<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|Interval arithmetic>

  The <verbatim|Interval> template implements interval arithmetic,

  <\quote-env>
    <\code>
      template\<less\>class C, int r \<gtr\> \ \ struct Interval;
    </code>
  </quote-env>

  The class <verbatim|Interval> is parameterised by

  <\itemize>
    <item>the type <verbatim|C> of the coefficients,

    <item>an <verbatim|int> <verbatim|r> corresponding to the rounding
    policies used, the possibles values are:

    <\itemize-minus>
      <item><verbatim|0> corresponding to an unsafe use of interval
      arithmetic,\ 

      <item><verbatim|1> safe arithmetic assuming downward rounding mode
      turned on,

      <item><verbatim|2> safe arithmetic assuming upward rounding mode turned
      on,

      <item><verbatim|><verbatim|3> context free safe arithmetic.
    </itemize-minus>
  </itemize>

  The default <verbatim|Interval\<less\>C\<gtr\>> corresponds to
  <verbatim|r=3>.

  <subsection|Example>

  <action|<with|mode|math|\<boxdot\>>|Interval.cc>

  <subsection|Implementation>

  See: <verbatim|synaps/arithm/Interval.h>\ 
</body>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|1.2|?>>
    <associate|auto-4|<tuple|1.3|?>>
    <associate|auto-5|<tuple|1.4|?>>
    <associate|auto-6|<tuple|1.2.2|?>>
    <associate|auto-7|<tuple|1.3|?>>
    <associate|auto-8|<tuple|1.4|?>>
    <associate|idx-1|<tuple|1.2.2|?>>
    <associate|toc-1|<tuple|1|?>>
    <associate|toc-2|<tuple|1.1|?>>
    <associate|toc-3|<tuple|1.2|?>>
    <associate|toc-4|<tuple|1.2.1|?>>
    <associate|toc-5|<tuple|1.2.2|?>>
    <associate|toc-6|<tuple|1.3|?>>
    <associate|toc-7|<tuple|1.4|?>>
    <associate|toc-8|<tuple|1.5|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Interval
      arithmetic> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Example
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Implementation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>
    </associate>
  </collection>
</auxiliary>