#ifndef SYNAPS_ARITHM_TRAITS_FIELDOF_H
#define SYNAPS_ARITHM_TRAITS_FIELDOF_H

#include <synaps/arithm/traits/sup.h>  
#include <complex>
__BEGIN_NAMESPACE_SYNAPS

namespace arithm {

  template<class X, class Y>
  struct fieldof_ { typedef type::null_t T; };
  

  template<>
  struct fieldof_<int, unsigned int> { typedef double T; };
  template<>
  struct fieldof_<unsigned int, int> { typedef double T; };
  template<>
  struct fieldof_<double,int> { typedef double T; };
  template<> 
  struct fieldof_<int,double> { typedef double T; };
  template<>
  struct fieldof_<double,unsigned int> { typedef double T; };
  template<> 
  struct fieldof_<unsigned int,double> { typedef double T; };
  

  template<class K, class X, class Y>
  struct kernel_fieldof { typedef typename K::rational T; };
  template<class K>
  struct kernel_fieldof< K, typename K::floating, typename K::ieee > 
  { typedef typename K::floating T; };
  template<class K>
  struct kernel_fieldof< K, typename K::ieee, typename K::floating > 
  { typedef typename K::floating T; };
  
  template<class X, class Y> struct kernel_fieldof<null_t,X,Y> { typedef null_t T; };

  /// x (in X) + y (in Y)  is subset of fieldof<X,Y>::T
  template<class X, class Y> 
  struct fieldof
  {
    typedef typename ucstref<X>::T                _X;
    typedef typename ucstref<Y>::T                _Y;
    typedef typename kernel_fieldof< typename kernelof<X>::T,_X,_Y>::T   KXY;
    typedef typename kernel_fieldof< typename kernelof<Y>::T,_Y,_X>::T   KYX;
    typedef typename type::sfirstnn< typename fieldof_<_X,_Y>::T, KXY, KYX, typename sup<X,Y>::T >::T T;
  };
  
  template<class X, class Y>
  struct fieldof_< std::complex<X>, std::complex<Y> > { typedef std::complex<typename fieldof<X,Y>::T > T; };
  template<class X>
  struct fieldof_< std::complex<X>, std::complex<X> > { typedef std::complex<X> T; };
}
__END_NAMESPACE_SYNAPS

#endif
