#ifndef SYNAPS_ARITHM_TRAITS_ISFLOATING_H
#define SYNAPS_ARITHM_TRAITS_ISFLOATING_H

#include <synaps/arithm/traits/kernelof.h>

__BEGIN_NAMESPACE_SYNAPS

namespace arithm {

  template<class X> struct isfloating_  { typedef false_t T; };

  template<> struct isfloating_<int> { typedef true_t T; };
  template<> struct isfloating_<long int> { typedef true_t T; };

  template<class K, class X>
  struct kernel_isfloating  { typedef false_t T; };
  template<class K>
  struct kernel_isfloating< K, typename K::floating >  { typedef true_t T; };
  
  template<class X> struct isfloating 
  {
    typedef typename ucstref <X>::T _X;
    typename kernel_isfloating< typename kernelof<_X>::T,_X>::T T;
  };

}
__END_NAMESPACE_SYNAPS

#endif
