#ifndef SYNAPS_ARITHM_TRAITS_ISINTEGER_H
#define SYNAPS_ARITHM_TRAITS_ISINTEGER_H

#include <synaps/arithm/traits/kernelof.h>

__BEGIN_NAMESPACE_SYNAPS

namespace arithm {

  template<class X> struct isinteger_  { typedef false_t T; };

  template<> struct isinteger_<int> { typedef true_t T; };
  template<> struct isinteger_<long int> { typedef true_t T; };

  template<class K, class X>
  struct kernel_isinteger  { typedef false_t T; };
  template<class K>
  struct kernel_isinteger< K, typename K::integer >  { typedef true_t T; };

  template<class X> struct isinteger 
  {
    typedef typename ucstref <X>::T _X;
    typename kernel_isinteger< typename kernelof<_X>::T,_X>::T T;
  };

}
__END_NAMESPACE_SYNAPS

#endif
