#ifndef SYNAPS_ARITHM_TRAITS_ISRING_H
#define SYNAPS_ARITHM_TRAITS_ISRING_H

#include <synaps/arithm/traits/kernelof.h>

__BEGIN_NAMESPACE_SYNAPS

namespace arithm {

  template<typename X>
  struct isring_ { typedef null_t T; };
  
  template<>
  struct isring_<int> { typedef true_t T; };
  template<>
  struct isring_<long int> { typedef true_t T; };
  template<>
  struct isring_<float> { typedef true_t T; };
  template<>
  struct isring_<double> { typedef true_t T; };
  template<>
  struct isring_<long double> { typedef true_t T; };
  
  template<typename K, typename X>
  struct kernel_isring { typedef true_t T; };
  template<typename X>
  struct kernel_isring<null_t,X> { typedef typename isring_<X>::T T; };

  template<typename X>
  struct isring
  {
    typedef  typename ucstref<X>::T   _X;
    typedef  typename kernel_isring< typename kernelof<_X>::T, _X >::T T;
  };
  
  
}

__END_NAMESPACE_SYNAPS

#endif
