#ifndef SYNAPS_ARITHM_TRAITS_STRUCTUREOF_H
#define SYNAPS_ARITHM_TRAITS_STRUCTUREOF_H

#include <synaps/init.h>
#include <synaps/base/type.h>

__BEGIN_NAMESPACE_SYNAPS

namespace arithm {
  
  namespace structure {
    
    struct scalar
    {
      struct floating;
      struct integer;
      struct rational;
      struct complex;
      struct interval;
    };
    
    struct vector;
    struct matrix;
    struct polynomial;

    struct dense;
    struct sparse;
    struct structured;
    struct univariate;
    struct multivariate;
    struct monomial;
    struct bernstein;
  };
  
  template<class X>
  struct scalar_type 
  {
  };
  
  template<class X> struct structureof_
  { 
    typedef structure::scalar T; 
  };
  
  template<class X> struct structureof { 
    typedef typename structureof_< typename ucstref<X>::T >::T T; 
  };
  //  template<> struct structureof_<double> { typedef structure::scalar T; };

  
  
  
};

__END_NAMESPACE_SYNAPS

#endif
