<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|Naming conventions and file structure>

  The functions defined in the library <verbatim|synaps> are available from
  the namespace <verbatim|SYNAPS>. Each file contains the following include
  directive:

  <\quote-env>
    <\code>
      #include \<less\>synaps/init.h\<gtr\>
    </code>
  </quote-env>

  where the macros <verbatim|__SYNAPS_BEGIN_NAMESPACE> and
  <verbatim|__SYNAPS_END_NAMESPACE> are defined. These macros appear around
  the definition of any function of the library, in order to enclose this
  definition in the namespace <verbatim|SYNAPS>.

  \;

  In order to use the functions and classes of the library, you can either
  use the directive

  <\quote-env>
    <\code>
      using namespace SYNAPS;
    </code>
  </quote-env>

  or \ define at the beginning of the main file the macro:

  <\quote-env>
    <\code>
      #define USING_NAMESPACE_SYNAPS 1
    </code>
  </quote-env>

  before including any other file of the library.

  \;

  <subsection|Types>

  Hereafter, we will use <verbatim|_t> to precise that we are defining a type
  name:

  <\quote-env>
    <\code>
      typedef a_class\<less\>double\<gtr\> adbl_t;
    </code>
  </quote-env>

  <subsection|Global functions and classes>

  The name of a global class of the namespace <verbatim|SYNAPS> starts with a
  upper case letter, whereas functions are with lower case letters:

  <\quote-env>
    <\code>
      solve(p, Aberth\<less\>RR\<gtr\>());
    </code>
  </quote-env>

  If the name is composite, we use several upper case letters:
  <verbatim|MatrDse>, <verbatim|DegLex>, ... The names of the <em|containers>
  are in lower case letters.

  <subsection|Modules>

  The name of a module is with upper case letters: <verbatim|MPOLDST>,
  <verbatim|VECTOR>, ...

  \;
</body>

<\initial>
  <\collection>
    <associate|language|french>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|1>>
    <associate|auto-2|<tuple|1.1|1>>
    <associate|auto-3|<tuple|1.2|1>>
    <associate|auto-4|<tuple|1.3|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Naming
      conventions and file structure> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Types
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Global functions and
      classes <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>Modules
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>
    </associate>
  </collection>
</auxiliary>