#ifndef SYNAPS_UTIL_RANGE_H
#define SYNAPS_UTIL_RANGE_H

#include <synaps/init.h>
#include <synaps/arithm/GENERIC.h>

__BEGIN_NAMESPACE_SYNAPS

struct Range
{
  unsigned int i1, i2;
  Range():i1(0),i2(0){}
  Range(const Range & r):i1(r.i1),i2(r.i2){}
  Range(unsigned int a, unsigned int b):i1(a),i2(b){}
};

struct Range2d
{
  unsigned int i1, i2, j1, j2;
  Range2d():i1(0),i2(0),j1(0),j2(0){}
  Range2d(const Range2d & r):i1(r.i1),i2(r.i2),j1(r.j1),j2(r.j2){}
  Range2d(unsigned int a, unsigned int b, unsigned int c, unsigned int d):i1(a),i2(b),j1(c),j2(d){}
  Range2d( const Range & a, const Range & b ) : i1(a.i1), i2(a.i2), j1(b.i1), j2(b.i2) {};
};

std::ostream & operator<<( std::ostream & , const Range & );
std::ostream & operator<<( std::ostream & , const Range2d & );


template<>
class OPTraits<Range> {
public:
  typedef Range const OP_node_ref;
};

template<>
class OPTraits<Range2d> {
public:
  typedef Range2d const OP_node_ref;
};

__END_NAMESPACE_SYNAPS

#endif // SYNAPS_UTIL_RANGE_H

