
#ifndef SYNAPS_UTIL_STRIDEITER_H
#define SYNAPS_UTIL_STRIDEITER_H

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

template <class T, class T_ref, class T_ptr, class T_stride>
class stride_iterator {
public:

  typedef T                              coef_t;
  typedef T_ref                          reference_t;
  typedef T_ptr                          pointer_t;
  typedef T_stride                       stride_t;
  typedef unsigned int                   index_t;

  typedef stride_iterator<coef_t,reference_t,pointer_t,stride_t>
                                         self_t;

  stride_iterator( pointer_t const ptr,  stride_t const stride)
    : my_rep(ptr), my_stride(stride), my_pos(0) {};

  self_t&
  operator++() { ++my_pos; my_rep += my_stride; return *this;}

  reference_t operator*() {return (this);}

  pointer_t operator->() {return my_rep;}

  bool operator!=( self_t const& rhs) { return my_rep != rhs.my_rep; }
  bool operator<=( self_t const& rhs) { return my_rep <= rhs.my_rep; }

  index_t
  pos() const { return my_pos;}

private:
  pointer_t my_rep;
  stride_t const my_stride;
};

__END_NAMESPACE_SYNAPS

#endif // SYNAPS_UTIL_STRIDEITER_H
