#ifndef SYNAPS_CONTAINER_TRAITS_H
#define SYNAPS_CONTAINER_TRAITS_H

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

namespace type
{
  template < class R, class X >
  struct instanceof { typedef null_t T; };  
  template < template<class> class R, class X, class Y>
  struct instanceof< R<X>, Y > { typedef R<Y> T; };
  template< template<class,int> class R, int N, class X, class Y>
  struct instanceof< R<X,N>, Y> { typedef R<Y,N> T; };
  template< template<class,unsigned> class R, unsigned N, class X, class Y>
  
  struct instanceof< R<X,N>, Y> { typedef R<Y,N> T; };
  // synaps view
  template< template<class,class> class V, class C, class R, class Y>
  struct instanceof< V<C,R>, Y > { typedef V<Y, typename instanceof<R,Y>::T > T; };
  
  template < class A, class B >
  struct sup_container { typedef A T; };

  template < class Container >
  struct value_type_{ typedef typename Container::value_type T; };
  template< template<class X> class R, class X >
  struct value_type_< R<X> >  { typedef X T; };
  template< typename C, unsigned N > struct value_type_< C[N] > { typedef C T;  };
  template< typename  C >  struct value_type_<C*> { typedef C T; };
  template< typename  C >  struct value_type_<const C*> { typedef C T; };
  template < class Container >
  struct value_type { typedef typename value_type_< typename ucstref<Container>::T >::T T; };
};

__END_NAMESPACE_SYNAPS

#endif
