#ifndef SYNAPS_BASE_TYPE_DEMANGLE_H
#define SYNAPS_BASE_TYPE_DEMANGLE_H

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

namespace type
{
  template<class X> inline
  const char * name() { 
    size_t len; 
    int status;
    return abi::__cxa_demangle( typeid(X).name(), 0, &len, &status );
  };
  
  template<class X> inline
  std::ostream& print( std::ostream& o )
  {
    size_t len; 
    int status;
    o << abi::__cxa_demangle( typeid(X).name(), 0, &len, &status );
    return o;
  };
  
  
  template<class X>
  struct TYPE {};
  template<class X>
  inline std::ostream & operator<<( std::ostream& o, const TYPE<X>& t )
  {
    return print<X>( o );
  };
};

__END_NAMESPACE_SYNAPS

#endif
