#ifndef SYNAPS_BASE_TYPE_LIST_H
#define SYNAPS_BASE_TYPE_LIST_H

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

namespace type {     

  /**
   * type list definition similar to the Typelist of Loki.
   **/

  /// type list node
  template<class A, class B> 
  struct tlist { typedef A car; typedef B cdr; };
  
  /** type map: defines a type of mapped type from a type list 
   *  example : A, B, C -> typename TypeFunctor<A>::T, typename TypeFunctor<B>::T, ...
   **/
  template< template<class> class TypeFunctor, class TypeList >
  struct tmap;
  template< template<class> class TypeFunctor, class Head, class Tail>
  struct tmap< TypeFunctor, tlist<Head,Tail> >
  {
    typedef tlist< typename TypeFunctor<Head>::T,
		   typename tmap< TypeFunctor, Tail >::T > T;
  };
  template< template<class> class TypeFunctor, class Head>
  struct tmap< TypeFunctor, tlist<Head,null_t> >
  {
    typedef tlist< typename TypeFunctor<Head>::T, null_t> T;
  };
  
  /// helper for type list definition
  template
  <
    typename T1  = null_t, typename T2  = null_t, typename T3  = null_t,
    typename T4  = null_t, typename T5  = null_t, typename T6  = null_t,
    typename T7  = null_t, typename T8  = null_t, typename T9  = null_t,
    typename T10 = null_t, typename T11 = null_t, typename T12 = null_t,
    typename T13 = null_t, typename T14 = null_t, typename T15 = null_t,
    typename T16 = null_t, typename T17 = null_t, typename T18 = null_t
    > 
  struct gentlist
  {
  private:
    typedef typename gentlist
    <
      T2 , T3 , T4 , 
      T5 , T6 , T7 , 
      T8 , T9 , T10, 
      T11, T12, T13,
      T14, T15, T16, 
      T17, T18 >
    ::T cdr;
    typedef T1 car;
  public:
    typedef tlist<car,cdr> T;
  };
  template< typename X>
  struct gentlist< X, null_t >
  {
    typedef tlist<X,null_t> T;
  };
  
  /// select the first non null type of a type-list.
  template < typename L >
  struct sfirstnnl { typedef L T; };
  template < typename car, typename cdr >
  struct sfirstnnl< tlist<car,cdr> > { typedef car T; };
  template < typename cdr > struct sfirstnnl< tlist< null_t, cdr > > 
  { typedef typename sfirstnnl< cdr >::T T; };
  template <> struct sfirstnnl< tlist<null_t, null_t> > { typedef null_t T; };
  
  template < 
    typename T1  = null_t, typename T2  = null_t, typename T3  = null_t,
    typename T4  = null_t, typename T5  = null_t, typename T6  = null_t,
    typename T7  = null_t, typename T8  = null_t, typename T9  = null_t,
    typename T10 = null_t, typename T11 = null_t, typename T12 = null_t,
    typename T13 = null_t, typename T14 = null_t, typename T15 = null_t,
    typename T16 = null_t, typename T17 = null_t, typename T18 = null_t
    >
  struct sfirstnn
  {
    typedef typename gentlist<T1,T2,T3,T4,T5,T6,T7,T8,T9,T10,T11,T12,T13,T14,T15,T16,T17,T18>::T L;
    typedef typename sfirstnnl<L>::T T;
  };

  /*
  template<class List> struct reverse;
  template<class List, class RList> struct reversal;
  template<class List> struct reversal<type::null_t,List> { typedef List T; };
  template<class car, class cdr, class List>
  struct reversal< tlist<car,cdr>, List > { typedef typename reversal<cdr, tlist<car,List> >::T T; };
  
  template<class car, class cdr>
  struct reverse< tlist<car,cdr> > 
  {
    typedef typename reversal< cdr  , tlist<car,type::null_t> >::T T;
  };
  */
};

__END_NAMESPACE_SYNAPS

#endif
