#ifndef SYNAPS_BASE_TYPE_TESTS_H
#define SYNAPS_BASE_TYPE_TESTS_H

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

namespace type 
{
  /// structure defining a positive answer
  struct true_t {};
  /// structure defining a negative answer
  struct false_t{};
  /// structure defining a the empty list
  struct null_t {};
  
  /// ask for type equality return T in { false_t, true_t } and V in {0,1}
  template <class X, class Y> 
  struct equal      
  { 
    enum { V = 1 };
    typedef false_t T;
  };

  template<class X>           
  struct equal<X,X> 
  {
    enum { V = 1 };
    typedef true_t T;
  };
  
  /// select a type based on condition X, X is assumed to be in { null_t, false_t, true_t }
  template<class X, class A, class B> 
  struct tselect                { typedef A T; };
  template<class A, class B>
  struct tselect<false_t, A, B> { typedef B T; };
  template<class A, class B>
  struct tselect<null_t,A, B> { typedef B T; };
  
  /// select a type base on condition V, V is assumed to be in { 0, 1 }
  template<int k, class A, class B>
  struct vselect                { typedef A T; };
  template<class A, class B>
  struct vselect<0,A,B>         { typedef B T; };
  
  template< typename X >  
  struct tnot 
  { 
    typedef false_t T;
  };
  
  template<> 
  struct tnot< false_t > { typedef true_t T; };
  template<>
  struct tnot< null_t > { typedef true_t T; };
  template<class X>
  struct is_ptr{ typedef typename equal<X,typename ptr<X>::T >::T T; };
}
__END_NAMESPACE_SYNAPS
  
#endif
