<TeXmacs|1.0.6>

<style|generic>

<\body>
  <section|How to build Synaps on MacOSX>

  This short HowTo explains how to get your environment ready to use Synaps
  on MacOSX.

  <subsection|Requirements>

  Many required packages are installed using
  <hlink|fink|http://fink.sourceforge.net/>. This HowTo supposes you have
  fink installed.

  There are two options to get the sources:

  <\itemize>
    <item>Download distribution tarball <hlink|here|http://gforge.inria.fr/frs/?group_id=93>.\ 

    <item>Checkout the source from our repository
    <hlink|here|http://gforge.inria.fr/scm/?group_id=93>.
  </itemize>

  To checkout the sources from the repository simply type:

  <\code>
    \<gtr\> svn checkout svn://scm.gforge.inria.fr/svn/synaps/main synaps
  </code>

  If you don't have svn installed, install it with:

  <\code>
    \<gtr\> sudo fink install svn-client
  </code>

  To build Synaps you will have to install the following libraries:

  <\itemize>
    <item>GMP (package): http://pdb.finkproject.org/pdb/package.php/gmp\ 

    <item>GMP (share libraries): http://pdb.finkproject.org/pdb/package.php/gmp-shlibs

    <item>GMPXX: http://pdb.finkproject.org/pdb/package.php/libgmpxx4-shlibs

    <item>Blas: http://developer.apple.com/hardwaredrivers/ve/vector_libraries.html

    <item>Lapack: http://developer.apple.com/hardwaredrivers/ve/vector_libraries.html

    <item>f2c: http://pdb.finkproject.org/pdb/package.php/f2c
  </itemize>

  You can install these libraries by typing:

  <\code>
    \<gtr\> sudo fink install gmp gmp-shlibs

    \<gtr\> sudo fink install gmpxx4-shlibs

    \<gtr\> sudo fink install f2c
  </code>

  \ Blas and Lapack are provided with the Apple Developer Tools within the
  vecLib framework.

  Synaps uses Autotools for compilation:

  <\code>
    \<gtr\> sudo fink install autoconf2.5 automake1.9 libtool
  </code>

  <subsection|Building Synaps>

  If you have download the distribution, type:

  <\code>
    \<gtr\> cd path/to/synaps

    \<gtr\> ./configure --with-gmp=/sw --with-gmpxx=/sw
    --with-blas="-framework vecLib" --with-lapack="-framework vecLib"
    FLIBS="-L/sw/lib -lf2c"

    \<gtr\> make
  </code>

  You can optionnally install Synaps by typing:

  <\code>
    \<gtr\> sudo make install
  </code>

  If you have checked out Synaps from the repository, type:

  <\code>
    \<gtr\> cd path/to/synaps

    \<gtr\> sh ./smake

    \<gtr\> ./configure --with-gmp=/sw --with-gmpxx=/sw
    --with-blas="-framework vecLib" --with-lapack="-framework vecLib"
    FLIBS="-L/sw/lib -lf2c"

    \<gtr\> make
  </code>

  That's it, Synaps is build. You will find:

  <\itemize>
    <item>libsynaps.a in /path/to/synaps/lib

    <item>libsisl.a in /path/to/synaps/lib

    <item>libmps.a in /path/to/synaps/lib

    <item>s++ in /path/to/synaps/bin
  </itemize>
</body>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|1.2|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|How
      to build Synaps on MacOSX> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|Requirements
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|Building Synaps
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>
    </associate>
  </collection>
</auxiliary>