<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|How to use the library>

  Once the library has been installed, a script \ <verbatim|s++> can be used
  as a compiler command, as follows:

  <\code>
    s++ \<less\>file\<gtr\>.cc
  </code>

  <subsection|Options of compilation>

  It will generate an executable file <verbatim|file.ex>, that can be run by
  typing <verbatim|./file.ex>. The options of the command s++ are optained by
  typing

  <\code>
    s++ -h\ 
  </code>

  Files can be compiled separately. Using the option <verbatim|-c> as
  follows:

  <\code>
    s++ -c file.cc\ 
  </code>

  which will produce a <verbatim|file.o>, which you will be able to link to
  another application. The file that you compile can be executed by

  <\code>
    s++ file.cc -run \ \ \ \ # Compile and run the file.ex\ 

    s++ file.cc -exe \ \ \ \ # Execute the file.ex
  </code>

  If you use options which are not mentionned in the previous list, they are
  passed directly to the <verbatim|C++> compiler.

  <\code>
    s++ file.cc -Wall -O6
  </code>

  This will pass the options <verbatim|-Wall> and <verbatim|-O6> to the
  <verbatim|C++> compiler.

  <subsection|Check the installation>

  In order to check the parameters of the installation, you can type
  <verbatim|s++ -v> which produces:

  <\code>
    VERSION = \<less\>time when you produce the s++ command\<gtr\>

    SOURCES = \<less\>source dir\<gtr\>

    INCDIR \ = -I\<less\>includedir\<gtr\> ...

    LIBDIR \ = -L\<less\>libdir\<gtr\>

    LIB \ \ \ \ = -llib1

    OPTION \ = \<less\>options of the compilation\<gtr\>

    OBJ \ \ \ \ = \<less\>list of object files\<gtr\>

    CXX \ \ \ \ = \<less\>compiler used\<gtr\>
  </code>

  \;
</body>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|1.2|?>>
    <associate|auto-4|<tuple|1.1.2|?>>
    <associate|auto-5|<tuple|1.3.1|?>>
    <associate|auto-6|<tuple|1.3.2|?>>
    <associate|auto-7|<tuple|1.4|?>>
    <associate|auto-8|<tuple|1.5|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>How
      to download and \ install the library>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>How to get it
      \ <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>How to configure it
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>How to use it
      \ <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|3fn>|1.3.1<space|2spc>Options of compilation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|3fn>|1.3.2<space|2spc>Check the installation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>
    </associate>
  </collection>
</auxiliary>