<TeXmacs|1.0.6>

<style|generic>

<\body>
  <section|The structure of the library>

  The library is divided into modules which share the following structure:

  <\code>
    \ module\ 

    \ \ \ \ \|-bin

    \ \ \ \ \|-doc

    \ \ \ \ \|-include

    \ \ \ \ \|-src

    \ \ \ \ \|-test

    \ \ \ \ \|-....
  </code>

  where the directory\ 

  <\itemize>
    <item><verbatim|bin> contains the commands which will be provided by the
    package (<verbatim|make>),

    <item><verbatim|doc> contains the documentation (<verbatim|.tm>) and
    examples files (<verbatim|.cc>) used in the test phase (<verbatim|make
    check>)

    <item><verbatim|include> contains the header files,

    <item><verbatim|src> contains the source file, which are compiled
    (<verbatim|make>),

    <item><verbatim|test> contains the test files (<verbatim|make check>).
  </itemize>

  Here is the list of modules

  <postscript|synaps-packages.ps||||||>

  <\itemize>
    <item><verbatim|base>: common and basic implementations shared by the
    other packages;

    <item><verbatim|arithm>: arithmetic, including extended arithmetic,
    interval arithmetic, modular numbers, relation between number types;

    <item><verbatim|linalg>: linear algebra, including tools for vectors,
    dense, sparse and structured matrices;

    <item><verbatim|upol>: univariate polynomials, including resultant
    constructions, Sturm sequences, gcd;

    <item><verbatim|mpol>: multivariate polynomials, including resultant
    constructions;

    <item><verbatim|usolve>: solving univariate equations and the
    manipulation of algebraic numbers;

    <item><verbatim|shape>: representation of algebraic geometric objects;

    <item><verbatim|topology>: \ tools for computing the topology of
    algebraic curves and surfaces
  </itemize>
</body>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|The
      structure of the library> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>