#include <synaps/init.h>
#ifdef SYNAPS_WITH_GMP
#include <iostream>
#include "synaps/arithm/gmp.h"
#include "synaps/mpol/MPol.h"       // multivariate polynomials

typedef MPol<QQ>    mpol_t;

mpol_t reduce(const mpol_t & p , const mpol_t & q)
{
  mpol_t r(p);
  mpol_t::monom_t m0=*q.begin();
  mpol_t::monom_t mr=(*r.begin())/m0;
  
  while(mr !=0)
    {
      r-=q*mr;
      mr=(*r.begin())/m0;
    }
  return r;
}

int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;
  mpol_t p("2*x0^3*x1-34*x0^2*x2+23;"),q("3*x0^2-1;"); 
  cout<<p<<endl<<q<<endl;
  cout <<reduce(p,q)<<endl;

}
#else
int main(int argc, char** argv) {}
#endif
