#include <synaps/arithm/gmp.h>
#include <synaps/mpol/MPol.h>
#include <synaps/msolve/sbdslv.h>

typedef MPol<double> mpol_t;

int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;
  std::list<mpol_t> E;
  E.push_back(mpol_t("x^2+y^2+z^2-1"));
  E.push_back(mpol_t("x^2+2*x*y-y^2+z^2-1"));
  E.push_back(mpol_t("3*x^2-x*y+4*y^2+z^2-2*x-3*y+z-2"));

  
  VectDse<double> domain(6,"-1 1.1 -1 1.1 -1 1.1");

  cout<<solve(E,SBDSLV<double,SBDSLV_RDRDL>(1e-6),domain)<<endl;

  // iterations  = 68
  // subdivisions = 4
  // [ 5.72114e-08 4.53431e-08 1 ]
  // [ -0.576379 -2.21964e-10 -0.817183 ]
  // [ -0.305627 -0.305627 -0.901767 ]
  
}
