<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|Dense matrices>

  <subsection|Introduction>

  Dense matrices are two-dimensional arrays in which all the coefficients are
  stored (even if they are zero). They provide classical arithmetic
  operations such as addition, subtraction, multiplication by scalars,
  vectors, matrices, ...

  <\quote-env>
    <\code>
      template\<less\>class C, class R= linalg::rep2d\<less\>C\<gtr\> \<gtr\>
      \ \ struct MatrDse;
    </code>
  </quote-env>

  The class <verbatim|MatrDse> is parameterised by

  <\itemize>
    <item>the type <verbatim|C> of the coefficients,

    <item>the internal representation <verbatim|R>. The default value is
    <verbatim|linalg::rep2d\<less\>C\<gtr\>>.
  </itemize>

  <subsection|Containers>

  Here are containers, which can be used for th einterneal representation
  <verbatim|R>:

  <\itemize-dot>
    <item><verbatim|linalg::rep2d\<less\>C\<gtr\>>: this is the default
    container, in which the matrix are stored by columns , in an array of
    coefficients.

    <item><verbatim|lapack::rep2d\<less\>C\<gtr\>>: for the \ allows use of
    the routines of the <samp|Lapack> library.
  </itemize-dot>

  <subsection|Example>

  File: <verbatim|MatrDse.cc>

  <subsection|Implementation>

  See: <verbatim|synaps/linalg/MatrDse.h>

  \;
</body>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|1.2|?>>
    <associate|auto-4|<tuple|1.3|?>>
    <associate|auto-5|<tuple|1.4|?>>
    <associate|auto-6|<tuple|1.2.2|?>>
    <associate|auto-7|<tuple|1.3|?>>
    <associate|auto-8|<tuple|1.4|?>>
    <associate|idx-1|<tuple|1.2.2|?>>
    <associate|toc-1|<tuple|1|?>>
    <associate|toc-2|<tuple|1.1|?>>
    <associate|toc-3|<tuple|1.2|?>>
    <associate|toc-4|<tuple|1.2.1|?>>
    <associate|toc-5|<tuple|1.2.2|?>>
    <associate|toc-6|<tuple|1.3|?>>
    <associate|toc-7|<tuple|1.4|?>>
    <associate|toc-8|<tuple|1.5|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Dense
      matrices> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Introduction
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Containers
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>Example
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|1.5fn>|1.4<space|2spc>Implementation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>
    </associate>
  </collection>
</auxiliary>