
__BEGIN_NAMESPACE_SYNAPS

namespace arithm
{
  template<class C, class R> // MatrDse<C,R> is exact as soon as C is exact
  struct isexact_< MatrDse<C,R> > { typedef typename isexact< C >::T T; };
  template<class C, class R> // MatrDse<C,R> define a ring
  struct isring_< MatrDse<C,R> > { typedef true_t T; };
  
  template<class Ca, class Ra, class Cb, class Rb > // result of ring operations over MatrDse
  struct ringof_< MatrDse<Ca,Ra>, MatrDse<Cb,Rb>  >  { 
    typedef typename ringof<Ca,Cb>::T C;            // 
    typedef typename instanceof<Ra,C>::T RaC;
    typedef typename instanceof<Rb,C>::T RbC;
    typedef typename sup_container<RaC,RbC>::T      R;
    typedef MatrDse<C,R>                            T;
  };
  
  template<class C, class R> struct structureof< MatrDse<C,R> > { typedef structure::matrix T; };
  

}

#define head template<class Ca, class Ra, class Cb, class Rb>
#define parm0 MatrDse<Ca,Ra>
#define parm1 MatrDse<Cb,Rb>
declare_binary_operator(head,parm0,parm1,_add_,operator+);
declare_binary_operator(head,parm0,parm1,_sub_,operator-);
declare_binary_operator(head,parm0,parm1,_mul_,operator*);
#undef head
#undef parm0
#undef parm1
#define head  template<class Ca,class Ra>
#define parm0 MatrDse<Ca,Ra>
#define parm1 typename MatrDse<Ca,Ra>::value_type
declare_binary_operator(head,parm0,parm1,_mul_,operator*);
declare_binary_operator(head,parm1,parm0,_mul_,operator*);
declare_binary_operator(head,parm0,parm1,_div_,operator/);
declare_binary_operator(head,parm1,parm0,_div_,operator/);
#undef parm1
#undef  head
#define head template<class Ca,class Ra,class K>
#define parm1 typename K::integer
declare_binary_operator(head,parm0,parm1,_mul_,operator*);
declare_binary_operator(head,parm1,parm0,_mul_,operator*);
declare_binary_operator(head,parm0,parm1,_div_,operator/);
declare_binary_operator(head,parm1,parm0,_div_,operator/);
#undef parm1
#undef  head
#define head template<class Ca,class Ra,class K>
#define parm1 typename K::floating
declare_binary_operator(head,parm0,parm1,_mul_,operator*);
declare_binary_operator(head,parm1,parm0,_mul_,operator*);
declare_binary_operator(head,parm0,parm1,_div_,operator/);
declare_binary_operator(head,parm1,parm0,_div_,operator/);
#undef parm1
#undef  head
#define head template<class Ca,class Ra,class K>
#define parm1 typename K::rational
declare_binary_operator(head,parm0,parm1,_mul_,operator*);
declare_binary_operator(head,parm1,parm0,_mul_,operator*);
declare_binary_operator(head,parm0,parm1,_div_,operator/);
declare_binary_operator(head,parm1,parm0,_div_,operator/);
#undef parm1
#undef head
#define head template<class Ca, class Ra, class Cb, class Rb>
#define parm1 VectDse<Cb,Rb>
declare_binary_operator(head,parm0,parm1,_mul_,operator*);
#undef head
#undef parm0
#undef parm1
#define head template<class C, class R>
#define parm0 MatrDse<C,R>
declare_binary_operator(head,parm0,Range2d,linalg::_submatrix_,submatrix);
#undef head
#undef parm0
#define head template<class C, class R>
#define parm0 MatrDse<C,R>
//declare_binary_operator(head,parm0,int,linalg::_row_,row);
//declare_binary_operator(head,parm0,int,linalg::_col_,col);
declare_binary_operator(head,parm0,Range,linalg::_row_,row);
declare_binary_operator(head,parm0,Range,linalg::_col_,col);
#undef head
#undef parm0

__END_NAMESPACE_SYNAPS
