#include"dgstrf.c"
#include"convert.cc"

__BEGIN_NAMESPACE_SYNAPS

namespace sparse {
void inverse(int* &pr,int n)
{
  int *tmp=(int*)malloc(sizeof(int)*n);
  for(int i=0;i<n;i++)
    tmp[pr[i]]=i;
  free(pr);
  pr=tmp;
}

template<typename T>
void LUdecomp(rep2d<T> &m,rep2d<T> *L,rep2d<T> *U
	      ,int **pr,int **pc)
{
  //cout<<"coucouc"<<endl;
 static int flag=1;
  SuperMatrix<T> tmpM,tmpL,tmpU,AC;
  T diag_piv_thres=1;
  int * etree=(int*)malloc(sizeof(int)*(m.ncol));
  int *perm_c=(int*)malloc(sizeof(int)*m.ncol);
  int *perm_r=(int*)malloc(sizeof(int)*m.nrow);
  static int info;
  static char refact;
  static int relax=sp_ienv(2);
  static int panel_size=sp_ienv(1);
  int lwork=0;
  refact='N';
  if (flag)
    {
      flag=0;
      StatInit(panel_size,relax);
    }
  dCreate_CompCol_Matrix(&tmpM, m.nrow, m.ncol, m.nnz,
			 (T*)m.nzval, m.rowind, m.colptr, NC, Pht_D, GE);
  get_perm_c(0,&tmpM,perm_c);
  sp_preorder(&refact,&tmpM,perm_c,etree,&AC);
    dgstrf(&refact,&AC,diag_piv_thres,0,relax,panel_size,
	 etree,NULL,lwork,perm_r,perm_c,&tmpL,&tmpU,&info);
  //if (info!=0) {cerr<<"dgstrf failed info "<<*info<<endl; /*abort();*/}
  *pr=perm_r;*pc=perm_c;
    LUConverttoNC(tmpM,tmpL,tmpU);
    destroystore(AC);
  m.destroystore();
  free(tmpM.Store);
  m.rowind=((NCformat*)(tmpU.Store))->rowind;
  m.nzval=((NCformat*)(tmpU.Store))->nzval;
  m.colptr=((NCformat*)(tmpU.Store))->colptr;
  m.nnz=((NCformat*)(tmpU.Store))->nnz;
  free(tmpU.Store);
  L->rowind=((NCformat*)(tmpL.Store))->rowind;
  L->nzval=((NCformat*)(tmpL.Store))->nzval;
  L->colptr=((NCformat*)(tmpL.Store))->colptr;
  L->nrow=tmpL.nrow;
  L->ncol=tmpL.ncol;
  L->nnz=((NCformat*)(tmpL.Store))->nnz;
  free(tmpL.Store);
  free(etree);
  inverse(*pr,m.nrow);
  inverse(*pc,m.ncol);
  return;
}


template<typename R> 
R decomp(LU, rep2d<R> & A)
{
  rep2d<R> *L,*U;
  int *pr, *pc;
  LUdecomp(A,L,U,&pr,&pc);
  L->destroystore();
  U->destroystore();
  free(L);
  free(U);
  free(pr);
  free(pc);
  return 0;
}

template<typename R> 
R decomp(LU, rep2d<R> & A, rep2d<R> & L)
{
  rep2d<R> *U;
  int *pr, *pc;
  LUdecomp(A,&L,U,&pr,&pc);
  U->destroystore();
  free(U);
  free(pr);
  free(pc);
  return 0;
}


template<typename R> 
R decomp(LU, rep2d<R> & A, rep2d<R> & L, rep2d<R> & U)
{
  int *pr, *pc;
  LUdecomp(A,&L,&U,&pr,&pc);
  free(pr);
  free(pc);
  return 0;
}
}

__END_NAMESPACE_SYNAPS


