#define USING_NAMESPACE_SYNAPS 1

#include "synaps/linalg/toeplitz.h"
#include "synaps/linalg/hankel.h"
#include "synaps/linalg/MatrStr.h"


using std::cout;
using std::cin;
using std::endl;

typedef VectDse<double> VECT;
typedef MatrStr<linalg::toeplitz<double> > MAT; 
    //Definition of Toeplitz matrices

int main(int argc, char** argv) {
  using namespace std;

  double v[]={1,2,1,1,3,4,2,2,5,5,5,5,-2, 1,2,3,1, -2.8,-2.4,1,.2,5.8};
  MAT A(4,4,v), B(A);
  B.transpose();

  cout<<"A  := "<<A<<", B   = "<<B<<endl;
  MAT C;
//   C= A+B; cout<<C<<endl;
  C= A-B; cout<<C<<endl;
  //  C= A*2; cout<<C<<endl;  

  VECT V(v+1,v+5); cout<<V<<endl;

  //Multiplication using FFT.
  VECT W(A*V);     cout<<"W(A*V)   = "<<W<<endl;

  //Submatrices
  W = col(A,1);  cout<<W<<endl;
  W = row(A,2);  cout<<W<<endl;

  //  B = A(Range(1,3),Range(1,3));  cout<<"A(1..3,1..3) = "<<B <<endl;

  //  B = row(A,Range(1,2));  cout<<B<<endl;
  //  B = col(A,Range(1,2));  cout<<B<<endl;
  return 0;
};

