#define USING_NAMESPACE_SYNAPS 1

#include <cassert>
#include "synaps/mpol.h"
#include "synaps/linalg.h"
#include "synaps/bignum.h"
//#include "synaps/inout/maple.h"
#include "synaps/base/Clock.h"

#ifdef SYNAPS_WITH_GMP

using std::cout;
using std::cin;
using std::endl;


typedef VectDse<ZZ> VECT;
typedef MatrDse<ZZ> MAT;
#endif //SYNAPS_WITH_GMP

int main(int argc, char** argv) {
#ifdef SYNAPS_WITH_GMP
  MAT A(3, 3, "1 2 3 4 5 6 7 8 9", ByRow());
  MAT B;
  ZZ dt;

  cout <<"Matrix "<<A.nbrow()<<"x"<<A.nbcol()<<endl;
  cout << A;
  Clock c;
  c.start();
  B = Triang<Bareiss>(A);
  cout <<"Bareiss(A)   "<<c.time()<<" s"<<endl;
  cout << B;
  cout << B(2,2) << endl;
  assert(B(2,2) == 0);
  c.start();
  dt = Det(A);
  cout <<"Det        = "<< dt <<endl;
  cout <<c.time()<<" s"<<endl;
  assert(dt == 0);
  return 0;
#else 
  std::cout <<"  Gmp is not connected"<<std::endl;
  return(77);
#endif //SYNAPS_WITH_GMP
};
