<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|Dense multivariate polynomials> <index|Multivariate polynomial>\ 

  The dense multivariate polynomials

  <\quote-env>
    <\code>
      template\<less\>class C,\ 

      \ \ \ \ \ \ \ \ \ class R = mpoldse::monomial\<less\>C\<gtr\> \<gtr\>\ 

      struct MPolDse\<less\>C,R\<gtr\>;
    </code>
  </quote-env>

  are parameterised by

  <\itemize>
    <item>the type of coefficients <verbatim|C>,

    <item>the internal representation of the polynomials <verbatim|R>. The
    default is monomial.
  </itemize>

  <subsection|Containers for multivariate polynomials>

  The representation <verbatim|R> for this class could be
  <with|font-family|tt|mpoldse::monomial> or
  <with|font-family|tt|mpoldse::bernstein>.

  See: <verbatim|mpol/mpoldse/monomial.h>,
  <verbatim|mpol/mpoldse/bernstein.h>

  <subsection|Example>

  File: <verbatim|MPolDse.cc>

  <subsection|Implementation>

  <\itemize>
    <item>The class is defined in <verbatim|synaps/mpol/MPolDse.h>.

    <item>The corresponding module <verbatim|MPOLDSE> is defined in
    <verbatim|synaps/mpol/MPOLDSE.m>.
  </itemize>
</body>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-2|<tuple|1|?>>
    <associate|auto-3|<tuple|1.1|?>>
    <associate|auto-4|<tuple|1.2|?>>
    <associate|auto-5|<tuple|1.3|?>>
    <associate|auto-6|<tuple|1.4|?>>
    <associate|auto-7|<tuple|1.5|?>>
    <associate|auto-8|<tuple|1.6|?>>
    <associate|idx-1|<tuple|1|?>>
    <associate|toc-1|<tuple|1|?>>
    <associate|toc-2|<tuple|1.1|?>>
    <associate|toc-3|<tuple|1.2|?>>
    <associate|toc-4|<tuple|1.3|?>>
    <associate|toc-5|<tuple|1.4|?>>
    <associate|toc-6|<tuple|1.5|?>>
    <associate|toc-7|<tuple|1.6|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|idx>
      <tuple|<tuple|Multivariate polynomial>|<pageref|auto-2>>
    </associate>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Dense
      multivariate polynomials> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Containers for multivariate
      polynomials <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Example
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>Implementation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>
    </associate>
  </collection>
</auxiliary>