#ifndef SYNAPS_MPOL_RS_H
#define SYNAPS_MPOL_RS_H

#include <synaps/init.h>

extern "C" {
 /*#include "synaps/usp_bz.h"*/
#include "synaps/io_interf_rs.h"
#include "synaps/io_ascii.h"
extern void parse_vars_ascii(void);
extern void reordonne_groebner(void);
extern void bz_bus_out(BUS, bz_const);
extern void send_Groebner(BUS,list_smp_bz_const);
extern void get_Groebner(BUS,list_smp_bz_ref,RS_I32 *,float *);
}


__BEGIN_NAMESPACE_SYNAPS

#define dup_bz_elt(a,i) vect_bz_elt(vect_bz_rep2t(a->rep),i)

// void POL_MP_INT_2_dup_bz(POL & p,dup_bz_ref rs_p)
// {
// 	unsigned int i;
// 	dup_bz_init_d(rs_p,p.degree()+1);

// 	for (i=0;i<p.degree()+1;i++){
// 	  /*	  (rs_p->rep).data=p.rep.tab_;*/
	  
// 	    mpz_set(&(dup_bz_elt(rs_p,i)[0]),&((p[i]).z)); 
// 	} 
// }

BUS init_bus(char * machine,char *server,char *gbhome)
{
  BUS RS=NULL;
  bz init_bz;
  bz_init_str(init_bz,"21345817372864405881847059188222722561");
  RS=(BUS)malloc(sizeof(BUS_REP));
  RS->__out=(String)malloc(GB_BUFF_SIZE);
  RS->__in=(String)malloc(GB_BUFF_SIZE);
  RS->hostName=machine;
  RS->algoName=server;
  RS->prot=(DYN_PROT)malloc(sizeof(DYN_PROT_REP));
  C__initProtocol(RS->prot);
  C__initProtocol_BI(RS->prot,(C__int *)(init_bz->_mp_d),abs(init_bz->_mp_size));      
  C__open(RS,gbhome,"","");
  return(RS);
  
}

void send_vars_u(BUS RS,char *v)
{
  int i=1;
  send_n(RS,(char*)(&i),4,4);
  C__sendString(RS,v);
  C__flush(RS);
}

void send_up(BUS RS,dup_bz_ref p)
{
  unsigned int i=1,c=0;
  C__sendMessages(RS,FGBRS_INIT);
  C__sendMessages(RS,FGBRS_INPUT);
  C__sendMessages(RS,FGBRS_VARS);
  send_vars_u(RS,"x");
  C__sendMessages(RS,FGBRS_INPUT);
  C__flush(RS);
  C__sendMessages(RS,FGBRS_PROPERTIES);
  C__flush(RS);
  C__sendMessages(RS,FGBRS_PROP_UP);
  C__flush(RS);
  C__sendMessages(RS,FGBRS_INPUT);
  C__flush(RS);
  C__sendMessages(RS,FGBRS_LIST);
  C__flush(RS);

  send_n(RS,(char*)(&i),4,4);  
  for(i=0;i<(p->rep).dim;i++) {
    if (RS_NOT(bz_isNull(dup_bz_elt(p,i)))) c++;
  }
  fprintf(stderr,"debut liste data\n");
  
  fflush(stderr);
  
  send_n(RS,(char*)(&c),4,4);
  for(i=0;i<p->rep.dim;i++) {
    if (RS_NOT(bz_isNull(dup_bz_elt(p,i)))) {

      fprintf(stderr,"@");
      fflush(stderr);

      send_n(RS,(char *)(&i),4,4);

      fprintf(stderr,"#");
      fflush(stderr);

      bz_bus_out(RS,dup_bz_elt(p,i));
    }
  }
  C__flush(RS);
}

// unsigned int cmd_run_isoleuni(BUS RS,int prec,list_rn_bz_ref lresn)
// {
//   unsigned int res=0;
//   C__sendMessages(RS,FGBRS_INPUT);
//   C__sendMessages(RS,RS_PARAM);
//   C__sendMessages(RS,RS_PARAM_PRECISOL);
//   send_n(RS,(char*) (&prec),sizeof(int),sizeof(int));
//   C__flush(RS);  
//   C__sendMessages(RS,FGBRS_INPUT);
//   C__sendMessages(RS,RS_CMD);
//   C__sendMessages(RS,RS_CMD_ISOLEUNI);
//   C__sendMessages(RS,FGBRS_RUN);
//   C__flush(RS);
//   C__sendMessages(RS,FGBRS_DIRECT_OUTPUT);
//   C__sendMessages(RS,FGBRS_PROP_INTERVAL);
//   C__flush(RS);
//   list_rn_bz_init(lresn);
//   list_rn_bz_bus_in(RS,lresn);
//   return(lresn->nb);
// }

/*
int main(int argc, char** argv) {

  BUS RS=NULL;
  list_rn_bz res_usp;
  dup_bz rs_up;
  int n=10;
  POL a(n);
  dup_bz_init(rs_up);
  
  for(int i=0;i<n;i+=2) { a[i] = (long int)i+1;  }
  for(int i=1;i<n;i+=2) { a[i] = (long int)-(i+1);  }
  
  cout <<a <<endl;
  
  POL_MP_INT_2_dup_bz(a,rs_up);
  
  RS=init_bus(argv[1],"serveur_rs -server","/u/molotova/0/galaad/mourrain/Fabrice/RSDevelop/Compilation");
  
  send_up(RS,rs_up);
  list_rn_bz_init(res_usp);
  cout << " Resultat :" << cmd_run_isoleuni(RS,128,res_usp) << "\n";
  list_rn_bz_out(res_usp,stderr);
}
*/

__END_NAMESPACE_SYNAPS

#endif // SYNAPS_MPOL_RS_H

