/*******************************************************************
 *   This file is part of the source code of the SYNAPS kernel.
 *   Author(s): B. Mourrain, GALAAD, INRIA
 *   $Id: $
 ********************************************************************/
#ifndef synaps_mpol_Variables_H
#define synaps_mpol_Variables_H
//===================================================================
#include <synaps/init.h>
#include <string>
#include <sstream>
#include <map>
//===================================================================
__BEGIN_NAMESPACE_SYNAPS
//===================================================================
struct Variables 
{

  int                  _nbvar;
  std::map<std::string,int> _index_of_var;
  std::map<int,std::string> _var_of_index;
  
  Variables():_nbvar(0) {}

  /// Construction the list of variables from a string of the form "a b c ..."
  Variables(const char* s) {*this=s;}
  /// Assign the variable of index \c i to be \c s
  std::string& let(int i, const std::string& s);
  /// Return the variable of index \c i.
  std::string  operator[](int i);
  /// Return the variable of index \c i.
  std::string  operator[](int i) const;
  /// Return the index of the variable \c s.
  int operator[](const std::string& s);
  /// Assign a set of variables from a string of the form "a b c ..."
  Variables& operator=(const char* s);

  int nbvar() const {return _nbvar;}

  static Variables default_;

};
__END_NAMESPACE_SYNAPS
#endif // synaps_mpol_Variables_H
