/*********************************************************************
*      This file is part of the source code of SYNAPS kernel.        *
*   Author(s): B. Mourrain, GALAAD, INRIA                            *
**********************************************************************
History:
$Id: MPol_fct.h,v 1.1 2005/07/11 11:17:56 mourrain Exp $
**********************************************************************/
#ifndef SYNAPS_MPOL_MPOL_FCT_H
#define SYNAPS_MPOL_MPOL_FCT_H

#include <synaps/init.h>
#include <synaps/mpol/MPOLDST.m>
#include <synaps/arithm/binomial.h>

__BEGIN_NAMESPACE_SYNAPS
//--------------------------------------------------------------------
template <class C, class O, class R> inline
int nbcoef (const MPol<C,O,R> & P) {
	int nc = 0;
	for (typename MPol<C,O,R>::const_iterator p = P.begin();
	     p != P.end(); ++p)
	  nc++;
	return nc;
}
//--------------------------------------------------------------------
template <class C, class O, class R> inline
MPol<C,O,R> Coeff(const MPol<C,O,R> & P, int i) {
   MPol<C,O,R> res;
   for (typename MPol<C,O,R>::const_iterator j = P.begin(); j != P.end(); ++j)
      if ((*j)[i])
         res += *j;
   return res;
}
//----------------------------------------------------------------------
template <class C, class O, class R> inline
MPol<C,O,R> Coeff(const MPol<C,O,R> & P, int i, int d)
{
	MPol<C,O,R> res;
	for (typename MPol<C,O,R>::const_iterator j = P.begin();
	     j != P.end(); ++j)
		if ((*j)[i] == d) {
			typename MPol<C,O,R>::monom_t aux(*j);
			aux.setdegree(i,0);
			res += aux;
		}
	return res;
}
__END_NAMESPACE_SYNAPS
//----------------------------------------------------------------------
#endif // SYNAPS_MPOL_MPOL_FCT_H


