#ifndef SYNAPS_MPOLDSE_BERNSTEIN_H
#define SYNAPS_MPOLDSE_BERNSTEIN_H

#include <synaps/init.h>
#include "monomial.h"

__BEGIN_NAMESPACE_SYNAPS

namespace mpoldse
{
  template<class C>
  struct bernstein : monomial<C>
  {
    typedef monomial<C>   base_type;
    typedef typename base_type::value_type  value_type;
    typedef typename base_type::vector_type vector_type;
    typedef typename base_type::iterator    iterator;
    typedef typename base_type::const_iterator const_iterator;
    typedef typename base_type::size_type size_type;
    bernstein( const C& x = 0 );
    template<class X, class O, class R> 
    bernstein( const MPol<X,O,R>& mpol ):base_type(mpol) 
    {
      MPOLDSE::convertm2b(*this);
    };
    
    bernstein( const eenv & e);
    bernstein( const eenv& e, const C& c );
    bernstein( int nvr, const int * szs, const int * vrs = 0 );
    bernstein& operator=( const C& x );
    C& operator[]( int i ) { return this->data[i]; };
    const C& operator[]( int i ) const { return this->data[i]; };
    bool operator==( const C& c ) const { return base_type::esz() == 1 && base_type::data[0] == c; };
    bool operator==( const bernstein& mp ) const;
  };
  
};


__END_NAMESPACE_SYNAPS

#include "bernstein.C"

#endif /* SYNAPS_MPOLDSE_BERNSTEIN_H */
