/*********************************************************************
*      This file is part of the source code of SYNAPS kernel.        *
*      Author(s): B. Mourrain, GALAAD, INRIA                         *
**********************************************************************
$Id: sequence_mon.h,v 1.1 2005/07/11 11:17:56 mourrain Exp $
**********************************************************************/
#ifndef SYNAPS_MPOL_LISTMONOM_H
#define SYNAPS_MPOL_LISTMONOM_H

#include <list>
#include <vector>
#include <synaps/init.h>
#include <synaps/arithm/GENERIC.h>


__BEGIN_NAMESPACE_SYNAPS

//----------------------------------------------------------------------------
// Representation des polynomes par des listes tries par monomes decroissants.
//----------------------------------------------------------------------------
// template <class M>  inline
// bool IsNull (const list<M> & l) {
//   if (l.empty()) return true;
//   else return (IsNull((l.begin()->GetCoeff())));
// }

// //template <class M> vector;
// template <class M>  inline
// bool IsNull (const vector<M> & l) {
//   if (l.empty()) return true;
//   else return (IsNull((l.begin()->GetCoeff())));
// }

// template <class M>  inline
// bool operator == (const list<M > & l, ZERO z ) {
//   if (l.empty()) return true;
//   else return (IsNull((l.begin()->GetCoeff())));
// }
//template <class R,class S> inline
//bool IsNull (const list<MPol<R,S> > & l) {
//   if (l.empty()) return true;
//   else return (IsNull((l.begin()->GetCoeff())));
// }
//{ return (l.empty() || (IsNull((l.begin()->GetCoeff()))));}

// template <class M> inline
// void build (list<M > & p, const M & m)       { p.push_back(m); }

// template<class T> inline 
// void copy  (T & p, const T & q) 
// {
//   if (&p==&q) return;
//   p.erase(p.begin(),p.end());
//   typename T::const_iterator iter;
//   for(iter=q.begin();iter!=q.end();iter++)
//     p.push_back(*iter);
// }
//p = r; }

template<class R> inline
typename R::iterator insert (R & p, 
			     typename R::iterator i, 
			     const typename R::value_type & m) 
{
  p.insert(i,m); return p.begin();
}

template<class M> inline
typename list<M>::iterator insert (list<M> & p, 
			     typename list<M>::iterator i, 
			     const M & m) 
{
  p.insert(i,m); return i;
}
template <class R, class O>
typename R::iterator addition (R & p, 
			       typename R::iterator i, 
			       const typename R::value_type & m) {
  
  //  typename R::iterator it;
  if (p.empty())
    {
      p.push_back(m);
      return p.begin();
    }
  for (; i != p.end(); i++)
    {
      if (O::less(*i,m)) // *i plus petit que m on insere
	{
	  // Inserting a new monomial
	  p.insert(i,m);//swap((*--i),(*m));
	  i=find(p.begin(),p.end(),m);return i;
	  //return insert(p,i,m);
	}
      else if (O::less(m, *i)) ;
        // *i plus grand que m on incremente
      else                       
	// m et *i sont comparables on ajoute les monomes
	{
	  *i += m;
	  if (i->GetCoeff()==0) {
	    typename R::iterator aux = i++;
	    i=p.erase(aux);
	  }
	  return i;
	}
    }
  
  // The for loop reaches its end;
  p.push_back(m);i=p.end();
  return (--i); //xxx p.begin();
}

__END_NAMESPACE_SYNAPS

#endif // SYNAPS_MPOL_LISTMONOM_H

