#define USING_NAMESPACE_SYNAPS 1
#include "synaps/mpol/MPol.h"

using std::cout;
using std::cin;
using std::endl;


typedef MPol<double> mpol_t;

int main (int argc, char**argv) 
{
   mpol_t p("-9*x2^2*x1-3*x0*x1+1");
   cout <<"p: "<<p<<endl;
   assert(diff(p,"x0")==diff(p,(unsigned)0));
   assert(diff(p,"x1")==diff(p,(unsigned)1));

   Variables::default_[0]="u";
   Variables::default_[1]="v";

   mpol_t r0("u^2*x2-v");
   cout <<r0<<endl;
   mpol_t r1("x0^2*x2-x1");
   cout <<r1<<endl;
   assert(r0==r1);
   
   mpol_t q("-9*x*y+z^2*x");
   cout <<"q: "<<q<<endl;
   //   assert(diff(q,"x0")==diff(q,"x"));
   unsigned i=Variables::default_["x"];

   assert(diff(q,i)==diff(q,"x"));

   i = Variables::default_["y"];
   cout <<"Var "<<i<<": "<<Variables::default_[i]<<endl;
   cout <<"Var 9: "<<Variables::default_[9]<<endl;

}
