#define USING_NAMESPACE_SYNAPS 1
#include "synaps/mpol/elim.h"
#include "synaps/mpol/approximate.h"

using std::cout;
using std::cin;
using std::endl;

typedef double coeff_t;
typedef MPol<coeff_t> mpol_t;
typedef std::vector<mpol_t> ListPol;

/**
  \param : S name of the file contained the polynomials
**/
int main(int argc, char** argv){

  ListPol h;
  h.push_back(mpol_t("1"));
  h.push_back(mpol_t("3*x0^2*x1+3*x1-x1^3"));
  h.push_back(mpol_t("3*x0*x1^2+3*x0-x0^3"));
  h.push_back(mpol_t("-3*x0^2+3*x1^2"));

  cout<<"Rational map:"<<endl;
  VECTOR::print(std::cout,h);
  ListPol f = transformType<ListPol>(h);
  std::vector<int> d(3); d[0]=1;d[1]=2;d[2]=1;
  double td[]= {-0.1,0,0.3,0.5,0.3,-0.5,-0.5,0.1,0.6,-0.2,-0.2,
		0.6,-0.2,-0.2,0.5,0.5,-0.5,0.2,0.7,0.5,0.8,-0.4,
		-0.4,-0.4,-0.1,0.7,0,-0.1};
  std::vector<double> u(td, td+28);
  cout<<"Degrees used :\n";
  VECTOR::print(std::cout,d);
  //  cout<<"Values used : \n";  print(u);
  mpol_t  p = Elim_Approximate(f,d,u);
  cout<<"Resulting equation: \n"<<p<<" = 0\n";
  cout<<"Degree : "<<degree(p)<<'\n';
}
