

#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS


template<typename monom>
struct predicat 
{
  int taille1;
  monom * accept;
  int taille2;
  monom * refuse;
  typedef monom monom_t;
};

template<typename predicat>
struct Base
{
	std::list<predicat> def;
  int nbvars;
  typedef predicat predicat_t;
  typedef typename predicat::monom_t mon;
  typedef typename std::list<predicat>::iterator iterator;
  typedef typename std::list<predicat>::const_iterator const_iterator;
  typedef typename std::list<predicat>::reverse_iterator reverse_iterator;
  typedef typename std::list<predicat>::const_reverse_iterator const_reverse_iterator;

  iterator begin () { return def.begin(); }
  const_iterator begin () const { return def.begin(); }
  reverse_iterator rbegin ()    { return def.rbegin(); }
  const_reverse_iterator rbegin () const { return def.rbegin(); }

  iterator end () { return def.end(); }
  const_iterator end () const { return def.end(); }
  reverse_iterator rend () { return def.rend(); } 
  const_reverse_iterator rend () const { return def.rend(); }

  iterator erase(iterator first, iterator last){return def.erase(first,last);};
  iterator erase(iterator first){return def.erase(first);};
  int nbvar() {return nbvars;};
  int nbvar() const {return nbvars;};
};

template<typename mon,typename predicat,typename Base>
int isinb(const mon &m,predicat p,const Base &b)
{
  int inaccept=0,inrefuse=0;
  for(int i=0;i<p.taille1;i++)
    {
      //cout<<"p.accept[i] "<<p.accept[i]<<" "<<m<<endl;
      inaccept|=isdivisible(p.accept[i],m,b);
      if(inaccept) break;
    }
  for(int i=0;i<p.taille2;i++)
    {
      inrefuse|=isdivisible(p.refuse[i],m,b);
      if(inrefuse) break;
      //cout<<"p.refuse[i] "<<p.refuse[i]<<" "<<m<<" "<<inrefuse<<endl;
    }
  //isdcout<<"inaccept "<<inaccept<<" inrefuse "<<inrefuse<<endl;
  return(inaccept&&(!inrefuse));
}

template<typename mon,typename Base>
int IsinB(const mon & m,const Base & b)
{
  int res=0;
  //cout<<"monom "<<m<<endl;
  for(typename Base::const_iterator iter=b.begin();iter!=b.end();iter++)
    {
      res=res||isinb(m,*iter,b);
      if (res) break;
    }
  //cout<<"verdict isinb "<<res<<endl;
  return res;
}

template<typename typMk,typename typdump,typename Base>
void Dovoisins(const typename typMk::value_type &m, typMk &voisins,
	       const typdump & dump,const Base &b)
{
  typedef typename typMk::value_type mon;
  int i=0;
  typename typdump::const_iterator iter=dump.begin();
  //on determine un parent
  typMk ancien;
  for(i=0;i<b.nbvar();i++)
    if(m[i]>0)
      ancien.push_back(my_divmon(m,i,b));
  //for(typename typMk::iterator iteranc=ancien.begin()
//		  ;iteranc!=ancien.end();iteranc++)
//	  cout<<*iteranc<<endl;
  //cout<<"Dans Dovoisins "<<m<<endl;
  for(;iter->k!=(degree(m)-1);iter++);
  for(i=0;i<iter->size;i++)
  {
    if(member(ancien,iter->nf[i].ind)) break;
  //  cout<<"iter->nf[i].ind "<<iter->nf[i].ind<<endl;
  }
    //maintenant on l'a on prend toute les consequences de ce parent
  //if(i==iter->size) cout<<"caca boudin"<<endl;
  for(int j=0;j<b.nbvar();j++)
  {
	mon tmp=iter->nf[i].ind*mon(j,1);
	  if(!member(voisins,tmp))
     	 voisins.push_back(tmp);
  }
}


template<typename typPk,typename typMk ,typename typdump,typename Base, typename typserv>
void rajoute_voisins(typPk &Pk,const typMk & Mk,
		     const typdump &dump, Base &b, typserv & serv)
  // l'object if de la fonction est d'eviter les 
  //oublis de voisin lors d'un rajout au quotient
{
  typedef typename typPk::value_type pol;
  typedef typename pol::monom_t mon;
  typedef typename pol::coeff_t coeff;
  mon * baccept=b.rbegin()->accept;
  int taille=b.rbegin()->taille1;
  typMk voisins;
  for(int i=0;i<taille;i++)
    Dovoisins(baccept[i],voisins,dump,b);
  //Dovoisins ne cree pas de monomes redondants!!!!!!!!!!!!
  for(typename typMk::iterator iter=voisins.begin();iter!=voisins.end();iter++)
    {
      for(int i=0;i<taille;i++)
	if(baccept[i].rep()==iter->rep())
	  {
	    voisins.erase(iter--);
	    break;
	
	  }  
    }
  for(typename typMk::iterator iter=voisins.begin();iter!=voisins.end();iter++)
    {
      if(member(Mk,*iter)) 
	voisins.erase(iter--);
    }
  //on vire les voisins que l on a rajoute a l'accept quotient
  //et ceux que l'on a deja
  for(typename typMk::iterator iter=voisins.begin();iter!=voisins.end();iter++)
    {
      typMk ancien;
      for(int i=0;i<b.nbvar();i++)
	if((*iter)[i]>0)
	  ancien.push_back(my_divmon(*iter,i,b));
      //on vient de creer les parents possibles
      //maintenant on cherhce un pere possible
      
      {
	typename typdump::const_iterator iterdump;
	  for(iterdump=dump.begin();iterdump!=dump.end();iterdump++)
	    if(iterdump->k==(degree(*iter)-1)) break;
	{
	  int i,j;
	  for(i=0;i<iterdump->size;i++)
	    if(member(ancien,iterdump->nf[i].ind)) 
	      break;
	  //on a un parent on calcul la nf du monome *iter maintenant
	  //d'abord on calcul la bonne variable
	  for(j=0;j<b.nbvar();j++)
	    if(iter->rep()==mon(iterdump->nf[i].ind*mon(j,1)).rep())
	      break;
	  mon * tmp=NULL;
	  int tmpsize=0;
	 //Tue Dec  4 16:39:25 MET 2001
	  //pol tmppol;
	  //densify(iterdump->nf[i],tmppol);
	  //cout<<"avant mult"<<endl;
	  //Tue Dec  4 16:39:25 MET 2001
	  //Pk.push_back(mult(j,tmppol,dump,b,&tmp,tmpsize));
	  Pk.push_back(mult(j,iterdump->nf[i],dump,b,&tmp,tmpsize,serv));
	  
	  //il n devrait y avoir personne dans tmp normalement
	  //int toint=0;
	  //for(;Pk.back().ind.GetCoeff()>toint;toint++);
	  for(int k=0;k<tmpsize-1;k++)
	    {
	      for(typename typPk::iterator iterpk=Pk.begin()
		    ;iterpk!=Pk.end();iterpk++)
		if(iterpk->ind.rep()==tmp[k].rep())
		  {
		    my_plus(Pk.back(),*iterpk,tmp[k].coeff());
		    break;
		  }
	    }
	  MAC_REV_FREE<mon>(tmp,sizeof(mon)*(tmpsize));
	}
      }
      //cout<<"coucou de rajoutevoisins "<<Pk.back().ind<<endl;
      //  cout<<"le pol rajoute vaut"<<endl<<invconv<Poly>(Pk.back())<<endl;
      Pk.back().ind.setcoeff((coeff)1);
      //cout<<"Je l'ai pas !!! "<<endl;
      //exit(10);
    }
  //on rajoute a B les monomes correspondants au voisin
  //on enleve en fait...
  //
  // cout<<"rajoute voisins .size "<<voisins.size()<<endl;
  b.rbegin()->refuse=(mon*)MAC_REV_REALLOC<mon>(b.rbegin()->refuse
				       ,sizeof(mon)*b.rbegin()->taille2,
			    sizeof(mon)*(b.rbegin()->taille2+voisins.size()));
  typename typMk::iterator iter=voisins.begin();
  for(unsigned int i=b.rbegin()->taille2;i<b.rbegin()->taille2+voisins.size()
	;i++,iter++)
    b.rbegin()->refuse[i]=*iter;
  b.rbegin()->taille2+=voisins.size();
} 

//AddB n'est normalement appele que lorsque la matruice n'a pas rang plein 
//et que le second membre se reduti a 0
template<typename typmat,typename typPk, typename typMk,typename typdump,
  typename typB,typename typserv>
void AddB(const typmat & mat, typPk & Pk,const typMk &Mk,const typdump & dump,
	  typB &b,typserv & serv)
{
  typedef typename typPk::value_type pol;
  typedef typename pol::monom_t mon;
  typedef typename pol::coeff_t coeff_t;
  typename typPk::iterator iterpk;
  predicat<mon> tmp;
  typename typMk::const_iterator iter=Mk.begin();
  int r=rank(mat),comprefuse=0,compaccept=0;
  unsigned int i;
  //cout<<"DANS ADDB"<<endl;
  //cout<<"rang de la matrice m "<<r<<" Mk.size "<<Mk.size()<<endl;
  //cout<<"taille de la matrice "<<mat.nrow<<"x"<<mat.ncol<<endl;
  tmp.refuse=(mon*)MAC_REV_MALLOC<mon>(r*sizeof(mon));
  tmp.taille2=r;
  tmp.accept=(mon*)MAC_REV_MALLOC<mon>((Mk.size()-r)*sizeof(mon));
  tmp.taille1=Mk.size()-r;
  //for(i=0;i<(unsigned)r;i++,iter++)
  //  tmp.refuse[i]=*iter;
  iter=Mk.begin();
  for(i=0;i<Mk.size();i++,iter++)
    {
      if(Iszero(mat(i,i))) 
	{
	  tmp.accept[compaccept++]=*iter;
	  //cout<<"monome rajoute au quotient "<<*iter<<endl;
	}
      else
	{
	  tmp.refuse[comprefuse++]=*iter;
	}
    }
  b.def.push_back(tmp);
  //bon maintenant que l'on vient de rajouter des 
  //monomes au quotient il faut remttre les polynomes comme il faut
  iter=Mk.begin();
  //for(int i=0;i<rank(mat);i++,iter++);
  //iter pointe maintenant sur le premier monome 
  //rajoute dans le quotient
//    for(int i=0;i<rank(mat);i++,iterpk++)
//      {
//        int newsize=iterpk->size-1;
//        typename typMk::const_iterator tmpiter=iter;
//        for(int j=rank(mat);j<mat.ncol;j++,tmpiter++)
//  	if(!Iszero(mat(i,j)))
//  	  {
//  	    if(newsize<mon2int(*tmpiter)) newsize=mon2int(*tmpiter);
//  	  }
//        //maintenant on realloue et on inittialise
//        iterpk->nf=(typename mon::coeff_t*)
//  	MAC_REV_REALLOC<typename mon::coeff_t>(iterpk->nf
//  			,iterpk->size*sizeof(typename mon::coeff_t)
//  			,(newsize+1)*sizeof(typename mon::coeff_t));
//        //      assert(iterpk->nf!=NULL);
//        for(int j=iterpk->size;j<newsize;j++)
//  	iterpk->nf[j]=(typename mon::coeff_t)(0);
//        iterpk->size=newsize+1;
//        //maintenant on ecrit dedans
//        tmpiter=iter;//on remet tmpiter a "zero"
//        for(int j=rank(mat);j<mat.ncol;j++,tmpiter++)
//  	if(!Iszero(mat(i,j)))
//  	  {
//  	    iterpk->nf[mon2int(*tmpiter)]=mat(i,j);
//  	  }
//        //voila le pol est pret!!
//      }
  for(unsigned int i=0;i<Mk.size();i++,iter++)
    {
      if(Iszero(mat(i,i)))
	{
	  int index=serv.mon2int(*iter);
	  iterpk=Pk.begin();
	  //on commence a faire de l'algebre lineaire
	  coeff_t *vec=(coeff_t*)MAC_REV_MALLOC<coeff_t>(i*sizeof(coeff_t));
	  for(unsigned int j=0;j<i;j++)
	    vec[j]=mat(j,i);
	  //le vecteur est fait reste plus qu'a 
	  //resoudre le syteme lineaire
	  for(int k=i-1;k>=0;k--)
	    {
	      if(Iszero(mat(k,k))) continue;
	      vec[k]/=mat(k,k);
	      for(int j=k-1;j>=0;j--)
		vec[j]-=vec[k]*mat(j,k);
	    }
	  //bon ca a l'air d'etre bon pour la resolution du systeme linaire
	  //on remet les coeff de vec dans les pol a la bonne place
	  for(unsigned int j=0;j<i;j++,iterpk++)
	    {
	      if((!Iszero(vec[j])))//&&(!Iszero(mat(j,j))))
	      {
		if(index>=iterpk->size)
		  {
		    iterpk->nf=(typename mon::coeff_t*)
		      MAC_REV_REALLOC<typename mon::coeff_t>(iterpk->nf
			,iterpk->size*sizeof(typename mon::coeff_t)
			,(index+1)*sizeof(typename mon::coeff_t));
		    for(int k=iterpk->size;k<=index;k++)
		      iterpk->nf[k]=0;
		    iterpk->size=index+1;
		  }
		iterpk->nf[index]=vec[j];
		//cout<<"rajoute le monome "<<*iter<<" a la ligne "<<j<<" "<<vec[j]<<" i "<<i<<endl;
		//		cout<<"le pol"<<endl<<invconv<Poly>(*iterpk)<<endl;
	      }
	    }
	  MAC_REV_FREE<coeff_t>(vec,i*sizeof(coeff_t));
	}
    }
  //rajoute_voisins(Pk,Mk,dump,b);
  return;
}
      
  
__END_NAMESPACE_SYNAPS

