
#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS


extern void affdebug(...);
extern void affdebug2(...);
//cherche un pivot et retourne son indice
template <typename typmat>
int findpiv(typmat &m,int j)
{
  typedef typename typmat::coeff_t coeff;
  int pivind=-1;
  coeff max=0;
  for(int i=j;i<m.ncol;i++)
    if(m(i,j)*m(i,j)>max)
      {
	pivind=i;
	max=m(i,j);
      }
  return pivind;
}

template<typename T>
int findpiv(sparse::rep2d<T> &m,int j)
{
  typedef T coeff;
  int pivind=-1;
  //cout<<"j dans findpiv "<<j<<endl;
  coeff max=0;
  for (int i=m.colptr[j];i<m.colptr[j+1];i++)
    {
      //cout<<"i dans pivind "<<i<<" "<<((coeff*)m.nzval)[i]<<" "
      //	  <<m.rowind[i]<<endl;
      T tmp=(((coeff*)m.nzval)[i]*((coeff*)m.nzval)[i]);
      if ((tmp>max) &&  (m.rowind[i]>=j))
	{
	  //  cout<<"la"<<endl;
	  pivind=m.rowind[i];
	  max=((coeff*)m.nzval)[i]*((coeff*)m.nzval)[i];
	}
    }
  //  cout<<"pivot found "<<pivind<<" "<<max<<endl;
  return pivind;
}
template<typename T>
void Doperm_r(sparse::rep2d<T> &m,int pivind,int j)
{
  for(int i=0;i<m.nnz;i++)
    {
      if(m.rowind[i]==pivind) {m.rowind[i]=j;continue;};
      if(m.rowind[i]==j) {m.rowind[i]=pivind;continue;};
    }
}

//fait une permutation des lignes
//echange pivind et j
template<typename typmat>
void Doperm_r(typmat &m,int pivind,int j)
{
  typename typmat::coeff_t tmp1,tmp2;
  for(int i=0;i<m.ncol;i++)
    {
      //cout<<"Doperm_r m("<<pivind<<","<<i<<") "<<m(pivind,i)<<endl;
      tmp1=m(pivind,i);
      tmp2=m(j,i);
      m(pivind,i,tmp2);
      m(j,i,tmp1);
    }
}
//meme chose sur les colonnes
template<typename typmat>
void Doperm_c(typmat &m,int k,int l)
{
  //  cout<<"k "<<k<<" l "<<l<<endl;
  typename typmat::coeff_t tmp;
  for(int i=0;i<m.nrow;i++)
    {
      tmp=m(i,k);
      //   cout<<" tmp "<<tmp<<" I "<<i<<endl;
      m(i,k,m(i,l));//<<endl;
      //cout<<"m(i,k) "<<m(i,k)<<endl;
      m(i,l,tmp);  //<<endl;
      //cout<<"m(i,l) "<<m(i,l)<<endl;
    }
}
template<typename T>
void Doperm_c(sparse::rep2d<T> &m,int k,int l)
{
  void *tmpnzval=malloc(m.nnz*sizeof(T));
  int *tmprowind=(int*)malloc(m.nnz*sizeof(int));
  int minkl,maxkl,decalage;
  if(k<l) {minkl=k;maxkl=l;}
  else {minkl=l;maxkl=k;};
  decalage=m.colptr[maxkl+1]-m.colptr[maxkl]-m.colptr[minkl+1]+m.colptr[minkl];
  for(int i=0;i<m.colptr[minkl];i++)
    {
      ((T*)tmpnzval)[i]=((T*)m.nzval)[i];
      tmprowind[i]=m.rowind[i];
    }
  for(int i=0;i<m.colptr[maxkl+1]-m.colptr[maxkl];i++)
    {
      ((T*)tmpnzval)[m.colptr[minkl]+i]=((T*)m.nzval)[m.colptr[maxkl]+i];
      tmprowind[m.colptr[minkl]+i]=m.rowind[m.colptr[maxkl]+i];
    }
  for(int i=m.colptr[minkl+1];i<m.colptr[maxkl];i++)
    {
      ((T*)tmpnzval)[i+decalage]=((T*)m.nzval)[i];
      tmprowind[i+decalage]=m.rowind[i];
    }
  for(int i=0;i<m.colptr[minkl+1]-m.colptr[minkl];i++)
    {
      ((T*)tmpnzval)[m.colptr[maxkl]+i+decalage]=
      ((T*)m.nzval)[m.colptr[minkl]+i];
      tmprowind[m.colptr[maxkl]+i+decalage]=m.rowind[m.colptr[minkl]+i];
    }
  for(int i=m.colptr[maxkl+1];i<m.nnz;i++)
    {
      ((T*)tmpnzval)[i]=((T*)m.nzval)[i];
      tmprowind[i]=m.rowind[i];
    }
  for(int i=minkl+1;i<=maxkl;i++)
    m.colptr[i]+=decalage;
  
  free(m.nzval);
  m.nzval=tmpnzval;
  free(m.rowind);
  m.rowind=tmprowind;
}
							    
//renvoit les poids des colonne de m
//sous forme d'un int*
//attention a desalouer derriere  
template<typename  typmat>
int * weight_c(const typmat &m)
{
  int * res=(int*)malloc(sizeof(int)*m.ncol);
  for(int i=0;i<m.ncol;i++)
    res[i]=m.colptr[i+1]-m.colptr[i];
  return res;
}
//trouve le plus grand parmi les les n premier 
int find_max(int *res,int n)
{
  int max=0,indmax=0;
  for(int i=0;i<n;i++)
    if (max<res[i])
      {
	max=res[i];
	indmax=i;
      }
  res[indmax]=0;
  return indmax;
}
//determine quelle est la permutation a effectuer
//pour bouger les collone de poid fort a gauche
//et appelle Doperm_c
template<typename typmat>
void perm_c(typmat &m,int* pc)
{
  int *res=weight_c(m);
  //  for(int i=0;i<m.ncol;i++)
  //  cout<<"res["<<i<<"] "<<res[i]<<endl;
  for(int i=m.ncol-1;i>0;i--)
    {int toto,tmp;
      Doperm_c(m,i,toto=find_max(res,m.ncol));
      tmp=pc[toto];
      pc[toto]=pc[i];
      pc[i]=tmp;
    }
  free(res);
}
//divis par le pivot une ligne
template<typename typmat>
void nwmc_normal(typmat &m,int j)
{
  const typename typmat::coeff_t temp=m(j,j);
  for (int i=j;i<m.ncol;i++)
    m(j,i,m(j,i)/temp);
return;
}
template<typename T>
void nwmc_normal(sparse::rep2d<T> &m,int j)
{
  const T temp=m(j,j);
  for (int i=m.colptr[j];i<m.colptr[j+1];i++)
    ((T*)m.nzval)[i]/temp;
}
//update elimine le coeff de la ligne j de la colonne jj
//en lui ajoutant le bon multiple de la ligne j
template<typename typmat>
void update(typmat &m,int jj,int j)
{
  const typename typmat::coeff_t tmp=m(jj,j)/m(j,j);
  for (int i=j;i<m.ncol;i++)
    {
      m(jj,i,m(jj,i)-tmp*m(j,i));
    }
      return;
}
template<typename T>
inline void update(sparse::rep2d<T> &m,int jj, int j)
{
  //int nbelemrowj=0;
  int colcount=0,nnz=0;
  const T tmp=m(jj,j)/m(j,j);
  T tmpvaljj=0;
  void *tmpnzval;
  register int * tmprowind;
  register int * tmpcolptr;
  //for(int i=0;i<m.nnz;i++)
  // if(m.rowind[i]==j) nbelemrowj++;
  //tmpnzval=malloc((m.nnz+nbelemrowj)*sizeof(T));  
  tmpnzval=malloc((m.nnz+m.ncol)*sizeof(T));
  // tmprowind=(int*)malloc((m.nnz+nbelemrowj)*sizeof(int));
  tmprowind=(int*)malloc((m.nnz+m.ncol)*sizeof(int));
  tmpcolptr=(int*)malloc((m.ncol+1)*sizeof(int));
  *tmpcolptr=0;
  memcpy(tmpnzval,m.nzval,m.colptr[j]*sizeof(T));
  memcpy((void*)tmprowind,(void*)m.rowind,m.colptr[j]*sizeof(int));
  memcpy((void*)tmpcolptr,(void*)m.colptr,(j+1)*sizeof(int));
  nnz=m.colptr[j];
  colcount=j;
  for(register int i=m.colptr[j];i<m.nnz;i++)
    {
      int rowind=m.rowind[i];
      // cout<<"m.colptr["<<colcount+1<<"] "<<m.colptr[colcount+1]<<" m.nnz "<<m.nnz<<" i "<<i<<endl;
      if(i==m.colptr[colcount+1])
	{
	  if((tmpvaljj!=0)||(nnz==tmpcolptr[colcount]))
	    {
	      ((T*)tmpnzval)[nnz]=tmpvaljj;
	      tmpvaljj=0;
	      tmprowind[nnz]=jj;
	      tmpcolptr[colcount+1]=nnz+1;
	      nnz++;
	    }
	  else
	    {
	      tmpcolptr[colcount+1]=nnz;
	    }
	  colcount++;
	}
      if(rowind==jj)
	{
	  tmpvaljj+=((T*)m.nzval)[i];
	  continue;
	}
      if(rowind==j)
	{
	  tmpvaljj-=tmp*((T*)m.nzval)[i];
	}
      ((T*)tmpnzval)[nnz]=((T*)m.nzval)[i];
      tmprowind[nnz]=rowind;
      nnz++;
    }
  if(tmpvaljj!=0)
    {
      ((T*)tmpnzval)[nnz]=tmpvaljj;
      tmpvaljj=0;
      tmprowind[nnz]=jj;
      tmpcolptr[colcount+1]=nnz+1;
      nnz++;
    }
  else
    {
      if (nnz==tmpcolptr[colcount])
	{
	  ((T*)tmpnzval)[nnz]=tmpvaljj;
	  tmpvaljj=0;
	  tmprowind[nnz]=jj;
	  tmpcolptr[colcount+1]=nnz+1;
	  nnz++;
	}
      else
	{
	  tmpcolptr[colcount+1]=nnz;
	}
    }
  //  cout<<"colcount "<<colcount<<" m.ncol "<<m.ncol<<endl;
  tmpcolptr[m.ncol]=nnz;
  tmpnzval=realloc(tmpnzval,nnz*sizeof(T));
  tmprowind=(int*)realloc(tmprowind,nnz*sizeof(int));
  free(m.nzval);
  free(m.rowind);
  free(m.colptr);
  m.nzval=tmpnzval;
  m.rowind=tmprowind;
  m.colptr=tmpcolptr;
  m.nnz=nnz;
}

template<typename T>
void update_col(sparse::rep2d<T> &m,int jj, int j)
{
  const T tmp=m(jj,j)/m(j,j);
  int comp,i,nnz=0,nbnnz=m.colptr[j+1]-m.colptr[j],
    nbtot=nbnnz+m.colptr[jj+1]-m.colptr[jj];
  int colindj=m.colptr[j],colindjj=m.colptr[jj];
  int *tmprowind=(int*)malloc((m.nnz+nbnnz)*sizeof(int));
  void * tmpnzval=malloc((m.nnz+nbnnz)*sizeof(T));
  int debutcol=m.colptr[jj];
  for(i=0;i<debutcol;i++)
    {
      ((T*)tmpnzval)[i]=((T*)m.nzval)[i];
      tmprowind[i]=m.rowind[i];
    }
  nnz=i;
  for(comp=0;comp<nbtot;)
    {
      if (m.rowind[colindj]<m.rowind[colindjj])
	{
	  tmprowind[debutcol+comp]=m.rowind[colindj];
	  ((T*)tmpnzval)[debutcol+comp]=-((T*)m.nzval)[colindj]*tmp;
	  comp++;
	  colindj++;
	  continue;
	}
       if (m.rowind[colindjj]<m.rowind[colindj])
	{
	  tmprowind[debutcol+comp]=m.rowind[colindjj];
	  ((T*)tmpnzval)[debutcol+comp]=((T*)m.nzval)[colindjj];
	  comp++;
	  colindjj++;
	  continue;
	}
       if(m.rowind[colindjj]==m.rowind[colindj])
	{
	  tmprowind[debutcol+comp]=m.rowind[colindjj];
	  ((T*)tmpnzval)[debutcol+comp]=
	    ((T*)m.nzval)[colindjj]-tmp*((T*)m.nzval)[colindj];
	  comp+=2;
	  colindj++;
	  colindjj++;
	  continue;
	}
    }
  nnz+=comp;
  for(i=m.colptr[jj+1];i<m.nnz;i++)
    {
      ((T*)tmpnzval)[i]=((T*)m.nzval)[i];
      tmprowind[i]=m.rowind[i];
      nnz++;
    }
  tmpnzval=realloc(tmpnzval,nnz*sizeof(T));
  tmprowind=(int*)realloc(tmprowind,nnz*sizeof(int));
  comp=comp-(m.colptr[jj+1]-m.colptr[jj]);
  for(i=0;i<=m.ncol;i++)
    m.colptr[i]+=comp;
  free(m.nzval);
  m.nzval=tmpnzval;
  free(m.rowind);
  m.rowind=tmprowind;
}

//la fonction mylu core
//elimination gaussienne structuree 
//a priori elle modifie m et lui affecte la valeur de L
template<typename typmat>
void LUdecomp(typmat &m,typmat *L,typmat *U,int **pr,int **pc)
{
  //  Clock c;
  typedef typename typmat::coeff_t coeff;
  int j; 
  coeff tmp;
  //    affdebug(m);
  *pr=(int*)malloc(sizeof(int)*m.nrow);
  *pc=(int*)malloc(sizeof(int)*m.ncol);
  for(int i=0;i<m.nrow;i++)
    {
      (*pr)[i]=i;
    }
  for(int i=0;i<m.ncol;i++) 
  {
    (*pc)[i]=i;
  }
  typmat &u=*U;
  typmat &l=*L;
  allocstore(u,m.nrow,m.ncol,(coeff)0);
  allocstore(l,m.nrow,m.nrow,(coeff)0);
// //   c.start();
// //   perm_c(m,*pc);
// //   cout<<"la perm des col "<<c.time()<<endl;
  //for(int i=0;i<m.ncol;i++)
  //  cout<<*((*pc)+i)<<endl;
  //cout<<"fin permu "<<endl;
  for(j=0;j<(m.ncol-1);j++)
    {
      //  cout<<"les nnz "<<endl;
      //for(int i=0;i<m.nnz;i++)
      //	cout<<((typename typmat::coeff_t*)m.nzval)[i]<<" "<<m.rowind[i]<<endl;
      //cout<<"avant permu "<<endl;
      //affdebug(m);
      
      int pivind=findpiv(m,j);
      // cout<<"pivind "<<pivind<<endl;
      if(pivind==-1)
	{
	  for(int k=j+1;k<m.ncol;k++)
	    {
	      Doperm_c(m,k,j);
	      //swapcol(l,k,j)     ???
	      std::swap((*pc)[j],(*pc)[k]);
	      pivind=findpiv(m,j);
	      // cout<<"pivind en cours "<<pivind<<endl;
	      if(pivind!=-1) break;
	    }
	}
      //cout<<"pivind "<<pivind<<endl;
      if (pivind!=-1)
	{
	  std::swap((*pr)[j],(*pr)[pivind]);
	  //cout<<"swap"<<endl;
	  Doperm_r(m,pivind,j);
	  Doperm_r(l,pivind,j);
	  //cout<<"perm R"<<endl;
	  tmp=m(j,j);
	  //cout<<"m(j,j)"<<tmp<<endl;
	  // nwmc_normal(m,j);
	  //cout<<"nwmc_normal fait"<<endl;
	  //c.start();
	  for(int jj=j+1;jj<m.nrow;jj++)
	   {
	    coeff tmp=(m(jj,j)*m(jj,j));
	     if (tmp>(coeff)0)
	      {
		l(jj,j,m(jj,j)/tmp);
		//cout<<"update"<<endl;
		//		affdebug(m);
		update(m,jj,j);
		//cout<<"update fait"<<jj<<" "<<j<<endl;
		//affdebug(m);
	      }
	   }
	  //	  cout<<"temps pour un update "<<c.time()<<endl;
	}
      // cout<<"les nnz "<<endl;
      //      for(int i=0;i<m.nnz;i++)
      //	cout<<((typename typmat::coeff_t*)m.nzval)[i]<<" "<<m.rowind[i]<<endl;
      //cout<<"apres permu "<<endl;
      //affdebug(m);
    }
  // cout<<"j en sortie de boucle vaut "<<j<<endl;
  //affdebug(m);
  int pivind=findpiv(m,j);
  // cout<<"pivind fin "<<pivind<<endl;
  if(pivind !=-1)
    {
      Doperm_r(m,pivind,m.ncol-1);
      Doperm_r(l,pivind,m.ncol-1);
      std::swap((*pr)[pivind],(*pr)[m.ncol-1]);
      //cout<<"conneries sur les lignes faites "<<endl;
      tmp=m(j,j);
      //cout<<"tmp "<<tmp<<endl;
      //nwmc_normal(m,j);
      for(int jj=j+1;jj<m.nrow;jj++)
	{
	  coeff tmp=(m(jj,j)*m(jj,j));
	  //  cout<<"dans le for jj "<<jj<<endl;
	  if (tmp>0)
	    {
	      //cout<<"entree dans update "<<jj<<" par "<<j<<endl;
	      //cout<<"m(jj,j) "<<m(jj,j)<<endl;
	      //affdebug(l);
	      l(jj,j,m(jj,j)/tmp);
	      // cout<<"ls ll passe "<<endl;
	      update(m,jj,j);
	    }
	}
    }
  //cout<<"fin des updates "<<endl;
  for(int jj=0;jj<m.nrow;jj++)
    l(jj,jj,1);
  //  cout<<"fin de mise des 1 sur l"<<endl;
  //affdebug(m);
  // cout<<"m avant les swap"<<endl;
 //  swap(m.nnz,u.nnz);
//   swap(m.rowind,u.rowind);
//   swap(m.colptr,u.colptr);
//   swap(m.nzval,u.nzval);
//   swap(m.ncol,u.ncol);
//   swap(m.nrow,u.nrow);
  
//   swap(m.nnz,l.nnz);
//   swap(m.rowind,l.rowind);
//   swap(m.colptr,l.colptr);
//   swap(m.nzval,l.nzval);
//   swap(m.ncol,l.ncol);
//   swap(m.nrow,l.nrow);
  //      cout<<"M"<<endl;
  //  affdebug(m);
  // cout<<"U   "<<endl;
  //affdebug(u);
  //  cout<<"L"<<endl;
  // affdebug(l);
  return;
}


__END_NAMESPACE_SYNAPS


