
#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS


template<typename typP,typename typPk,typename Base>
void Crochetchoix(const typP & P,typPk & Pk, typPk & redspol,int k,
		    Base &b);

template<typename typPk>
void stab(typPk & Pk)
{
  typedef typename typPk::value_type pol;
  typedef typename pol::monom_t mon;
  for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
    {
      pol tmpres=mon(0);
      for(typename pol::iterator iterpol=iter->begin();iterpol!=iter->end();
	  iterpol++)
	{
	  if(!Iszero(iterpol->coeff()))
	    tmpres+=*iterpol;
	}
      *iter=tmpres;
    }
}

template<typename T>
void  my_merge(T &l1,const T &l2)
{
  typename T::const_iterator iter=l2.begin();
  for(;iter!=l2.end();iter++)
    l1.push_back(*iter);
}
template<typename mon>
mon Lcm(const mon &m1,const mon &m2)
{
  mon m(1);
  int maxi=std::max(lvar(m1.rep()),lvar(m2.rep()));
  for(int i=0;i<=maxi;i++)
    m*=mon(i,std::max(m1[i],m2[i]));
  return m;
}

template<typename typppcm,typename Base>
void compute_ppcm(typppcm &ppcm,const Base & b)
{
  typedef typename Base::mon mon;
  //typppcm tmpppcm;
  for(typename Base::const_reverse_iterator iter=b.rbegin()
	;iter==b.rbegin();iter++)
    {
      for(int i=0;i<iter->taille2;i++)
	for(int j=i+1;j<iter->taille2;j++)
	  {
	    mon tmpmon=Lcm(iter->refuse[i],iter->refuse[j]);
	    if(!ppcm.count(tmpmon))
	      ppcm[tmpmon]=1;
	    //cout<<"ppcm rajoute "<<tmpmon<<" "<<iter->refuse[i]<<" "<<iter->refuse[j]<<endl;
	  }
    }
}

template<typename mon,typename Base,typename typppcm>
int goodspol(const mon &m1,const mon &m2, typppcm & ppcm,const Base &b)
  //,const typMk &Spoldejavu)
{
  //list<mon> ppcm;
  int res=0,comp=0;//,nobplus=1;
  mon m=m1;
  for(int i=0;i<b.nbvar();i++)
    if(m1[i]!=m2[i])
      {
	comp++;
	if (m1[i]==m2[i]+1)
	  res+=1;
	if (m1[i]+1==m2[i])
	  {
	    res+=1;
	    m*=mon(i,1);
	  }
      };
  //compute_ppcm(ppcm,b);
  //if((res==2)&&(comp==2)) 
  //  for(int i=0;i<b.nbvar();i++)
  //    if(m.GetDegree(i)>0)
  //	nobplus=nobplus && !IsinB(my_divmon(m,i,b),b);
   //cout<<"m1 "<<m1<<" m2 "<<m2<<" resultat "<<((res==2)&&(comp==2))<<endl;
   //return ((res==2)&&(comp==2)&&nobplus);
  //cout<<m1<<" < "<<m2<<" res "<<(member(ppcm,m)&&(res==2)&&(comp==2))<<endl;
  return (res==2)&&(comp==2)&&ppcm[m];//&&!member(Spoldejavu,m);
}

template<typename typPk,typename Base>
typPk Spolordsup(typPk Pk,const Base & b)//,const typMk & Spoldejavu)
{
  typedef typename typPk::value_type::monom_t mon;
  //typedef typename typ::order_t O;
  std::map<mon,int,my_Dlex<mon> > ppcm;
  typPk res;
  //cout<<"compute ppcm"<<endl;
  compute_ppcm(ppcm,b);
  //cout<<"test goodspol"<<endl;
  for(typename typPk::iterator iter1=Pk.begin();iter1!=Pk.end();iter1++)
    for(typename typPk::iterator iter2=iter1;iter2!=Pk.end();iter2++)
      if (goodspol(iter1->ind,iter2->ind,ppcm,b))
	{
	  res.push_back(*iter1);
	  res.push_back(*iter2);
	}
  return res;
}
template<typename typP>
int minmaxdegP(typP P,int &maxdeg)
{
  int res=degree(*P.begin());
  maxdeg=res;
  for(typename typP::iterator iter=P.begin();iter!=P.end();iter++)
    {
      res=(res>degree(*iter))?degree(*iter):res;
      maxdeg=(maxdeg<degree(*iter))?degree(*iter):maxdeg;
    }
  return res;
}
template<typename typP, typename typserv>
typP Crochet(const typP &P, int k,typserv & serv)
{
  typP res;
  for(typename typP::const_iterator iter=P.begin();iter!=P.end();iter++)
    if(degree(*iter,serv)==k) res.push_back(*iter);
  return res;
}

template<typename typP>
typP Crochet(const typP &P, int k)
{
  typP res;
  for(typename typP::const_iterator iter=P.begin();iter!=P.end();iter++)
    if(degree(*iter)==k) res.push_back(*iter);
  return res;
}

template<typename typP, typename Base>
void Setnbvars(const typP &tmpPk,Base& b)
{
  int tmpvar=0;
  for(typename typP::const_iterator iter=tmpPk.begin();iter!=tmpPk.end();iter++)
    for(typename typP::value_type::const_iterator iterpol=iter->begin();
	iterpol!=iter->end();iterpol++)
      if(tmpvar<lvar(iterpol->rep())) tmpvar=lvar(iterpol->rep());
  b.nbvars=tmpvar+1;
}

template<typename typP, typename typMk, typename Base>
void DoBaseMk(const typP &tmpPk, typMk &Mk, Base &b)
{
  typedef typename typMk::value_type mon;
  typename Base::predicat_t tmp;
  int i=0;
  //int tmpvar=0;
   
  for(typename typP::const_iterator iter=tmpPk.begin();iter!=tmpPk.end();iter++)
    {
      mon tmp(choice(*iter));
      int yes=1;
      //  cout<<"pol dans DoBaseMk "<<endl<<*iter<<endl<<"g choisi "<<tmp<<endl;
      tmp.setcoeff(1);//*=mon(1/tmp.GetCoeff());
      for(typename typMk::iterator iter=Mk.begin();iter!=Mk.end();iter++)
	if(*iter==tmp) {yes=0;break;};
      if(yes) Mk.push_back(tmp);
    }
  //cout<<"Mk.size()"<<Mk.size()<<endl;
  tmp.taille2=Mk.size();
  tmp.refuse=(mon*)MAC_REV_MALLOC<mon>(tmp.taille2*sizeof(mon));
  tmp.taille1=1;
  tmp.accept=(mon*)MAC_REV_MALLOC<mon>(sizeof(mon));
  tmp.accept[0]=mon(1);
  i=0;//pour en etre bien sur
  for(typename typMk::iterator iter=Mk.begin();iter!=Mk.end();iter++,i++)
    {
      tmp.refuse[i]=*iter;
    };
  if(!b.def.empty())
    {
      typename Base::predicat_t verytmp;
      for(typename Base::iterator iter=b.begin();iter!=b.end();iter++)
	{
	  verytmp=*iter;
	  MAC_REV_FREE<mon>(verytmp.refuse,verytmp.taille2*sizeof(mon));
	  MAC_REV_FREE<mon>(verytmp.accept,verytmp.taille1*sizeof(mon));
	}
      b.erase(b.begin(),b.end());
    }
  b.def.push_back(tmp);
  return;
}

template <typename typPk,typename typMk,typename typmat >
typmat*
MatrixOf(const typPk & L, 
	 const typMk & lm,const typmat &mat) 
{
  typedef typename typPk::value_type POL;
  typedef typename typMk::value_type monom_t;  
  typmat *res=NULL;
  std::map<monom_t,int,typename POL::order_t > index;
  int l=1;
  if (res!=NULL) {delete res;};
  for(typename typMk::const_iterator m = lm.begin(); m!=lm.end(); m++){
    index[*m]=l;
    l++;
  }
  int c;
  res=new typmat(L.size(),lm.size());
  l=0;
  // cout<<"L.size() "<<L.size()<<" lm.size() "<<lm.size()<<endl;
  for(typename typPk::const_iterator pi = L.begin(); pi != L.end(); ++pi){
    for(typename POL::const_iterator m = pi->begin(); m!=pi->end(); m++)
      {
	
	if((index.count(*m))) 
	  {
	    c=index[*m];
	    (*res)(l,c-1,m->coeff());
	  }
      }
    l++;
  }
  return res;   
}

template<typename typMat,typename typP,typename typPk,typename typMk, 
  typename Base,typename typdump,typename typserv>
void init_algo(typP &P,int &nouveaumon, int &maxdeg, int & k
	       ,typPk &Pk, typMk & Mk, Base & b, typdump & dump, 
	       typserv & serv)
{
  typedef typename typPk::value_type pol;
  typedef typename pol::coeff_t coeff;
  typedef typename pol::monom_t mon;
  int (*tmpord)(const mon &,const mon &)
    =my_ord<mon>;
  typP tmpPk=P;
  pol debugpol;
  typMat *Mat;
  int *pr,*pc,flag=1;
  serv.setorder(tmpord);
  nouveaumon=1;
  Setnbvars(P,b);
  while(flag)
    {
      Mk.erase(Mk.begin(),Mk.end());
      //cout<<"mindeg"<<endl;
      k=minmaxdegP(tmpPk,maxdeg);
      //cout<<"Crochet"<<endl;
      //tmpPk.push_back(Crochet(P,k).front());
      tmpPk=Crochet(tmpPk,k);
      //      for(typename typP::iterator iter=tmpPk.begin();iter!=tmpPk.end();iter++)
      //cout<<"pol pendant init"<<endl<<*iter<<endl;
      //cout<<"doBaseMk"<<endl;
      DoBaseMk(tmpPk,Mk,b);
      // for(typename typMk::iterator iter=Mk.begin();iter!=Mk.end();iter++)
      //	cout<<*iter<<endl;
      //cout<<"Matrixof"<<endl;
      Mat=MatrixOf(tmpPk,Mk,typMat());
      //affdebug(*Mat);
      //cout<<"solve"<<endl;
      tmpPk=Solve(*Mat,tmpPk,&pr,&pc);
      //      cout<<"apres solve"<<endl;
      selectnozero(tmpPk);
      //affdebug(*Mat);
      stab(tmpPk);
      //for(typename typP::iterator iter=tmpPk.begin();iter!=tmpPk.end();iter++)
	//	cout<<"pol pendant init"<<endl<<*iter<<endl;
      //  cout<<"deletemat"<<endl;
      if(rank(*Mat)==(int)tmpPk.size()) flag=0;
      Mat->destroystore();
      delete(Mat);
      free(pr);
      free(pc);
    }
  //cout<<"Pk,apres solve"<<endl<<tmpPk.front()<<endl;
  //cout<<"convertion"<<endl;
      //for(typename typP::value_type::iterator iter=tmpPk.front().begin();
      //  iter!=tmpPk.front().end();iter++)
	//cout<<"*iter "<<*iter<<" IsinB "<<IsinB(*iter,b)<<endl;
      //for(typename typP::iterator iter=tmpPk.begin();iter!=tmpPk.end();iter++)
	//cout<<"pol apres les solve "<<endl<<*iter<<endl;
      for(typename typP::iterator iter=tmpPk.begin();iter!=tmpPk.end();iter++)
	{
	  Pk.push_back(convert<pol>(*iter,b,serv));
	  //cout<<"le pol apres invconv"<<endl
	   //<<invconv<typename typP::value_type>(*Pk.rbegin(),serv)<<endl;
	   //cout<<"le pol original "<<endl<<*iter<<endl;
	}
      //      for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
      //	cout<<"pol apres les solve "<<endl<<iter->ind<<endl;
      debugpol=Pk.front();
      //for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
	//	cout<<"apres convertion "<<endl<<
	//  invconv<typename typP::value_type>(*iter)<<endl;
      //cout<<"size "<<debugpol.size<<endl;
      //cout<<"Dump "<<Pk.front().ind.GetCoeff()<<endl;
      Dump(Pk,dump);
      //cout<<"apres Dump "<<invconv<typename typP::value_type>(Pk.front())<<endl;
      //      cout<<"je sort d'init_algo "<<endl;
      //cout<<"k vaut "<<k<<endl;
      //cout<<" Pk.size() "<<Pk.size()<<endl;
  return ;
}

template<typename pol,typename coeff>
void inline my_plus(pol &res,const pol & nf,const coeff toto)
{
  typedef typename pol::monom_t mon;
  register unsigned int i=0,stock;;
  register unsigned int ttmp;//=taillequotient/16;
  register unsigned int tmp;//=taillequotient % 16;
  // cout<<"nf.size "<<nf.size<<endl;
  //cout<<"nf.ind "<<nf.ind<<endl;
  //cout<<"nf.nf "<<nf.nf<<endl;
  //cout<<"res.nf "<<res.nf<<endl;
  //cout<<"res.size "<<res.size<<endl;
  coeff *resnf,*nfnf;
  if((res.size) <(nf.size))
    {
      //  cout<<"je realloue res.nf avant "<<res.nf<<endl;
      res.nf=(coeff*)MAC_REV_REALLOC<coeff>(res.nf,res.size*sizeof(coeff)
				     ,nf.size*sizeof(coeff));
      //cout<<"res.nf apres "<<res.nf<<endl;
      for(int i=res.size;i<nf.size;i++)
	res.nf[i]=0;
      res.size=nf.size;
    }
  ttmp=nf.size/16;
  tmp=nf.size %16;//16 pourquoi... PARCE QUE!!!!! :-))
  for(;i<ttmp;++i)
      {
	stock=16*i;
	resnf=res.nf+stock;
	nfnf=nf.nf+stock;
	{
	  // if(nf.nf[stock]!=0)
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	    *resnf++-=*nfnf++*toto;
	  //    //if(nf.nf[stock+1]!=0)
//  	    res.nf[stock+1]-=nf.nf[stock+1]*toto;
//  	   //if(nf.nf[stock+2]!=0)
//  	    res.nf[stock+2]-=nf.nf[stock+2]*toto;
//  	   // if(nf.nf[stock+3]!=0)
//  	   res.nf[stock+3]-=nf.nf[stock+3]*toto;
//  	   //if(nf.nf[stock+4]!=0)
//  	   res.nf[stock+4]-=nf.nf[stock+4]*toto;
//  	   //if(nf.nf[stock+5]!=0)
//  	   res.nf[stock+5]-=nf.nf[stock+5]*toto;
//  	   //if(nf.nf[stock+6]!=0)
//  	   res.nf[stock+6]-=nf.nf[stock+6]*toto;
//  	   //if(nf.nf[stock+7]!=0)
//  	   res.nf[stock+7]-=nf.nf[stock+7]*toto;
//  	   //if(nf.nf[stock+8]!=0) 
//  	   res.nf[stock+8]-=nf.nf[stock+8]*toto;
//  	   /// if(nf.nf[stock+9]!=0)
//  	   res.nf[stock+9]-=nf.nf[stock+9]*toto;
//  	   //if(nf.nf[stock+10]!=0)
//  	    res.nf[stock+10]-=nf.nf[stock+10]*toto;
//  	    //if(nf.nf[stock+11]!=0)
//  	   res.nf[stock+11]-=nf.nf[stock+11]*toto;
//  	   //if(nf.nf[stock+12]!=0)
//  	   res.nf[stock+12]-=nf.nf[stock+12]*toto;
//  	   //if(nf.nf[stock+13]!=0)
//  	   res.nf[stock+13]-=nf.nf[stock+13]*toto;
//  	   //if(nf.nf[stock+14]!=0)
//  	    res.nf[stock+14]-=nf.nf[stock+14]*toto;
//  	    //if(nf.nf[stock+15]!=0)
//  	   res.nf[stock+15]-=nf.nf[stock+15]*toto;
  	 }
	
      }
  i*=16;
  for(register unsigned int j=0;j<tmp;j++)
    res.nf[i+j]-=nf.nf[i+j]*toto;
}

template<typename pol,typename coeff>
void inline my_moins(pol &res,const pol & nf,const coeff &toto)
{
  typedef typename pol::monom_t mon;
  register unsigned int i=0;
  register unsigned int ttmp;//=taillequotient/16;
  register unsigned int tmp;//=taillequotient % 16;
  if((res.size)<(nf.size))
   {
     res.nf=(coeff*)MAC_REV_REALLOC<coeff>(res.nf,res.size*sizeof(coeff)
					   ,nf.size*sizeof(coeff));
     for(int i=res.size;i<nf.size;i++)
       res.nf[i]=0;
     res.size=nf.size;
   }
  ttmp=nf.size/16;
  tmp=nf.size %16;//16 pourquoi... PARCE QUE!!!!! :-))
  for(;i<ttmp;++i)
      {
	{
	  res.nf[i*16]+=nf.nf[i*16]*toto;
	  res.nf[i*16+1]+=nf.nf[i*16+1]*toto;
	  res.nf[i*16+2]+=nf.nf[i*16+2]*toto;
	  res.nf[i*16+3]+=nf.nf[i*16+3]*toto;
	  res.nf[i*16+4]+=nf.nf[i*16+4]*toto;
	  res.nf[i*16+5]+=nf.nf[i*16+5]*toto;
	  res.nf[i*16+6]+=nf.nf[i*16+6]*toto;
	  res.nf[i*16+7]+=nf.nf[i*16+7]*toto;
	  res.nf[i*16+8]+=nf.nf[i*16+8]*toto;
	  res.nf[i*16+9]+=nf.nf[i*16+9]*toto;
	  res.nf[i*16+10]+=nf.nf[i*16+10]*toto;
	  res.nf[i*16+11]+=nf.nf[i*16+11]*toto;
	  res.nf[i*16+12]+=nf.nf[i*16+12]*toto;
	  res.nf[i*16+13]+=nf.nf[i*16+13]*toto;
	  res.nf[i*16+14]+=nf.nf[i*16+14]*toto;
	  res.nf[i*16+15]+=nf.nf[i*16+15]*toto;
	 }
	
      }
  i*=16;
  for(register unsigned int j=0;j<tmp;j++)
    res.nf[i+j]+=nf.nf[i+j]*toto;
}
//renvoit l'indice du monome x_i*m_j
template<typename mon,typename Base, typename typserv>
int indice2(int i,int j,const Base & b, typserv & serv)
{
 int res=-1;
 mon tmp;
 serv.int2mon(j,tmp);
 tmp*=mon(i,1);//on suppose qd meme que j correspond a qqchose
 //cout<<"indice2 IsinB("<<mon(i,1)*tmp<<",b) "<<IsinB(mon(i,1)*tmp,b)<<endl;
 if(IsinB(tmp,b))
   {
     res=serv.mon2int(tmp);
     //  cout<<"le monome "<<mon(i,1)*tmp<<" l'indice "<<res<<endl;
   }
 return res;
}

//on lui donne l'ensemble des formes normales, dump, l'indice de b(cf ci dessus)
// le numero de la variable par laquelle on multiplie
//et elle renvoie un pol(cf def du type) sur la forme normale de var*m_{indmon}
 
template<typename typpol,typename typdump,typename Base, typename typserv>
typpol nf(int var ,int indmon,const typdump &dump,const Base & b,
	  typserv & serv)
{
  //on cherche dans dump...
  //a optimiser plus tard
  typedef typename typdump::value_type dumpstruct;
  typedef typpol pol;
  typedef typename pol::monom_t mon;
  pol res;
  res.nf=NULL;
  res.size=-1;
  mon tmpmon;//=mon(1,var)*int2mon<mon>(indmon);
  int deg=0;//=tmpmon.GetDegree()+1;
  typename typdump::const_iterator iter;
  serv.int2mon(indmon,tmpmon);
  deg=degree(tmpmon)+1;
  //cout<<"mon("<<var<<",1) "<<mon(var,1)<<" et deg "<<deg<<endl;
  tmpmon*=mon(var,1);
   for(iter=dump.begin();
       (iter!=dump.end()) && (iter->k!=deg);iter++);
   //    cout<<"iter-k "<<iter->k<<endl;
   // if(iter!=dump.end()) cout<<"iter->k en sortie "<<iter->k<<" et deg "<<deg<<endl;
  //cout<<"valuer a la sortie "<<(--iter)++->k<<endl;
   // cout<<"iter!=dump.end() "<<(iter!=dump.end())
   //   <<" dump.empty() "<<dump.empty()<<endl;
  if(iter!=dump.end())//on cherche pas n'importe quoi qd meme
    {
      int i;
      for(i=0;i<iter->size;i++)
	{
	  //  cout<<"dans nf iter->nf[i].ind "<<iter->nf[i].ind<<endl;
	  if(iter->nf[i].ind.rep()==tmpmon.rep())
	    break;
	}
      if(i!=iter->size)
	//Tue Dec  4 16:39:25 MET 2001
	//	densify(iter->nf[i],res);

	res=(iter->nf[i]);
    }
  //cout<<"la gueule de res "<<res<<endl;
  //if (res!=NULL) cout<<"suite de res "<<res->ind<<" "<<res->nf<<endl;
  return res;
}

//effectue la multiplication du pol T par la variable x_i
template<typename typpol,typename typdump,typename Base,typename mon, 
  typename typserv> 
typpol inline mult(int i,const typpol &pol,const typdump &dump,
		   const Base &b,mon **exce,int &exsize, typserv & serv)
{
  typedef typename typpol::coeff_t coeff;
  static const mon monzero=mon(0);
  //static int *taillexe=NULL;
  typpol ret;
  coeff *res=NULL;
  // res=(coeff*)calloc(pol.size,sizeof(coeff));
  //ret.size=pol.size;
  ret.nf=res;
  (*exce)=(mon*)MAC_REV_MALLOC<mon>((pol.size+1)*sizeof(mon));
  int noquo=0,nbmyplus=0,maxind=0;
  //cout<<"pol.ind "<<pol.ind<<endl;
  for(int j=0;j<pol.size;++j)
    if (!Iszero(pol.nf[j]))
     {
       int stockindice2=indice2<mon>(i,j,b,serv);
       //   cout<<"stockindice2 "<<stockindice2<<" pol.size "<<
       //pol.size<<" J "<<j<<endl;
       if (maxind<stockindice2)
	 maxind=stockindice2;
     }
  //cout<<"maxind "<<maxind<<endl;
  ret.nf=(coeff*)MAC_REV_MALLOC<coeff>((maxind+1)*sizeof(coeff));
  for(int j=0;j<=maxind;j++)
    ((coeff*)(ret.nf))[j]=0;
  ret.size=maxind+1;
  //ret.nf=res;
  for (int j=0;j<pol.size;++j)
    {
      const coeff stockpol=pol.nf[j];
      mon tmp; 
      serv.int2mon(j,tmp);
      //  cout<<" dans mult j"<<j<<"et le coeff a cet indice "<<stockpol<<endl;
      //cout<<"le monome que je regare est "<<tmp*mon(i,1)<<endl;
      if (!Iszero(stockpol))//ici introduire les epsilon si on veut gagner un peu..
     {// pas necessaire pour les epsilon parce que ca marche !!
      int stockindice2=indice2<mon>(i,j,b,serv);
      //cout<<"stockindice2 avant le test "<<stockindice2<<endl;
      if (stockindice2>=0) 
	{
	  ret.nf[stockindice2]+=stockpol;
	  //  cout<<"stocvkindice2 "<<stockindice2<<" pol.size "<<
	  //   pol.size<<" J "<<j<<endl;
	}
      else  
	{
	  //
	  //
	  //
	  //
	  typename typpol::monom_t tmpmon;
	  //cout<<" j vaut dans mult "<<j<<endl;
	  serv.int2mon(j,tmpmon);
	  // cout<<"et int2mon de ce j vaut "<<tmpmon<<endl;
	  tmpmon*=mon(i,1);
	  
	  //cout<<"je recherche la nf de "<<tmpmon<<endl;
	  typpol tmp;
	  //tmp.ind=monzero;
	  tmp=nf<typpol>(i,j,dump,b,serv);
	  //cout<<"tmpind  vaut alors "<<tmp.ind<<endl;
	  //
	  //
	  //
	  if (tmp.size!=-1)
	  {
	    nbmyplus++;
	    //cout<<"tmp "<<tmp<<endl;
	    //cout<<"tmp.ind "<<tmp->ind<<endl;
	    //cout<<"tmp.nf "<<tmp->nf<<endl;
	    my_plus(ret,tmp,stockpol);
	    //Tue Dec 4
	    //MAC_REV_FREE<mon>(tmp.nf,tmp.size*sizeof(coeff));
	    //res=ret.nf;//car my_plus realloc la chose
	  }
	  else  
	    {
	      mon tmpmon;
	      (*exce)[noquo]=mon(i,1);
	      serv.int2mon(j,tmpmon);
	      //cout<<"je rajoute ala fin listes exceed "<<tmpmon*mon(i,1)<<endl;
	      (*exce)[noquo]*=tmpmon;//int2mon<mon>(j);
	      (*exce)[noquo]*=stockpol;
	      ++noquo;
	    };
	  
	  //dans plus qd nf renvois NULL il faut rien faire!!!!
	}
      }
    }
  //(*exce)=(mon*)MAC_REV_REALLOC<mon>((*exce),pol.size*sizeof(mon)
  //			       ,(noquo)*sizeof(mon));
// cout<<"fin"<<endl;
  
  //cout<<"pol.ind a la fin "<<pol.ind<<endl;
  ret.ind=pol.ind;
  ret.ind*=mon(i,1);
  //cout<<"ret.ind apres mult "<<ret.ind<<endl;
  //Fri Nov 16 14:42:34 MET 2001
  (*exce)[noquo++]=ret.ind;
  //cout<<"apres affectation "<<(*exce)[noquo-1]<<endl;
  exsize=noquo;
  //cout<<"pol.size "<<pol.size<<endl;
  (*exce)=(mon*)MAC_REV_REALLOC<mon>((*exce),(pol.size+1)*sizeof(mon)
			       ,(noquo)*sizeof(mon));
  //Fri Nov 16 14:42:34 MET 2001
  //cout<<"avant setcoeff() "<<(*exce)[noquo-1]<<endl;
  ret.ind.setcoeff(noquo+1);//*=mon(noquo+1);
  //cout<<"apres setcoeff() "<<(*exce)[noquo-1]<<endl;
  //cout<<"noquo a la fin de mult "<<noquo<<endl;
  //  ret.nf=res;
  return ret;
}

// renvoit mon/x_i .... mais suppose qu'on ne fait pas n'importe quoi
 template <typename Mon,typename Base>
Mon my_divmon(const Mon &mon,int i,const Base& b)
{
  Mon res(1);
  for(int j=0;j<b.nbvar();j++)
    if(i==j)
      {
	//if(mon[j]>1)
	res*=Mon(j,mon[j]-1);
      }
     else 
       {
	 res*=Mon(j,mon[j]);
       }
  return res;
}

template<typename typmon,typename Base>
int GoodDir(const typmon &m,int i, const Base & b)
{
  int res=0;
  typmon tmpm=m*typmon(i,1);
  //cout<<"dans GoodDir les monomes "<<m<<"********"<<typmon(i,1)<<endl;
  //cout<<"b.nbvar() "<<b.nbvar()<<endl;
  for(int j=0;j<b.nbvar();j++)
    {
      if(tmpm[j]>=1)
	if(IsinB(my_divmon(tmpm,j,b),b)) {res=1;break;};
    }
  //cout<<" le verdict de GoodDir "<<res<<endl;
  return res;
}

//fonct\ion adhoc qui merge une liste de polyalp avec une liste de pol
//en cours de calcul cad liste de pol + liste excedentaire 
template<typename typPk,typename typP,typename typexceed,
  typename typsize ,typename Base, typename typserv>
void conv_merge(typPk &Pk,typP &P,typexceed &ex,typsize &sizeex,
		const Base &b, typserv & serv)
{
  typedef typename typP::value_type polalp;
  typedef typename polalp::order_t ord;
  typedef typename polalp::monom_t mon;
  typedef typename typPk::value_type pol;
  typedef typename pol::coeff_t coeff;
  coeff * tabcoeff=NULL;
  int * tabindices=NULL;
  int tabsize=0;
//#define DEBUG
#ifdef DEBUG
  cout<<"entree dans conv_merge"<<endl;
  for(typename Base::const_iterator p=b.begin();p!=b.end();p++)
    {
      for(int i=0;i<p->taille1;i++)
	{
	  cout<<"p.accept[i] "<<p->accept[i]<<endl;
	}
      for(int i=0;i<p->taille2;i++)
	{
	  cout<<"p.refuse[i] "<<p->refuse[i]<<endl;
	}
    }
  cout<<"p-taille2 "<<b.begin()->taille2<<" "<<b.begin()->taille2-1<<endl;
  cout<<"I=ideal("<<endl;
  {
    typename Base::const_iterator p=b.begin();
    for(int i=0;i<p->taille2-1;i++)
	{
	  cout<<p->refuse[i]<<","<<endl;
	}
    if(p->taille2>=1) cout<<p->refuse[p->taille2-1]<<")"<<endl;
  }
#endif //DEBUG
//#undef DEBUG
  for(typename typP::iterator iter=P.begin();iter!=P.end();iter++)
    {
      //cout<<"dans for"<<endl;
      pol tmp;
      int max=0;
      tmp.ind=mon(1);
      
      tabcoeff=(coeff*)MAC_REV_REALLOC<coeff>((void*)tabcoeff,
					      tabsize*sizeof(coeff),
					      iter->size()*sizeof(coeff));
      tabindices=(int*)realloc((void*)tabindices,iter->size()*sizeof(int));
      tabsize=iter->size();
      //ici il faudrait un type template
      for(int i=0;i<tabsize;i++)
	{
	  tabcoeff[i]=0;
	}
      //memset((void*)tabcoeff,0,tabsize*sizeof(coeff));
      //ici aussi
      mon * tmpex=NULL;
      tmpex=(mon*)MAC_REV_REALLOC<mon>((void*)tmpex,0,tabsize*sizeof(mon));
      {
	int comp=0;int i=0;
	for(typename polalp::iterator iterpol=iter->begin();
	    iterpol!=iter->end();iterpol++)
	  {
	    if(!Iszero(iterpol->coeff()))
	    {		    
		//    cout<<"IsinB("<<*iterpol<<","<<"b)"<<endl;
	    if (IsinB(*iterpol,b))
	      {
		tabcoeff[i]=iterpol->coeff();
		tabindices[i]=serv.mon2int(*iterpol);
		if(tabindices[i]>max) max=tabindices[i];
		i++;
	      }
	    else
	      {	
		//cout<<"y en a un qu'est pas dans B "<<*iterpol<<endl;
		if(!Iszero(iterpol->coeff()))
		   tmpex[comp++]=*iterpol;
	      }
	    }
	   }
	tmpex=(mon*)MAC_REV_REALLOC<mon>((void*)tmpex,tabsize*sizeof(mon)
					 ,(comp+1)*sizeof(mon));
	tmp.size=max+1;
	tmp.nf=(coeff*)MAC_REV_MALLOC<coeff>(tmp.size*sizeof(coeff));
	for(int j=0;j<tmp.size;j++)
	  tmp.nf[j]=0;
	for(int j=0;j<i;j++)
	  tmp.nf[tabindices[j]]=tabcoeff[j];
	tmp.ind=mon(comp+1);
	Pk.push_back(tmp);
	ex.push_back(tmpex);
	sizeex.push_back(comp);
      }
    }
  MAC_REV_FREE<coeff>(tabcoeff,tabsize*sizeof(coeff));
  free(tabindices);
}

//member ne test que les exposant pas les coefficients
template<typename typMk>
int member(const typMk & tmpMk,const typename typMk::value_type mon)
{
  int res=0;
  for(typename typMk::const_iterator iter=tmpMk.begin();
      iter!=tmpMk.end();iter++)
    if(iter->rep()==mon.rep()) {res=1;break;}
  return res;
}

template<typename typP,typename typPk, typename typMk,typename typexceed
,typename typsize,typename typdump,typename Base, typename typserv>
void putingoodshape(const typP & P,typPk &workvect,const typMk & tmpMk
		    ,typexceed & exceed,typsize & sizeex
		    ,const typdump & dump,const Base & b, typserv & serv)
{
  typedef typename typPk::value_type pol;
  typedef typename pol::coeff_t coeff;
  typedef typename typexceed::value_type typex;
  typedef typename typMk::value_type mon;
  typedef typename typP::value_type polyalp;
  typP tobeproj;
  for(typename typPk::iterator iter=workvect.begin();
      iter!=workvect.end();iter++)
    {
      int sizeexceed=0;
      polyalp projpol(0);
      typex tmpex=(mon*)MAC_REV_MALLOC<mon>(sizeof(mon)*tmpMk.size());
      for(unsigned int i=0;i<tmpMk.size();i++)
	tmpex[i]=mon(0);
      //      cout<<"proj pol au debaut "<<projpol<<endl;
      for(int i=0;i<iter->size;i++)
	{
	  if(!Iszero(iter->nf[i]))
	    {
	      mon tmpmon;
	      serv.int2mon(i,tmpmon);
	      if(!IsinB(tmpmon,b))
		{
		  if(member(tmpMk,tmpmon)) 
		    {
		      tmpex[sizeexceed++]=tmpmon*iter->nf[i];
		      iter->nf[i]=0;
		    }
		  else
		    {
		      projpol+=tmpmon*iter->nf[i];
		      iter->nf[i]=0;
		    };
		}
	    }
	}
      if(degree(iter->ind)>0)
	tmpex[sizeexceed++]=iter->ind;
      exceed.push_back(tmpex);
      tobeproj.push_back(projpol);
      //cout<<"tobeproj avant push back "<<endl<<projpol<<endl;
      //cout<<"sizeexced pushbacke "<<sizeexceed<<endl;
      sizeex.push_back(sizeexceed);
    }
  //bon on a isole les monomes a projeter 
  proj(tobeproj,dump,b,serv);
  {
    typename typPk::iterator iter=workvect.begin();
    typename typexceed::iterator iterex=exceed.begin(); 
    typename typsize::iterator itersize=sizeex.begin();
    for(typename typP::iterator iterproj=tobeproj.begin();
	iterproj!=tobeproj.end();iterproj++,iter++,iterex++,itersize++)
      {
	//	cout<<"*itersize "<<(*itersize)<<" et tmpMk.size() "<<tmpMk.size()<<endl; 	
	int maxend=iter->size-1;
	for(typename polyalp::iterator iterpol=iterproj->begin();
	    iterpol!=iterproj->end();iterpol++)
	  {
	    if(IsinB(*iterpol,b)&&maxend<serv.mon2int(*iterpol))
	      maxend=serv.mon2int(*iterpol);
	  }
	    iter->nf=(coeff*)MAC_REV_REALLOC<coeff>(iter->nf
						    ,iter->size*sizeof(coeff)
						    ,(maxend+1)*sizeof(coeff));
	    for(int i=iter->size;i<=maxend;i++)
	      iter->nf[i]=0;
	    for(typename polyalp::iterator iterpol=iterproj->begin();
		  iterpol!=iterproj->end();iterpol++)
	      {
		if(IsinB(*iterpol,b))
		  {
		    iter->nf[serv.mon2int(*iterpol)]+=iterpol->coeff();
		  }
		else
		  {
		    int i=0;
		    
		    for(;(i<(*itersize))&&
			  ((*iterex)[i].rep()!=iterpol->rep());i++);
		    if(i<(*itersize))
		      {
			(*iterex)[i]+=*iterpol;
		      }
		    else 
		      {
			(*iterex)[(*itersize)++]=*iterpol;
			//	cout<<"rajoute "<<*iterpol<<" a la pos "<<*itersize<<endl;
		      }
		  }
	      }
	    *iterex=(typex)MAC_REV_REALLOC<mon>(*iterex,tmpMk.size()*sizeof(mon)
						,(*itersize)*sizeof(mon));
	iter->size=maxend+1;
	//cout<<"relecture  itersize "<<*itersize<<endl;
      }
    
  }
}

template<typename typMat,typename typPk,typename typP,
  typename typMk,typename Base,typename typdump,typename typrecall, 
  typename typserv>
int newPkMkMatrixof(typMat &mat,typPk &Pk, typP &P,typMk &Mk,
		    int &k,Base &b, typdump &dump,typrecall &recall, 
		    typserv & serv)
		    //,typMk &Spoldejavu)
  //template<typename typMat,typename typPk,typename typP,
  // typename typMk,typename Base,typename typdump>
  //int newPkMkMatrixof(typMat &mat,typPk &Pk,const typP &P,typMk &Mk,
  //	     int &k,Base &b, typdump &dump)
{
  typedef typename typMk::value_type mon;
  typedef typename typP::value_type::order_t ord;
  typedef typename typPk::value_type pol;
  typedef typename pol::coeff_t coeff;
  typedef typename typP::value_type polyalp;
  typPk tmpPk,workvect;
  typMk tmpMk;
  std::list<mon *> exceed;
  std::list<int> sizeexceed;
  int nbproj=0,flagdoplus=1;
  //prise en compte des pol pas encore introduits
  //cout<<endl;
#ifdef TRACE_PROG
  cerr<<k<<" ";
#endif
  //cout<<"crochet"<<endl;
  typP ttmpP=Crochet(P,k+1);//
  typrecall verytmp=Crochet(recall,k+1,serv);//verytmpP 24/08/2001
  recall.erase(recall.begin(),recall.end());

  if (!ttmpP.empty()) 
    {
      int tmpdeg;
      // cout<<"proj "<<endl;
      proj(ttmpP,dump,b,serv);
      //  cout<<"selectnozero"<<endl;
      selectnozero(ttmpP);

      nbproj=ttmpP.size();
      if (!ttmpP.empty())
	{
	  //cout<<"apres select non zero "<<ttmpP.size()<<endl;
	  tmpdeg=minmaxdegP(ttmpP,tmpdeg);
	  //cout<<"apres minmax deg "<<tmpdeg<<" "<<k<<endl;
	  //cout<<"un tel pol "<<std::endl<<ttmpP.front()<<endl;
	  if(tmpdeg<k+1)
	    {
	      flagdoplus=0;
	      // cout<<"un des pol de pretendu degre le bon se reduit mal"<<endl;
	      //en fait a un polynome de degre inferieur
	      typPk tmpconv;
	      //cout<<"recover"<<endl;
	      recover(tmpPk,Mk,dump,tmpdeg);
	      //Listedejafait(Mk,Spoldejavu);

	      recall=verytmp;
	      forget(b,dump,tmpdeg,recall);
	      //  cout<<"coucou c ici que je comp-ress"<<endl;
	      // for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
	      //cout<<invconv<typename typP::value_type>(*iter,serv)<<endl;
	      serv.compress(tmpPk,dump,b,tmpdeg);
	      verytmp.erase(verytmp.begin(),verytmp.end());


	      
	      //forget(b,dump,tmpdeg);
	      
	      ttmpP=Crochet(ttmpP,tmpdeg);
	      nbproj=ttmpP.size();

	      //Pk.pop_back();//on elimine de Pk le pol de proj choisi
	      //pour se ramner au cas ou proj != 0 et P ok
	      Mk.erase(Mk.begin(),Mk.end());
	      for (typename typPk::iterator iterpk=tmpPk.begin();
		   iterpk!=tmpPk.end();iterpk++)
		{
		  // cout<<"iterpk->ind "<<iterpk->ind
		  //    <<"et Isinb(iterpk-ind,b) "<<IsinB(iterpk->ind,b)<<endl;
		  if (IsinB(iterpk->ind,b))
		    {
		      for(typename Base::iterator iterb=b.begin()
			    ;iterb!=b.end();iterb++)
			{
			  iterb->refuse=(mon*)MAC_REV_REALLOC<mon>
			    (iterb->refuse,(iterb->taille2)*sizeof(mon),
			     (iterb->taille2+1)*sizeof(mon));
			  iterb->refuse[iterb->taille2]=iterpk->ind;
			  iterb->refuse[iterb->taille2].coeff()=(1);
			  iterb->taille2++;
			}
		    }
		}
	      for(typename typPk::iterator iter=tmpPk.begin()
		    ;iter!=tmpPk.end();iter++)
		{
		  mon *tmp=(mon*)MAC_REV_MALLOC<mon>(sizeof(mon));
		  *tmp=iter->ind;
		  tmpMk.push_back(*tmp);
		  exceed.push_back(tmp);
		  sizeexceed.push_back(1);
		  // 	  cout<<"pour Mk iter->ind "<<iter->ind<<endl;
		}
	      //cout<<"ici tmpdeg "<<tmpdeg<<endl;
	      		//on vient de chuter de 
	      //degre et on a reconstitue les bons mk et pk
	      k=tmpdeg-1;
	      if (k==-1) return 0;
	      //Dump(Pk,dump);
	    }
	}
    }
  if(flagdoplus)
    {
      //list<mon> dejavu;
      //consttruction des pol ord sup
      for(int i=0;i<b.nbvar();i++)
	{
          for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
	    {
	      //cout<<"avant gooddir l'ind "<<iter->ind<<endl;
	      if(GoodDir((*iter).ind,i,b))
		{
		  mon tmpmon=iter->ind*mon(i,1);
		  tmpmon.coeff()=(1);
		  if(!member(tmpMk,tmpmon))
		    {
		      typename typrecall::iterator iterrec;
		      tmpMk.push_back(tmpmon);
#if 1	      
		      for(iterrec=verytmp.begin();
			  (iterrec!=verytmp.end())
			    &&(!(iterrec->ind.rep()==tmpmon.rep()));
			  iterrec++);
			if(iterrec!=verytmp.end())
			  {
			    workvect.push_back(*iterrec);
			    verytmp.erase(iterrec);
			    continue;
			  }
#endif
			//cout<<"aprfes gooddir"<<endl;
		      mon * tmp=NULL;
		      int tmpsize;
		      //cout<<"avant mult"<<endl;
		      tmpPk.push_back(mult(i,*iter,dump,b,&tmp,tmpsize,serv));
		      //attention le coefficient de ind est la taille de 
		      // l'exceed correspondant
		      //      cout<<"apres mult"<<endl;
		      exceed.push_back(tmp);
		      sizeexceed.push_back(tmpsize);
		    }
		}
	    }
	}
      //      recall=verytmp;
    }
  //  cout<<"tmpPK.size "<<tmpPk.size()<<endl;
  //Constructyion de pol terminee
  //cout<<"ttmpP.size "<<ttmpP.size()<<endl;
  //cout<<"avant conv merge"<<endl;
#if 1
  {  
#if 1
    for(typename typPk::iterator iter=verytmp.begin();iter!=verytmp.end();iter++)
      {
	int good=0;
	for(int i=0;i<b.nbvar();i++)
	  {
	    if((iter->ind[i]>0)&&(IsinB(my_divmon(iter->ind,i,b),b)))
	    {
	      good=1;break;
	    }
	  }
	if(good)
	  { 
	    //NON il faut virer les ind de B avant de les pushbacker
	    if(serv.mon2int(iter->ind)>=iter->size)
	      {
		iter->nf=(coeff*)MAC_REV_REALLOC<coeff>(iter->nf,
				     iter->size*sizeof(coeff)
				     ,(serv.mon2int(iter->ind)+1)*sizeof(coeff));
		}
	    iter->nf[serv.mon2int(iter->ind)]=iter->ind.coeff();
	    iter->ind=mon(0);
	    workvect.push_back(*iter);
	    verytmp.erase(iter--);
	  }
      }
#endif
    //recall=verytmp;
	std::list<mon*> tmpexceed;
    std::list<int> tmpsizeex;
    putingoodshape(P,workvect,tmpMk,tmpexceed,tmpsizeex,dump,b,serv);
    my_merge(tmpPk,workvect);
    my_merge(exceed,tmpexceed);
    my_merge(sizeexceed,tmpsizeex);
  }
#endif
  conv_merge(tmpPk,ttmpP,exceed,sizeexceed,b,serv);
  //construction de la matrice maintenant
  //positionnement des pointeurs de matrices pour gagner en tps
   {
     int nnz=0;
     for(std::list<int>::iterator iter=sizeexceed.begin();iter!=sizeexceed.end()
	   ;iter++)
       {
	 nnz+=*iter;
       
      }
//#define DEBUG
#ifdef DEBUG
     typename typPk::iterator tmpiter=tmpPk.begin();
	 std::list<int>::iterator itersize=sizeexceed.begin();
     for(typename list<mon*>::iterator iter=exceed.begin();iter!=exceed.end()
      ;tmpiter++,iter++,itersize++)
      {
		  std::cout<<"pour un exceeed la taille attendue est "
	    <<*itersize<<std::endl;
	for(int i=0;*itersize>i;i++)//;tmpiter->ind.GetCoeff()>i+1;i++)
	  {
		  std::cout<<"le gus que je regarde "<<(*iter)[i]<<std::endl;
	    if(!member(tmpMk,(*iter)[i]))
	     {
	      
	       for(int j=0;j<b.nbvar();j++)
		   std::cout<<"x"<<j<<"^"<<(*iter)[i][j]<<" ";
	       std::cout<<std::endl;
	       std::cout<<"g pas trouve "<<(*iter)[i]<<std::endl;
	       std::cout<<"dans ce pol "<<invconv<polyalp>(*tmpiter,serv)<<std::endl;
	       std::cout<<"l'ind "<<tmpiter->ind<<std::endl;
	       exit(-10);
	     }
	  }
     }
#endif
//     #undef DEBUG
     //cout<<"nnz of matrix "<<nnz<<endl;
     //en general la matrice est rectangulaire
     void * toto=MAC_REV_MALLOC<coeff>(nnz*sizeof(typename typMat::coeff_t));
     //+nnz*sizeof(int)+((*mat)->ncol+1)*sizeof(int));
     if (mat.nzval!=NULL) MAC_REV_FREE<typename typMat::coeff_t>
			    (mat.nzval,mat.nnz
			     *sizeof(typename typMat::coeff_t));
     mat.nrow=tmpPk.size();
     mat.ncol=tmpMk.size();
     mat.nnz=nnz;
     mat.nzval=toto;
     for(int i=0;i<nnz;i++)
       ((typename typMat::coeff_t*)mat.nzval)[i]=(coeff)1000000000000.0;
     // mstore->rowind=(int*)((double*)toto+nnz);
     if(mat.rowind!=NULL) free(mat.rowind);
     mat.rowind=(int*)malloc(nnz*sizeof(int));
     //mstore->colptr=(int*)(mstore->rowind+nnz);//
     if(mat.colptr!=NULL) free(mat.colptr);
     mat.colptr=(int*)malloc((mat.ncol+1)*sizeof(int));
   }
   //cout<<"matrix of size "<<mat.nrow<<"x"<<mat.ncol<<endl;
   //matrice cree rest plus qu'a ecrire dedans ca
   {
     int *ncol=(int*)calloc(mat.ncol,sizeof(int));
     //memset((void*)ncol,0,(*mat)->ncol*sizeof(int));
	 std::map<mon,int,ord> mapint;
     typename typMk::iterator itermk=tmpMk.begin();
     typename typPk::iterator iterpk=tmpPk.begin();
     typename std::list<mon*>::iterator iterex=exceed.begin();
	 std::list<int>::iterator itersize=sizeexceed.begin();
     int line_num=0;
     for(int i=0;itermk!=tmpMk.end();i++,itermk++)
       {
	 mapint[*itermk]=i;
       } 
     iterpk=tmpPk.begin();
     for(;iterpk!=tmpPk.end();iterpk++,iterex++,itersize++,line_num++)
       {
	 // if(iterpk->ind.GetDegree()>0) 
	 //  {
	 //    mon tmpmon=iterpk->ind;
	 //    tmpmon.SetCoeff(1);
	 //   ncol[mapint[tmpmon]]++;
	     //	     cout<<"on est a la ligne "<<line_num<<" ai augmente "<<mapint[(iterpk->ind*(1/iterpk->ind.GetCoeff()))]<<" a cause de son monome dom "<<endl;
	     // cout<<"le voila "<<(iterpk->ind*(1/iterpk->ind.GetCoeff()))<<endl;
	 //}
	{
	  // coeff tmpcoeff=(iterpk->ind).GetCoeff()-(coeff)1;
	 for(int i=0;*itersize>i;i++)
	   {
	     //cout<<"iterpk icici ->GetCoeff()"<<iterpk->ind.GetCoeff()<<endl;
	     if (mapint.count((*iterex)[i]))
	       {
		 ++ncol[mapint[(*iterex)[i]]];
		 // cout<<" ai augmente "<<mapint[(*iterex)[i]]<<"a cause de iterex "<<endl;
	       }
	   }
	}
       }
     //rajoute le 23/01/2001
     //enleve le 17.05/2001
     //     for(int i=mat.nrow-nbproj;i<mat.nrow;i++)
     // ncol[i]--;
     //fin rajout c pour prendre en compte que lors de 
     //de la proj le monome de tete se trouve dans exceed
     //fin enlevement
     typename typMat::coeff_t* nzval=(typename typMat::coeff_t*)mat.nzval;
     int *rowind=mat.rowind;
     int *colptr=mat.colptr;
    //mise  en place des colptr
    *colptr=0;
    for(int i=0;i<mat.ncol-1;i++)
      {
	colptr[i+1]=colptr[i]+ncol[i];
	//cout<<"nb element colonne "<<i<<" "<<ncol[i]<<endl;
	//cout<<"les valeurs de debut de colonne "<<8*colptr[i+1]<<endl;
      }
    colptr[mat.ncol]=mat.nnz;
    //cout<<"mat.nnz "<<mat.nnz<<" "<<mat.nnz*8<<endl;
    //fin mise en place
    //la on fait des manip symboliques pour savoir ou ecrire 
    //les coeffs de chaques colonnes ca evite d'avoir a les
    //recopier 50000 fois pour construire la matrice 
    //c bcp plus rapide
    itermk=tmpMk.begin();
    iterpk=tmpPk.begin();
    iterex=exceed.begin();
    itersize=sizeexceed.begin();
    line_num=0;
    //cout<<"nbproj "<<nbproj<<endl;
    for(;0&&(line_num < (int)(tmpPk.size()-nbproj));
	iterpk++,iterex++,itersize++,line_num++)
      //les polynome projette sont foutut au bout de la liste!!
      //d'ou le tmpPk.size()-nbproj
      {
	mon tmpmon=iterpk->ind;
	tmpmon.setcoeff(1);
	//const unsigned int tmpplus=line_num+1,tmp=line_num;
	const unsigned int tmpplus
	  =mapint[tmpmon]+1,tmp=tmpplus-1;
	//	cout<<"ici line_num"<<line_num<<" le mon dom est col "<<tmp<<endl;
	//ici couille car le ind n'est pas forcement le mon diag
	nzval[colptr[tmpplus]-ncol[tmp]]=1;
	//fin couille changer un truc
	//	cout<<"mat.nnz "<<mat.nnz<<endl;
	//cout<<"colptr[...]"<<colptr[tmpplus]<<endl;
	//cout<<"ncol[....]"<<ncol[tmp]<<endl;
	//cout<<"1 a la pos "<<colptr[tmpplus]-ncol[tmp]<<endl;
	rowind[colptr[tmpplus]-ncol[tmp]]=line_num;
	//cout<<"1 a la ligne "<<rowind[colptr[tmpplus]-ncol[tmp]]<<endl;
	ncol[tmp]--;
	{
	  //coeff tmpcoeff=iterpk->ind.GetCoeff()-(coeff)1;
	  for(int i=0;*itersize>i;i++)
	  {
	    const coeff stock=(*iterex)[i].coeff();
	    (*iterex)[i].setcoeff(1);
	    const unsigned int tmpplusex=mapint[(*iterex)[i]]+1;
	    const unsigned int tmpex=mapint[(*iterex)[i]];
	    nzval[colptr[tmpplusex]-ncol[tmpex]]
	      =stock;
	    rowind[colptr[tmpplusex]-ncol[tmpex]]=line_num; 
	    ncol[tmpex]--;
	    //    cout<<"valeur de ncol["<<tmpex<<"] "<<ncol[tmpex]<<endl;
	  }
	}
	MAC_REV_FREE<mon>(*iterex,*itersize*sizeof(mon));
      }
    for(;(iterpk!=tmpPk.end());iterpk++,iterex++,itersize++,line_num++)
      {
	//const unsigned int tmpplus=line_num+1,tmp=line_num;
	{
	  //coeff tmpcoeff=iterpk->ind.coeff()-(coeff)1;
	  for(int i=0;*itersize>i;i++)
	  {
	    const coeff stock=(*iterex)[i].coeff();
	    (*iterex)[i].setcoeff(1);
	    const unsigned int tmpplusex=mapint[(*iterex)[i]]+1;
	    const unsigned int tmpex=mapint[(*iterex)[i]];
	    nzval[colptr[tmpplusex]-ncol[tmpex]]
	      =stock;
	    rowind[colptr[tmpplusex]-ncol[tmpex]]=line_num; 
	    ncol[tmpex]--;
	  }
	}
	MAC_REV_FREE<mon>(*iterex,*itersize*sizeof(mon));
	//free(*iterex);
      }
    free(ncol);
  }
   //!!! ATTENTION C VITAL DE PAS FAIRE N'IMPORTE QUOI AVEC LES IND
   for(typename typPk::iterator iterpk=tmpPk.begin()
	 ;iterpk!=tmpPk.end();iterpk++)
     iterpk->ind.setcoeff(1);
     //iterpk->ind*=1/iterpk->ind.coeff();
   //  cout<<"la matrice dans newpkmkmatrixof"<<endl;
   //cout<<" nombre de non zero "<<mat.nnz<<endl;
   // affdebug(mat);
   //cout<<"le colptr "<<endl;
   //for(int i=0;i<mat.ncol;i++)
   // cout<<mat.colptr[i]<<" "<<endl;
   //   cout<<"les indices de lignes et le nnz"<<endl;
   //for(int i=0;i<mat.nnz;i++)
   //  cout<<mat.rowind[i]<<" "<<((typename typMat::coeff_t*)mat.nzval)[i]<<endl;
   //cout<<"fin matrice"<<endl;
   Pk.swap(tmpPk);
   Mk.swap(tmpMk);
   
   //  for(int i=0;i<mat.nnz;i++)
   // cout<<"coeff mat "<<((typename typMat::coeff_t*)mat.nzval)[i]<<" et i "<<i<<endl; 
   return flagdoplus;
}
//newpkmkmatrixof termine reste plus qu'a tester .... ;-(

template<typename typdump,typename mon,typename pol>
void findcorresppol(const mon & m,const typdump &dump,pol &res)
{
  int i,d=degree(m);
  typename typdump::const_iterator iter=dump.begin();
  for(;(iter!=dump.end())&&(iter->k!=d);iter++);
  //localise la dump struct de bon degre
  if(iter!=dump.end())
    {
      for(i=0;(i<iter->size)&&(iter->nf[i].ind.rep()!=m.rep());i++);
      //cout<<"monomes passe en revue pour chercher "<<m<<" : "<<iter->nf[i].ind<<endl;;
      //trouve dans la dump struct le pol qui marche
      if (i<iter->size)//estce que je connais?
	//oui super
	{
	  //cout<<"g trouve un gus qui convient"<<endl;
	  //for(int j=0;j<iter->nf[i].size;j++)
	  // cout<<"et ses coeff sont "<<iter->nf[i].nf[j]<<endl;
	  //Tue Dec  4 16:12:10 MET 2001
	  //densify(iter->nf[i],res);}
	  //Tue Dec  4 16:12:10 MET 2001
	  res=iter->nf[i];}
      else {
	//non ben alors il se reecrit en lui meme
	res.ind=mon(0);//m*(1/m.coeff());
	res.size=-1;
	res.nf=NULL;
      }
    }
  return;
}
template<typename iterator, typename mon,typename Base>
void varmult(iterator iter1,iterator iter2,mon &var1, mon &var2,const Base &b)
{
  for(int i=0;i<b.nbvar();i++)
    {
      if(iter1->ind[i]>iter2->ind[i])
	var2=mon(i,1);
      if(iter2->ind[i]>iter1->ind[i])
	var1=mon(i,1);
    }
}
template <typename mon,typename pol, typename typdump,typename Base, 
  typename typserv>
pol halfred(const mon &targetind, const pol & p, const typdump & dump
	      , const Base & b, typserv & serv)
{
  typedef typename pol::coeff_t coeff;
  static const mon monzero=mon(0);
  static const typename pol::coeff_t zero(0);
  int *place=(int*)MAC_REV_MALLOC<int>(p.size*sizeof(int));
  pol res;
  mon varref;
  int maxref=0;
  for(int i=0;i<b.nbvar();i++)
    {
      varref=mon(i,1); 
      if(targetind[i]>p.ind[i])
	break;
    }
  //cout<<"target "<<targetind<<" et ind "<<p.ind<<" et var "<<varref<<endl;
  for(int i=0;i<p.size;i++)
    {
      if(p.nf[i]!=zero)
	{
	  int indtmpmon;
	  mon tmpmon;
	  serv.int2mon(i,tmpmon);
	  tmpmon*=varref;
	  if(IsinB(tmpmon,b))
	    {
	      indtmpmon=serv.mon2int(tmpmon);
	      if(maxref<indtmpmon) 
		maxref=indtmpmon;
	      place[i]=indtmpmon;
	    }
	  else
	    {
	      place[i]=-1;
	    }
	}
    }
  res.nf=(typename pol::coeff_t*)
    MAC_REV_MALLOC<typename pol::coeff_t>
    ((maxref+1)*sizeof(typename pol::coeff_t));
  for(int i=0;i<=maxref;i++)
    res.nf[i]=0;
  res.size=maxref+1;
  for(int i=0;i<p.size;i++)
    {
      if(p.nf[i]!=zero)
	{
	  mon tmpmon;
	  serv.int2mon(i,tmpmon);
	  tmpmon*=varref;
	  if(place[i]==-1)
	    {
	      pol stock;
	      //cout<<"halfred "<<varref*tmpmon<<endl;
	      findcorresppol(tmpmon,dump,stock);
	      //cout<<"en retour "<<invconv<Poly>(stock)<<endl;
	      res*stock.ind.coeff();
	      my_plus(res,stock,p.nf[i]);
	      //Tue Dec  4 17:29:06 MET 2001
	      //MAC_REV_FREE<coeff>(stock.nf,stock.size*sizeof(coeff));
	      //Tue Dec  4 17:29:06 MET 2001
	    }
	  else
	    {
	      res.nf[serv.mon2int(tmpmon)]+=p.nf[i];
	    }
	}
    }
  res.ind=monzero;
  MAC_REV_FREE<int>(place,p.size*sizeof(int));
  return res;
}

template <typename typPk, typename typdump,typename Base, typename typserv>
void ReduceSpol(typPk &S,const typdump & dump,typPk &redspol,const Base &b
		, typserv & serv)
{
  typedef typename typPk::value_type pol;
  typedef typename pol::monom_t mon;
  typedef typename pol::coeff_t coeff;
  std::list<mon> leadmon;
  std::list<typPk> membermon;
  
  //cout<<"en entree de RedSpol S.size "<<S.size()/2<<endl;
  for(typename typPk::iterator iterS=S.begin();iterS!=S.end();iterS++,iterS++)
    {
      typename typPk::iterator iterS2=iterS;
      typename std::list<mon>::iterator itermon=leadmon.begin();
      typename std::list<typPk>::iterator itermemb=membermon.begin();
      mon var1,var2,tmpleadmon;
      iterS2++;
      varmult(iterS,iterS2,var1,var2,b);
      tmpleadmon=iterS->ind*var1;
      for(;itermon!=leadmon.end()&&itermon->rep()!=tmpleadmon.rep();
	  itermon++,itermemb++);
      if(itermon!=leadmon.end())
	{
	  int yes1=1,yes2=1;
	  for(typename typPk::iterator tmpiter=itermemb->begin();
	      tmpiter!=itermemb->end();tmpiter++)
	    {
	      if(tmpiter->ind.rep()==iterS->ind.rep()) yes1=0;
	      if(tmpiter->ind.rep()==iterS2->ind.rep()) yes2=0;
	    }
	  if(yes1) itermemb->push_back(*iterS);
	  if(yes2) itermemb->push_back(*iterS2);
	}
      else
	{
	  typPk verytmp;
	  leadmon.push_back(tmpleadmon);
	  membermon.push_back(verytmp);
	  membermon.back().push_back(*iterS); 
	  membermon.back().push_back(*iterS2);
	}
    }
  //maintenant on a mis en place la structure de Redspol
  //reste plus qu'a calculer les bon et a reduire tout ca!!
  { 
    typename std::list<mon>::iterator itermon=leadmon.begin();
    typename std::list<typPk>::iterator itermemb=membermon.begin();
    for(;itermon!=leadmon.end();itermon++,itermemb++)
      {
	typename typPk::value_type ref;
	typename typPk::iterator tmpiter=itermemb->begin();
	ref=halfred(*itermon,*tmpiter,dump,b,serv);
	//	cout<<"ref.size "<<ref.size<<endl;
	//cout<<"ref en entier"<<endl<<invconv<Poly>(ref)<<endl;
	tmpiter++;
	for(;tmpiter!=itermemb->end();tmpiter++)
	  {
	    typename typPk::value_type redcur;
	    redcur=halfred(*itermon,*tmpiter,dump,b,serv);
	    my_plus(redcur,ref,(coeff)1);
	    if(!Ispolzero(redcur))
	      {
		redspol.push_back(redcur);
	      }
	    else
	      {
		MAC_REV_FREE<coeff>(redcur.nf,redcur.size*sizeof(coeff));
	      }
	  }
	MAC_REV_FREE<coeff>(ref.nf,ref.size*sizeof(coeff));
      }
  }
}

template <typename typPk, typename typdump,typename Base>
void OLD_ReduceSpol(typPk &S,const typdump & dump,typPk &redspol,const Base &b)
{
  using namespace std;
  typedef typename typPk::value_type pol;
  typedef typename pol::monom_t mon;
  typedef typename pol::coeff_t coeff;
  const coeff  zero(0);
  cout<<"en entree de RedSpol S.size "<<S.size()/2<<endl;
  for(typename typPk::iterator iterS=S.begin();iterS!=S.end();iterS++,iterS++)
    {
      typename typPk::iterator iterS2=iterS;
      mon var1,var2;
      typename typPk::value_type res;
      int max=0;
      mon tmpmon;
      iterS2++;
      //cout<<"les deux pol sont dans redspol "<<endl;
       //cout<<invconv<Poly>(*iterS)<<endl;
      //cout<<"et"<<endl;
      //cout<<invconv<Poly>(*iterS2)<<endl;
      varmult(iterS,iterS2,var1,var2,b);
      //cout<<"les var mult "<<var1<<" "<<var2<<endl;
      res.ind=mon(zero);
      for(int i=0;i<iterS->size;i++)
	{
	  //if(!Iszero(iterS->nf[i]))
	  if(iterS->nf[i]!=zero)
	    {
	      int2mon(i,tmpmon);
	      //cout<<"les mon red "<<(var1*tmpmon)<<endl;
	      if(IsinB(var1*tmpmon,b))
		if(max<mon2int(var1*tmpmon)) max=mon2int(var1*tmpmon);
	  }
	}
      for(int i=0;i<iterS2->size;i++)
	{
	  //if(!Iszero(iterS2->nf[i]))
	  if(iterS2->nf[i]!=zero)
	  {
	      int2mon(i,tmpmon);
	      //  cout<<"les mon red "<<(var1*tmpmon)<<endl;
	      if(IsinB(var2*tmpmon,b))
		if(max<mon2int(var2*tmpmon)) max=mon2int(var2*tmpmon);
	    }
	}
      res.nf=(typename typPk::value_type::coeff_t*)
	MAC_REV_MALLOC<typename typPk::value_type::coeff_t>
	((max+1)*sizeof(typename typPk::value_type::coeff_t));
      for(int i=0;i<=max;i++)
	res.nf[i]=0;
      res.size=max+1;
      for(int i=0;i<iterS->size;i++)
	{
	  //if(!Iszero(iterS->nf[i]))
	  if(iterS->nf[i]!=zero)
	  {
	    mon tmpmon;
	    int2mon(i,tmpmon);
	    if(!IsinB(var1*tmpmon,b))
	      {
		pol stock;
		//cout<<"je cheche le monome "<<(var1*tmpmon)<<"  et var1 vaut "
		//   <<var1<<endl;
		findcorresppol(var1*tmpmon,dump,stock);
		//cout<<"stock trouve "<<endl<<invconv<Poly>(stock)<<endl;
		//cout<<"stock.size "<<stock.size<<endl;
		res*stock.ind.coeff();
		my_plus(res,stock,iterS->nf[i]);
	      }
	  else
	    {
	 //      cout<<"je rajoute a "<<var1*tmpmon<<" "<<iterS->nf[i]<<endl;
	      res.nf[mon2int(var1*tmpmon)]+=iterS->nf[i];
	    }
	    // cout<<"a ce tour de boucle res vaut"<<endl<<invconv<Poly>(res)<<endl;
	  }
	}
      //cout<<"entre deux boucle res vaut"<<endl<<invconv<Poly>(res)<<endl;
      for(int i=0;i<iterS2->size;i++)
	{
	  //if (!Iszero(iterS2->nf[i]))
	  if(iterS2->nf[i]!=zero)
	  {
	      mon tmpmon;
	      //cout<<"iterS2->size "<<iterS2->size<<endl;
	      //cout<<" et i "<<i<<endl;
	      int2mon(i,tmpmon);

	      if(!IsinB(var2*tmpmon,b))
		{
		  pol stock;
		  findcorresppol(var2*tmpmon,dump,stock);

		  res*stock.ind.coeff();
		  my_plus(res,stock,(coeff)((coeff)(-1)*iterS2->nf[i]));
		}
	      else
		{

		  res.nf[mon2int(var2*tmpmon)]-=iterS2->nf[i];
		}
	    }
	}
      if(!Ispolzero(res))
	{
	  redspol.push_back(res);
	  //break;//ca c pour pas faire 50 tours 
	  //      //qd on cherche juste a extraire 1 seul sopl non 0
	}
      else
	{
	  MAC_REV_FREE<coeff>(res.nf,res.size*sizeof(coeff));
	}
    }
}

template<typename typPk, typename typserv>
int mindeg(const typPk &l, typserv &serv)
{
  typedef typename typPk::value_type::monom_t mon;
  typedef typename mon::coeff_t coeff;
  int res=-1;
  for(typename typPk::const_iterator iter=l.begin() ;iter!=l.end();iter++)
   {
     int mmax=-1;
     for(int i=0;i<iter->size;i++)
       if(!Iszero(iter->nf[i]))
	 {
	   mon tmpmon;
	   serv.int2mon(i,tmpmon);
	   mmax=(mmax<degree(tmpmon))?degree(tmpmon):mmax;
	 }
     if (iter->ind.coeff()==(coeff)1)
       mmax=(mmax<degree(iter->ind))?degree(iter->ind):mmax;
     if(mmax!=-1)
     {
       if(res==-1) res=mmax;
       res=(mmax>res)?res:mmax;
     }
   }
  return res;
}

template<typename typP,typename typPk,typename typMk,typename Base
,typename typdump, typename typserv>
void Crochetchoix(const typP & P,typPk & Pk, typMk & Mk, typPk & redspol,int k
		    ,typdump & dump, Base &b, typserv & serv)
{
  typedef typename typP::value_type polyalp;
  typedef typename polyalp::monom_t mon;
  typedef typename polyalp::coeff_t coeff;
  typPk res=Crochet(redspol,k),tmpres;
   for(typename typPk::iterator iter=res.begin();iter!=res.end();iter++)
    {
      for(typename typPk::iterator iterredspol=redspol.begin();
	  iterredspol!=redspol.end();iterredspol++)
	if(iter->nf==iterredspol->nf)
	  {
	    redspol.erase(iterredspol);
	    break;
	  }
    }
  for(typename typPk::iterator iter=res.begin();iter!=res.end();iter++)
    {
           if (!Ispolzero(*iter))
	{
	  iter->ind=choice(invconv<polyalp>(*iter));
	  
	   //	  
	  //
	  //
	  //UGLY HACK
	  remiseenforme(*iter);
	  //SALE HACK
	  //
	  //
	  //
	  //
	  //
	  *iter/=iter->ind.coeff();//pour la "nf"
	  iter->ind*=(coeff)1/iter->ind.coeff();//pour l'ind
	  iter->nf[mon2int(iter->ind)]=0;
	  //	  
	  //
	  //
	  //UGLY HACK
	  remiseenforme(*iter);
	  //SALE HACK
	  //
	  //
	  //
	  //
	  //

	  tmpres.push_back(*iter);
	  //on met a 0 le coeff du mon passe en ind
	  //maintenant on a une regle en forme comme il faut reste a:
	  //-reduire les regles deja existantes par rapport acelle ci
	  //-reduire les autres redspol par rapport a celle ci
	  for(typename typPk::iterator iterPk=Pk.begin();iterPk!=Pk.end();iterPk++)
	    if((mon2int(iter->ind)<iterPk->size)&&
	       (iterPk->nf[mon2int(iter->ind)]!=(coeff)0))//test a zero!!!
	      {
		my_plus(*iterPk,*iter,iterPk->nf[mon2int(iter->ind)]);
		iterPk->nf[mon2int(iter->ind)]=0;
		
	      }
		//attention plus(a,b)==a-coeff_de_ind_b_dans_a*b;
	  for(typename typPk::iterator iterredspol=iter;iterredspol!=res.end()
		;iterredspol++)
	    {
	    
	      if(mon2int(iter->ind)<iterredspol->size && 
		 iterredspol->nf[mon2int(iter->ind)]!=(coeff)0)//test a 0 ici
		{
		  my_plus(*iterredspol,*iter,iterredspol->nf[mon2int(iter->ind)]);
		  iterredspol->nf[mon2int(iter->ind)]=0;
		}
	    }
	      //voila c fait 
	  //maintenant on met a jour la Base b.
	  for(typename Base::iterator iterb=b.begin();iterb!=b.end();iterb++)
	    {
	      iterb->refuse=(mon*)MAC_REV_REALLOC<mon>
		(iterb->refuse,(iterb->taille2)*sizeof(mon),
		 (iterb->taille2+1)*sizeof(mon));
	      iterb->refuse[iterb->taille2]=iter->ind;
	      iterb->refuse[iterb->taille2].setcoeff(1);
	      iterb->taille2++;
	    }
	  res.erase(iter--);
	  break;//comme ca on fait pas 50 tours.
	}
    }
  for (typename typPk::iterator iterpk=Pk.begin();iterpk!=Pk.end();iterpk++)
    {
      if (IsinB(iterpk->ind,b))
	{
	  for(typename Base::iterator iterb=b.begin();iterb!=b.end();iterb++)
	    {
	      iterb->refuse=(mon*)MAC_REV_REALLOC<mon>
		(iterb->refuse,(iterb->taille2)*sizeof(mon),
		 (iterb->taille2+1)*sizeof(mon));
	      iterb->refuse[iterb->taille2]=iterpk->ind;
	      iterb->refuse[iterb->taille2].setcoeff(1);
	      iterb->taille2++;
	    }
	}
    }
  my_merge(Pk,tmpres);//les gens dans res\tmpres ne sont pas detruits!!!
  my_merge(redspol,res);
  return;
}
//assomption de Destroy Crochet choix met le "gagnant " a la fin
template<typename typPk>
void Destroyredspol(typPk &redspol,const typPk &Pk)
{
  typename typPk::const_iterator iterpk=--Pk.end(); 
  for(typename typPk::iterator iter=redspol.begin();
      iter!=redspol.end();iter++)
    {
      if(iter->nf!=iterpk->nf)
	MAC_REV_FREE<typename typPk::value_type::coeff_t>(iter->nf
						  ,iter->size
				 *sizeof(typename typPk::value_type::coeff_t));
    }
}

template<typename typP,typename typPk,typename typMk
         ,typename Base,typename typdump, typename typrecall, typename typserv>
void NewCrochetchoix(typP & P,typPk & Pk,typMk & Mk, typPk & redspol
  		     ,int &k,typdump &dump, Base &b
		     , typrecall & recall, typserv & serv)
		     //,typMk &Spoldejavu)
  //template<typename typP,typename typPk,typename typMk,typename Base,typename typdump>
//void NewCrochetchoix(const typP & P,typPk & Pk,typMk & Mk, typPk & redspol
//		     ,int &k,typdump &dump, Base &b)
  //en cours d'ecriutre inoperationnel ,pour le moment
  //comme le Newdestroystore...
{
  typedef typename typP::value_type polyalp;
  typedef typename polyalp::monom_t mon;
  typedef typename polyalp::coeff_t coeff;
  typPk res=Crochet(redspol,k,serv),tmpres;
  if(k==-1) return;
  for(typename typPk::iterator iter=res.begin();iter!=res.end();iter++)
	{
	  for(typename typPk::iterator iterredspol=redspol.begin();
	      iterredspol!=redspol.end();iterredspol++)
	    if(iter->nf==iterredspol->nf)
	      {
		redspol.erase(iterredspol);
		break;
	      }
	}
  for(typename typPk::iterator iter=res.begin();iter!=res.end();iter++)
    {
      if (!Ispolzero(*iter))
	{
	  iter->ind=choice(invconv<polyalp>(*iter,serv));
	  //cout<<"iter->ind.coeff() "<<iter->ind.coeff()<<" Iszero ?"
	  //   <<Iszero(iter->ind.coeff())<<endl;
	  if(degree(iter->ind)<k)
	    {
	      k=degree(iter->ind);
	      iter->ind=mon(0);
	      my_merge(res,tmpres);
	      my_merge(redspol,res);
	      tmpres.erase(tmpres.begin(),tmpres.end());
	      res.erase(res.begin(),res.end());
	      res=Crochet(redspol,k,serv);
	      for(typename typPk::iterator iterres=res.begin()
		    ;iterres!=res.end();iterres++)
		{
		  for(typename typPk::iterator iterredspol=redspol.begin();
		      iterredspol!=redspol.end();iterredspol++)
		    if(iterres->nf==iterredspol->nf)
		      {
			redspol.erase(iterredspol);
			break;
		      }
		}
	      iter=res.begin();
	      iter->ind=choice(invconv<polyalp>(*iter,serv));
	      Dump(Pk,dump);//c pour detruire Pk dans forget
	      //ca ne respecte pas la structure du dump!!!
	      recover(Pk,Mk,dump,k);
	      forget(b,dump,k,recall);
	      if(k==0) return;
	    }
	  
	  //
	  //
	  //UGLY HACK
	  remiseenforme(*iter);
	  //SALE HACK
	  //
	  //
	  //
	  //
	  //
	  //cout<<"iter->ind.coeff() "<<iter->ind.coeff()<<" Iszero ?"
	  //   <<Iszero(iter->ind.coeff())<<endl;
	  *iter/=iter->ind.coeff();//pour la "nf"
	  iter->ind.setcoeff((coeff)1);
	  iter->nf[serv.mon2int(iter->ind)]=0;
	  //	  
	  //
	      //
	  //UGLY HACK
	  remiseenforme(*iter);
	  //SALE HACK
	      //
	  //
	      //
	  //
	  //
	  
	  tmpres.push_back(*iter);
	  //on met a 0 le coeff du mon passe en ind
	  //maintenant on a une regle en forme comme il faut reste a:
	  //-reduire les regles deja existantes par rapport acelle ci
	  //-reduire les autres redspol par rapport a celle ci
	  for(typename typPk::iterator iterPk=Pk.begin();iterPk!=Pk.end();iterPk++)
	    if((serv.mon2int(iter->ind)<iterPk->size)&&
	       (iterPk->nf[serv.mon2int(iter->ind)]!=(coeff)0))//test a zero!!!
	      {
		//cout<<"g trouve un gus qui a un coeff du mon choisi "
		//<<iterPk->nf[mon2int(iter->ind)]<<endl;
		my_plus(*iterPk,*iter,iterPk->nf[serv.mon2int(iter->ind)]);
		iterPk->nf[serv.mon2int(iter->ind)]=0;
		//cout<<"apres plus le coeff vaut "
		//  <<iterPk->nf[mon2int(iter->ind)]<<endl; 
	      }
	  //attention plus(a,b)==a-coeff_de_ind_b_dans_a*b;
	  typename typPk::iterator iterredspol=iter;
	  iterredspol++;
	  for(;iterredspol!=res.end();iterredspol++)
	    {
	      //cout<<"redspol.size() "<<redspol.size()<<endl;
	      //cout<<"iterredspol-ind "<<iterredspol->ind<<" "<<iterredspol->nf<<endl;
	      if(serv.mon2int(iter->ind)<iterredspol->size && 
		 iterredspol->nf[serv.mon2int(iter->ind)]!=(coeff)0)//test a 0 ici
		{
		  my_plus(*iterredspol,*iter,iterredspol->nf[serv.mon2int(iter->ind)]);
		  iterredspol->nf[serv.mon2int(iter->ind)]=0;
		  //  cout<<"coucou je suis ici "<<
		  // iterredspol->nf[mon2int(iter->ind)]<<endl;
		}
	    }
	  //au tour de tmpres...
	  for(iterredspol=tmpres.begin();iterredspol!=tmpres.end();iterredspol++)
	    {
	      //cout<<"redspol.size() "<<redspol.size()<<endl;
	      //cout<<"iterredspol-ind "<<iterredspol->ind<<" "<<iterredspol->nf<<endl;
	      if(serv.mon2int(iter->ind)<iterredspol->size && 
		 iterredspol->nf[serv.mon2int(iter->ind)]!=(coeff)0)//test a 0 ici
		{
		  my_plus(*iterredspol,*iter,iterredspol->nf[serv.mon2int(iter->ind)]);
		  iterredspol->nf[serv.mon2int(iter->ind)]=0;
		  //  cout<<"coucou je suis ici "<<
		  //  iterredspol->nf[mon2int(iter->ind)]<<endl;
		}
	    }
	  //voila c fait 
	  //maintenant on met a jour la Base b.
	  for(typename Base::iterator iterb=b.begin();iterb!=b.end();iterb++)
	    {
	      int tmptaille1=0;
	      mon *tmp=(mon*)MAC_REV_MALLOC<mon>(iterb->taille1*sizeof(mon));
	      for(int i=0;i<iterb->taille1;i++)
		if(!isdivisible(iter->ind,iterb->accept[i],b))
		  tmp[tmptaille1++]=iterb->accept[i];
	      tmp=(mon*)MAC_REV_REALLOC<mon>(tmp,iterb->taille1*sizeof(mon)
					     ,tmptaille1*sizeof(mon));
	      MAC_REV_FREE<mon>(iterb->accept,iterb->taille1*sizeof(mon));
	      iterb->accept=tmp;
	      iterb->taille1=tmptaille1;
	      if(iterb->taille1==0)
		{
		  MAC_REV_FREE<mon>(iterb->refuse,iterb->taille2*sizeof(mon));
		  b.erase(iterb--);
		  continue;
		}
	      iterb->refuse=(mon*)MAC_REV_REALLOC<mon>
		(iterb->refuse,(iterb->taille2)*sizeof(mon),
		 (iterb->taille2+1)*sizeof(mon));
	      iterb->refuse[iterb->taille2]=iter->ind;
	      // cout<<"reffuse rajoute "<<iter->ind<<endl;
	      iterb->refuse[iterb->taille2].setcoeff(1);
	      iterb->taille2++;
	    }
	  res.erase(iter--);
	}
      //break;//comme ca on fait pas 50 tours.
    }

  for (typename typPk::iterator iterpk=Pk.begin();iterpk!=Pk.end();iterpk++)
    {
      //cout<<"iterpk->ind "<<iterpk->ind<<"et Isinb(iterpk-ind,b) "<<IsinB(iterpk->ind,b)<<endl;
      //cout<<"le pol "<<invconv<Poly>(*iterpk)<<endl;
      if (IsinB(iterpk->ind,b))
	{
	  for(typename Base::iterator iterb=b.begin();iterb!=b.end();iterb++)
	    {
	      iterb->refuse=(mon*)MAC_REV_REALLOC<mon>
		(iterb->refuse,(iterb->taille2)*sizeof(mon),
		 (iterb->taille2+1)*sizeof(mon));
	      iterb->refuse[iterb->taille2]=iterpk->ind;
	      iterb->refuse[iterb->taille2].setcoeff(1);
	      iterb->taille2++;
	    }
	}
    }
  //  for(typename typPk::iterator iter=tmpres.begin();iter!=tmpres.end();iter++)
  //  P.push_back(invconv<polyalp>(*iter));
  my_merge(Pk,tmpres);//les gens dans res\tmpres ne sont pas detruits ici!!
  my_merge(redspol,res);
  return;
}

template<typename typPk>
void NewDestroyredspol(typPk &redspol,const typPk &Pk)
{
  //  typename typPk::const_iterator iterpk=--Pk.end(); 
  for(typename typPk::iterator iter=redspol.begin();
      iter!=redspol.end();iter++)
    {
      //    if(iter->nf!=iterpk->nf)
	MAC_REV_FREE<typename typPk::value_type::coeff_t>(iter->nf,iter->size
			 *sizeof(typename typPk::value_type::coeff_t));
    }
}

template<typename typMk>
void Listedejafait(const typMk &Mk,typMk &Spoldejavu)
{
  Spoldejavu.erase(Spoldejavu.begin(),Spoldejavu.end());
  for(typename typMk::const_iterator iter1=Mk.begin();iter1!=Mk.end();
      iter1++)
    for(typename typMk::const_iterator iter2=iter1;iter2!=Mk.end();
      iter2++)
      {
	typename typMk::value_type tmp=Lcm(*iter1,*iter2);
	if (tmp.GetDegree()==iter1->GetDegree()+1)
	  Spoldejavu.push_back(tmp);
      }
}

template<typename typP,typename typPk,typename typdump,typename Base
, template<typename  T> class tmptypmat ,typename typserv>
void algo(typP P,typdump &dump,Base &b,typserv &serv)
{
  // int toto=0;
  typedef std::list<typename typPk::value_type::monom_t> typMk;
  typedef typename typMk::value_type mon;
  typMk Mk;
  typMk Spoldejavu;
  typPk Pk,S;
  //typP recall 
  typPk recall;
  //Base b;
  typedef tmptypmat<typename typP::value_type::coeff_t> typMat;
  typMat Mat;
  int nouveaumon,allpolused=0,maxdeg,k,*pr,*pc;
  //cout<<"avant init"<<endl;
  init_algo<typMat>(P,nouveaumon,maxdeg,k,Pk,Mk,b,dump,serv);
  //cout<<"apres init"<<endl;
  while ((nouveaumon||(k<=maxdeg)) && k)
  {
    //    if (toto>=3) {exit(10);}
    //toto++;
    int killspol;
    //for(typename Base::const_iterator p=b.begin();p!=b.end();p++)
    //  {
    //for(int i=0;i<p->taille1;i++)
    //  {
    //    cout<<"p.accept[i] "<<p->accept[i]<<endl;
    //  }
    //for(int i=0;i<p->taille2;i++)
    //  {
    //    cout<<"p.refuse[i] "<<p->refuse[i]<<endl;
    //  }
    //}
    //    cout<<"poly a la fin de la boulcle de l'algo"<<endl;
#ifdef TRACE_PROG
    cerr<<"["<<Pk.size()<<"] ";
#endif
    //     for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
      //cout<<"les sizes "<<iter->size<<endl;
    // cout<<invconv<typename typP::value_type>(*iter,serv)<<endl;       
    //cout<<"Spolordsup"<<endl;
    //S=Spolordsup(Pk,b,Spoldejavu);
    S=Spolordsup(Pk,b);
    //cout<<"newpkmkmatrixof"<<endl;
    //cout<<"Pk.size() "<<Pk.size()<<endl;
    //killspol=!newPkMkMatrixof(Mat,Pk,P,Mk,k,b,dump,recall,Spoldejavu);
    killspol=!newPkMkMatrixof(Mat,Pk,P,Mk,k,b,dump,recall,serv);
    // killspol=!newPkMkMatrixof(Mat,Pk,P,Mk,k,b,dump);
    //cout<<"ici "<<k<<endl;
    if(k==-1) break;
    if(killspol) S.erase(S.begin(),S.end());
    if (k+1>=maxdeg) allpolused=1;
    if(Mk.size()==0) nouveaumon=0;
    //cout<<"j'en suis a k="<<k<<endl;
    //cout<<"Ici dans algo Mat"<<endl;
    //affdebug(Mat);
    //Solve affecte a Mat la valeur U
    //cout<<"solve"<<endl;
    //for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
    //  cout<<"avant solve les ind "<<iter->ind<<endl;
    //for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
    //  cout<<"avant solve les pol "<<invconv<Poly>(*iter)<<endl;
    //if(k==3) exit(-10);
    //for(typename typMk::iterator iter=Mk.begin();iter!=Mk.end();iter++)
    //  cout<<"monomes dans Mk "<<*iter<<endl;
    if (Mat.ncol!=0)
      {
	//cout<<"dans solve "<<endl;
	Solve(Mat,Pk,&pr,&pc);
	//	cout<<"apres solve :"<<endl;
	//for(int kk=0;kk<Mk.size();kk++)
	//cout<<"permc "<<kk<<" "<<pc[kk]<<endl;
	inverse(pc,Mk.size());
	Dopermu(Mk,pc);
	{
	  //ici on remet les ind a la bonne valuer 
	  //a inclure dans une petite fonction inline apres
	  int j=0;
	  typename typMk::iterator itermon=Mk.begin();
	  typename typPk::iterator iter;
	  for(iter=Pk.begin();
	      itermon!=Mk.end();iter++,itermon++,j++)
	    {
	      if(!Iszero(Mat(j,j)))
		{
		  //		  cout<<"ligne "<<j<<" je mets le monome "<<*itermon<<endl;
		  iter->ind=*itermon*(iter->ind.coeff());
		}
	      else
		{
		  iter->ind=mon(0);
		}
	    }
	  //for(;itermon!=Mk.end();iter++,itermon++)
	  //  iter->ind=mon(0);
	}
	free(pr);
	free(pc);
      }
    
 //appliquer les permutation a MK!!!!!!!!
    // for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
      //  cout<<"apres solve les ind "<<iter->ind<<endl;
    //for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
    // cout<<"apres solve les pol "<<invconv<Poly>(*iter)<<endl;
    //
    //
    //APPLIQUER LES PERMUTYATIONS A MK!!
    //
    //
    //
    //
    if ((unsigned)rank(Mat)==Mk.size())
      //matrice de rang plein
      {
	typPk redspol,secd=secondmembre(Mat,Pk);;
	//secondmembre2(Mat,Pk,secd);
	//typename typPk::iterator iter=Pk.begin();
	//cout<<"matrice de rang plein "<<endl;
	//for(unsigned int i=0;i<Mk.size();i++,iter++);
	//Pk.erase(iter,Pk.end());
//	cout<<"juste avant Dump "<<endl;
//	for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
//		                    cout<< invconv<typename typP::value_type>(*iter,serv)<<endl;
	Dump(Pk,dump);
	//cout<<"Reduce Spol "<<endl;
	ReduceSpol(S,dump,redspol,b,serv);
	//cout<<"secd.size() "<<secd.size()<<endl;
	my_merge(redspol,secd);
	if(redspol.size()==0)
	  {
	    //a voir....    Dump(Pk,dump);
	    k++;
	    continue;
	    //la matrice a rang plein 
	    //ET les Spol\secondmembre de ce niveau se ,reduisent a 0
	  }
	else
	  {
	    //on a des spol\secondmembre qui se reduisent pas a 0
	    //cad un defaut de commuatation
	    nouveaumon=1;
	    //cout<<"redspol.size() "<<redspol.size()<<endl;
	    //cout<<invconv<typename typP::value_type>(redspol.front())<<endl;
	    k=mindeg(redspol,serv);
//	    cout<<"le mindeg ici vaut "<<k<<endl;
//	    if(k==0) {cout<<"g trouve "<<
//		    invconv<typename typP::value_type>(redspol.front(),serv)<<endl;}
	    //cout<<"Pk.size() avant recover "<<Pk.size()<<endl;
	    recover(Pk,Mk,dump,k);
//	    cout<<"juste apres recover"<<endl;
//	    for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
//		cout<< invconv<typename typP::value_type>(*iter,serv)<<endl;
	    //Listedejafait(Mk,Spoldejavu);
	    //cout<<"Pk.size() apres recover "<<Pk.size()<<endl;
	    forget(b,dump,k,recall);
	    //forget(b,dump,k);
	    //cout<<"Pk.size() avant Crochetchoix "<<Pk.size()<<endl;
	    //NewCrochetchoix(P,Pk,Mk,redspol,k,dump,b,recall,Spoldejavu);
	    NewCrochetchoix(P,Pk,Mk,redspol,k,dump,b,recall,serv);
	    //NewCrochetchoix(P,Pk,Mk,redspol,k,dump,b);
	    //cout<<"Pk.size apres Crochetchoix "<<Pk.size()<<" et k "<<k<<endl;
	    NewDestroyredspol(redspol,Pk);
//	    cout<<"c ici que je compress"<<endl;
//	    for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
//		    cout<< invconv<typename typP::value_type>(*iter,serv)<<endl;
	    serv.compress(Pk,dump,b,k);
	    Dump(Pk,dump);
	    //misa jour de B dans crochet choix!!
	    continue;
	  }
      }
    else
      //la matrice n'est pas de rang plein
      {
	//cout<<"matrice de rang pas plein "<<endl;
	typPk secd;
	AddB(Mat,Pk,Mk,dump,b,serv);
	//
	//secondmembre supprime des trucs dans Pk!!
	//
	secd=secondmembre(Mat,Pk);
	rajoute_voisins(Pk,Mk,dump,b,serv);
	//ne selectionne que les non nuls
       if(secd.size()==0)
	 {
	   typPk redspol;
	   //for(int i=Pk.size();i>rank(Mat);i--)
	   //{
	   //  if(Pk.back().size!=0)
	   // MAC_REV_FREE<typename typMat::coeff_t>(Pk.rbegin()->nf
	   //    ,Pk.rbegin()->size*sizeof(typename typMat::coeff_t));
	   //  Pk.pop_back();
	   //}//on vire les 0 avant de dumper
	   //	   AddB(Mat,Pk,Mk,dump,b);
	   Dump(Pk,dump);
	   ReduceSpol(S,dump,redspol,b,serv);
	   if(redspol.size()==0)
	     {
	       // forget(b,dump,k);
	       //AddB(Mat,Pk,Mk,b);
	       //Dump(Pk,dump);
	       //ici on modifie Pk dans AddB 
	       //<=> forget(b,dump,k) AddB(..) Dump(Pk,dump);
	       k++;
	       continue;
	       //la matrice a pas rang plein second membre =0 
	       //ET les Spol de ce niveau se ,reduisent a 0
	     }
	   else
	     {
	       //on a des spol qui se reduisent pas a 0
	       //cad un defaut de commutation 
	       k=mindeg(redspol,serv);
	       recover(Pk,Mk,dump,k);
	       //Listedejafait(Mk,Spoldejavu);
	       forget(b,dump,k,recall);
	       //forget(b,dump,k);
	       //     cout<<"il ya un passage par mat rang pas"
	       //  <<"plein et pol non zero"<<endl;
	       //NewCrochetchoix(P,Pk,Mk,redspol,k,dump,b,recall,Spoldejavu);
	       NewCrochetchoix(P,Pk,Mk,redspol,k,dump,b,recall,serv);
	       //NewCrochetchoix(P,Pk,Mk,redspol,k,dump,b);
	       NewDestroyredspol(redspol,Pk);
  //      cout<<" c la ligne 2164 que je compress"<<endl;
//	       for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++) 
//		cout<< invconv<typename typP::value_type>(*iter,serv)<<endl;
	       serv.compress(Pk,dump,b,k);
	       Dump(Pk,dump); 
	       continue;
	     }
	 }
       else
	 {
	   //on a des pol qui se reduisent pas a 0
	   //cad un defaut de commuatation dans les coins
	   typPk redspol;
	   //for(int i=Pk.size();i>rank(Mat);i--)
	   //  Pk.pop_back();
	   //cout<<"PK. size "<<Pk.size()<<" Mat.nbcol "<<Mat.ncol<<endl;
	   //cout<<"rank(Mat) "<<rank(Mat)<<endl;
	   //int j=0;
	   //cout<<"avant recover et meme avant le dump "<<endl;
	   //for(typename typPk::iterator iter = secd.begin();iter!=secd.end()
	   // 	 ;iter++,j++)
	   // cout<<"pol de secd num "<<j<<endl<<invconv<Poly>(*iter)<<endl;
	   //	   AddB(Mat,Pk,Mk,b);
	   //cout<<"apres ADDB le dump "<<endl;
	   //for(typename typPk::iterator iter = Pk.begin();iter!=Pk.end()
	   //	 ;iter++)
	   // cout<<invconv<Poly>(*iter)<<endl;
	   Dump(Pk,dump);
	   //cout<<"secd.size()" <<secd.size()<<endl;
	   ReduceSpol(S,dump,redspol,b,serv);
	   my_merge(secd,redspol);
	   k=mindeg(secd,serv);
	   recover(Pk,Mk,dump,k);
	   //Listedejafait(Mk,Spoldejavu);
	   //cout<<"apres recover"<<endl;
	   //	   for(typename typPk::iterator iter = Pk.begin();iter!=Pk.end()
	   // 	 ;iter++)
	   //  cout<<invconv<Poly>(*iter)<<endl;
	   //cout<<"les Spol non reduits"<<endl;
	   //for(typename typPk::iterator iter = secd.begin();iter!=secd.end()
	   //	 ;iter++)
	   //  cout<<invconv<Poly>(*iter)<<endl;
	   forget(b,dump,k,recall);
	   
	   //forget(b,dump,k);
	   //cout<<"il ya un passage par mat pas rang plein et Spol non zero"<<endl;
	   //for(typename typPk::iterator iter = secd.begin();iter!=secd.end()
	   //	 ;iter++)
	   // cout<<invconv<Poly>(*iter)<<endl;
	   //NewCrochetchoix(P,Pk,Mk,redspol,k,dump,b,recall,Spoldejavu);
	   NewCrochetchoix(P,Pk,Mk,secd,k,dump,b,recall,serv);
	   //NewCrochetchoix(P,Pk,Mk,secd,k,dump,b);
	   NewDestroyredspol(secd,Pk);
	   //for(typename typPk::iterator iter = Pk.begin();iter!=Pk.end()
	   //	 ;iter++)
	   // cout<<invconv<Poly>(*iter)<<endl;
//	  cout<<" c en ligne 2220 que je compress"<<endl;
//	   for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)                      cout<< invconv<typename typP::value_type>(*iter,serv)<<endl;
	   serv.compress(Pk,dump,b,k);
	   Dump(Pk,dump);
	   
	   continue;
	 }
      
      }
  }//while nouveau mon etc...
  // Pk=recomposePk(dump);
  //return Pk;
  //  return;
  //for(typename Base::const_iterator p=b.begin();p!=b.end();p++)
  // {
  //  for(int i=0;i<p->taille1;i++)
  //{
  //  cout<<"p.accept[i] "<<p->accept[i]<<endl;
  //}
  //  for(int i=0;i<p->taille2;i++)
  //{
  //  cout<<"p.refuse[i] "<<p->refuse[i]<<endl;
  // }
  //
  //  cout<<"sortie d'algo flash"<<endl;
  Mat.destroystore();
  return ;//dump;
  //comme ca on conserve le tri par degre des formes normales et 
  //donc la construction des operateurs de multiplication se 
  //fait plus vite.. :-)

}


__END_NAMESPACE_SYNAPS

