
#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

template <class M> struct my_Dlex 
{
  static bool less (const M &, const M &);
  bool operator() (const M &, const M &) const;
};
template <class M>
bool my_Dlex<M>::operator()(const M & m1, const M & m2) const {
	return less(m1,m2);
}

template <class M>
inline bool my_Dlex<M>::less(const M & m1, const M & m2){
  int dm1=0,dm2=0,firstdiff=0,tmpdeg1,tmpdeg2;
  //int dm1=Degree(m1),dm2=Degree(m2);
  int n1 = lvar(m1.rep()), n2 =lvar(m2.rep());
  int n = std::max(n1,n2);
  if(n1 <0 && n2>0) return false;
  if(n2 <0 && n1>0) return true;
  for(int i=0;i<=n;i++)
    {
      tmpdeg1=m1[i];
      tmpdeg2=m2[i];
      if(tmpdeg1>tmpdeg2 && firstdiff==0) firstdiff=1;
      if(tmpdeg2>tmpdeg1 && firstdiff==0) firstdiff=-1;
      dm1+=tmpdeg1;
      dm2+=tmpdeg2;
    } 
  if (dm1 < dm2) return false;
  else if (dm1 > dm2) return true;
  return (firstdiff==1);
}

__END_NAMESPACE_SYNAPS


#include"pol.cc"
#include"memory.cc"
//#include"harwell.cc"
#include"isdivisible.cc"
#include"IsinB.cc"
#include"Iszero.cc"
#include"LUdecomp.cc"
#include"Solve.cc"
#include"choice.cc"
#include"dump.cc"
#include"placemon.cc"
#include"proj.cc"
#include"rank.cc"
#include"io.cc"
#include"ord.cc"
#include"corealgo.cc"
//#include"LUspecial.cc"
//#include"synaps/linalg/sparse.h"
#include"matmul.cc"
#include"resolve2.cc"


