
#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

typedef __mpf_struct   MPF;
unsigned long MPF_PRECISION;
//----------------------------------------------------------------------
template<> inline shared_object<MPF>::rep::~rep() {mpf_clear(&obj);}
//----------------------------------------------------------------------
template<> inline
void Scl<MPF>::init ( )                   {mpf_init(&rep());}
//------------------- Scl<T> (...) -------------------------------------
template<> inline
Scl<MPF>::Scl<MPF> ( )                    {mpf_init(&rep());}
//----------------------------------------------------------------------
template<> inline 
Scl<MPF>::Scl<MPF>(const Scl<MPF>& rhs) 
{
  COUNT<MPF>('c');
  mpf_init_set(&rep(), &rhs.rep()); 
}
//----------------------------------------------------------------------
template<> inline 
Scl<MPF>& Scl<MPF>::operator =  (const Scl<MPF>& rhs)
{
  COUNT<MPF>('=');
  if (this != &rhs) mpf_set(&rep(), &rhs.rep()); 
  return *this;
}
//----------------------------------------------------------------------
template<> inline
Scl<MPF>::Scl<MPF> (signed long int sl)   {mpf_init_set_si(&rep(),sl);}
//----------------------------------------------------------------------
template<> inline
Scl<MPF>::Scl<MPF> (unsigned long int ul) {mpf_init_set_ui(&rep(),ul);}
//----------------------------------------------------------------------
template<> inline
Scl<MPF>::Scl<MPF> (int si)               {mpf_init_set_si(&rep(), si);}
//----------------------------------------------------------------------
template<> inline
Scl<MPF>::Scl<MPF> (const char *string, unsigned int base)
{
  if (mpf_init_set_str(&rep(), string, base))
    cerr << "Scl<MPF>: The string " << string 
	 << " is not a valid number in base " << base << endl;
}
//----------------------------------------------------------------------
template<> inline Scl<MPF>::~Scl ( )      {}
//----------------------------------------------------------------------
// == ------------------------------------------------------------------
template<> inline 
bool Scl<MPF>::operator == (const Scl<MPF>& rhs) const
{
  return mpf_cmp(&rep(), &rhs.rep()) == 0;
}

template<> inline 
bool Scl<MPF>::operator == (long sl) const {
  return mpf_cmp_si(&rep(), sl) == 0;
}

template<> inline 
bool Scl<MPF>::operator == (int si) const {
  return mpf_cmp_si(&rep(), (long) si) == 0;
}

template<> inline 
bool Scl<MPF>::operator == (unsigned long ul) const
{
  return mpf_cmp_ui(&rep(), ul) == 0;
}

// != ------------------------------------------------------------------
template<> inline 
bool Scl<MPF>::operator != (const Scl<MPF>& rhs) const
{
  return mpf_cmp(&rep(), &rhs.rep()) != 0;
}

template<> inline 
bool Scl<MPF>::operator != (long sl) const {
  return mpf_cmp_si(&rep(), sl) != 0;
}

template<> inline
bool Scl<MPF>::operator != (int si) const {
  return mpf_cmp_si(&rep(), (long) si) != 0;
}

template<> inline 
bool Scl<MPF>::operator != (unsigned long ul) const
{
  return mpf_cmp_ui(&rep(), ul) != 0;
}
// > -------------------------------------------------------------------
template<> inline 
bool Scl<MPF>::operator > (const Scl<MPF>& rhs) const
{
  return mpf_cmp(&rep(), &rhs.rep()) > 0;
}

template<> inline 
bool Scl<MPF>::operator > (long sl) const {
  return mpf_cmp_si(&rep(), sl) > 0;
}

template<> inline 
bool Scl<MPF>::operator > (int si) const {
  return mpf_cmp_si(&rep(), (long) si) > 0;
}

template<> inline 
bool Scl<MPF>::operator > (unsigned long ul) const
{
  return mpf_cmp_ui(&rep(), ul) > 0;
}
// <= --------------------------------------------------------------------
template<> inline 
bool Scl<MPF>::operator >= (const Scl<MPF>& rhs) const
{
  return mpf_cmp(&rep(), &rhs.rep()) >= 0;
}

template<> inline 
bool Scl<MPF>::operator >= (long sl) const {
  return mpf_cmp_si(&rep(), sl) >= 0;
}

template<> inline 
bool Scl<MPF>::operator >= (int si) const
{
  return mpf_cmp_si(&rep(), (long) si) >= 0;
}

template<> inline 
bool Scl<MPF>::operator >= (unsigned long ul) const
{
  return mpf_cmp_ui(&rep(), ul) >= 0;
}

// < -------------------------------------------------------------------
template<> inline 
bool Scl<MPF>::operator < (const Scl<MPF>& rhs) const
{
  return mpf_cmp(&rep(), &rhs.rep()) < 0;
}

template<> inline 
bool Scl<MPF>::operator < (long sl) const {
  return mpf_cmp_si(&rep(), sl) < 0;
}

template<> inline 
bool Scl<MPF>::operator < (int si) const
{
  return mpf_cmp_si(&rep(), (long) si) < 0;
}

template<> inline 
bool Scl<MPF>::operator < (unsigned long ul) const
{
  return mpf_cmp_ui(&rep(), ul) < 0;
}

// <= ------------------------------------------------------------------

template<> inline 
bool Scl<MPF>::operator <= (const Scl<MPF>& rhs) const
{
  return mpf_cmp(&rep(), &rhs.rep()) <= 0;
}

template<> inline 
bool Scl<MPF>::operator <= (long sl) const {
  return mpf_cmp_si(&rep(), sl) <= 0;
}

template<> inline 
bool Scl<MPF>::operator <= (int si) const
{
  return mpf_cmp_si(&rep(), (long) si) <= 0;
}

template<> inline 
bool Scl<MPF>::operator <= (unsigned long ul) const
{
  return mpf_cmp_ui(&rep(), ul) <= 0;
}

// = -------------------------------------------------------------------
template<> inline 
Scl<MPF>&  Scl<MPF>::operator =  (unsigned long ul)
{
  mpf_set_ui(&rep(), ul); return *this;
}

template<> inline 
Scl<MPF>& Scl<MPF>::operator =  (long sl)
{
  mpf_set_si(&rep(), sl);  return *this;
}

template<> inline 
Scl<MPF>& Scl<MPF>::operator = (int ul)
{
  mpf_init_set_si(&(this->rep()), ul);  return *this;
}
// += -------------------------------------------------------------------
template<> inline 
Scl<MPF>& Scl<MPF>::operator += (const Scl<MPF>& rhs)
{
  mpf_add(&rep(), &rep(), &rhs.rep());  return *this;
}

template<> inline 
Scl<MPF>& Scl<MPF>::operator += (unsigned long ul)
{
  mpf_add_ui(&rep(), &rep(), ul); return *this;
}

template<> inline 
Scl<MPF>& Scl<MPF>::operator += (long sl)
{
  if (sl >= 0)
    mpf_add_ui(&rep(), &rep(), (unsigned long) sl);
  else
    mpf_sub_ui(&rep(), &rep(), ((unsigned long) -sl));
  return *this;
}

template<> inline 
Scl<MPF>& Scl<MPF>::operator += (int ul)
{
  *this += Scl<MPF>(ul);  return *this;
}

// -= -------------------------------------------------------------------
template<> inline 
Scl<MPF>& Scl<MPF>::operator -= (const Scl<MPF>& rhs)
{
  mpf_sub(&rep(), &rep(), &rhs.rep()); return *this;
}

template<> inline 
Scl<MPF>& Scl<MPF>::operator -= (unsigned long ul)
{
  mpf_sub_ui(&rep(), &rep(), ul); return *this;
}

template<> inline 
Scl<MPF>& Scl<MPF>::operator -= (long sl)
{
  if (sl >= 0)
    mpf_sub_ui(&rep(), &rep(), (unsigned long) sl);
  else
    mpf_add_ui(&rep(), &rep(), (unsigned long) sl);
  return *this;
}

template<> inline 
Scl<MPF>& Scl<MPF>::operator -= (int ul)
{
  *this -= Scl<MPF>(ul); return *this;
}
// *= -----------------------------------------------------------------
template<> inline 
Scl<MPF>& Scl<MPF>::operator *= (const Scl<MPF>& rhs)
{
  mpf_mul(&rep(), &rep(), &rhs.rep()); return *this;
}
template<> inline 
Scl<MPF>& Scl<MPF>::operator *= (unsigned long ul)
{
  mpf_mul_ui(&rep(), &rep(), ul); return *this;
}
template<> inline 
Scl<MPF>& Scl<MPF>::operator *= (long sl)
{
  if (sl >= 0)
    mpf_mul_ui(&rep(), &rep(), (unsigned long) sl);
  else
    {
      rep()._mp_size = -rep()._mp_size;
      mpf_mul_ui(&rep(), &rep(), ((unsigned long) -sl));
    }
  return *this; 
}
template<> inline 
Scl<MPF>& Scl<MPF>::operator *= (int ul)
{
   if (ul >= 0)
     mpf_mul_ui(&rep(), &rep(), (unsigned long) ul);
   else {
     mpf_mul_ui(&rep(), &rep(), (unsigned long) (-ul));
     mpf_neg(&rep(), &rep());
   }
   return *this;
}
// /= ------------------------------------------------------------------
template<> inline 
Scl<MPF>& Scl<MPF>::operator /= (const Scl<MPF>& rhs)
{
  mpf_div(&rep(), &rep(), &rhs.rep());
  //mpf_divexact(&rep(), &rep(), &rhs.rep()); 
  return *this;
}
template<> inline 
Scl<MPF>& Scl<MPF>::operator /= (unsigned long ul)
{
  mpf_div_ui(&rep(), &rep(), ul); return *this;
}

template<> inline 
Scl<MPF>& Scl<MPF>::operator /= (long sl)
{
  if (sl >= 0)
    mpf_div_ui(&rep(), &rep(), (unsigned long) sl);
  else
    {
      rep()._mp_size = -rep()._mp_size;
      mpf_div_ui(&rep(), &rep(), ((unsigned long) -sl));
    }
  return *this;
}

//======================================================================
// ARITHMETIC OPERATORS
//======================================================================
// Scl<MPF> operator +(const Scl<MPF>& a1, const Scl<MPF>& a2) 
// {
//   Scl<MPF> result;
//   mpf_add(&result.rep(), &a1.rep(), &a2.rep());
//   return result;
// }
// //----------------------------------------------------------------------
// Scl<MPF> operator -(const Scl<MPF>& a1, const Scl<MPF>& a2) 
// {
//   Scl<MPF> result;
//   mpf_sub(&result.rep(), &a1.rep(), &a2.rep());
//   return result;
// }
//----------------------------------------------------------------------
// Scl<MPF> operator *(const Scl<MPF>& a1, const Scl<MPF>& a2) 
// {
//   Scl<MPF> result;
//   mpf_mul(&result.rep(), &a1.rep(), &a2.rep());
//   return result;
// }
//======================================================================
// ASSIGNEMENTS  
//======================================================================
inline void assign(Scl<MPF> & p, 
	    const OP<'+',Scl<MPF>, Scl<MPF> >& M) 
{
  mpf_add(&p.rep(),&M.op1.rep(),&M.op2.rep());
}
//----------------------------------------------------------------------
inline
void assign(Scl<MPF> & p, 
	    const OP<'-',Scl<MPF>, Scl<MPF> >& M) 
{ 
  mpf_sub(&p.rep(),&M.op1.rep(),&M.op2.rep());
}
//----------------------------------------------------------------------
inline void assign(Scl<MPF> & p, 
	    const OP<'*',Scl<MPF>, Scl<MPF> >& M) 
{ 
  mpf_mul(&p.rep(),&M.op1.rep(),&M.op2.rep());
}
//----------------------------------------------------------------------
void assign(Scl<MPF> & p, 
	    const OP<'/',Scl<MPF>,Scl<MPF> >& M) 
{ 
  assert(M.op2!=0);
  mpf_div(&p.rep(),&M.op1.rep(),&M.op2.rep());
}
//======================================================================
/// Prefix ++ operator
template<> inline 
void Scl<MPF>::operator ++ ( )
{
  mpf_add_ui(&rep(), &rep(), 1);
}
//----------------------------------------------------------------------
/// Prefix ++ operator
template<> inline 
void Scl<MPF>::operator -- ( )
{
  mpf_sub_ui(&rep(), &rep(), 1);
}
//======================================================================
inline void convert(Scl<MPF>& n, char *s) 
{
  mpf_init_set_str(&n.rep(), s, 10);
}
//======================================================================
// INPUT OUTPUT
//======================================================================
ostream& operator << (ostream& os, const Scl<MPF>& b)
{
  mpf_out_str(stdout, 10, mpf_get_prec(&b.rep()),&b.rep()); 
  return os;
}
//----------------------------------------------------------------------
istream& operator >> (istream& is, Scl<MPF>& b)
{
  string s;is >> s;
  mpf_init_set_str(&b.rep(),s.c_str(), 10);
  return is;
}
//======================================================================
// SPECIAL FUNCTIONS
//======================================================================
/** Set the default precision for the MPZ numbers.  This is not the precision
of the results of operations on these numbers, because of error propagations.
**/
void Precision(unsigned long l)
{
   mpf_set_default_prec(l);
}
//----------------------------------------------------------------------
/** Set the precision for MPZ.  This precision is not the precision
of the result of operations on this number.
**/
void Precision( Scl<MPF>& b, unsigned long l)
{
  mpf_set_prec(&b.rep(),l);
}
//======================================================================
template<> inline 
void Scl<MPF>::Div2Exp (unsigned long exponent_of_2)
{
  mpf_div_2exp(&rep(), &rep(), exponent_of_2);
}

template<> inline void
Scl<MPF>::abs ( )
{
  if (rep()._mp_size < 0)
    rep()._mp_size = - rep()._mp_size;
}

template<> inline 
Scl<MPF>& Scl<MPF>::negate ( )
{
  rep()._mp_size = - rep()._mp_size; return *this;
}

template<> inline 
void Scl<MPF>::sqrt ( )
{
  mpf_sqrt(&rep(), &rep());
}

//-------------------------- log(...) -----------------------------------
inline size_t log (const Scl<MPF>& b)
{
  return mpf_size(&b.rep());
}
//-------------------------- sign ---------------------------------------------
inline int sign (const Scl<MPF>& b)
{
  if (b.rep()._mp_size == 0)
    return 0;
  else
    return b.rep()._mp_size > 0 ? 1 : -1;
}
//-------------------------- compare (...) ------------------------------------
inline int compare (const Scl<MPF>& b1, const Scl<MPF>& b2)
{
  return mpf_cmp(&b1.rep(), &b2.rep());
}

inline int compare (const Scl<MPF>& b, unsigned long ul)
{
  return mpf_cmp_ui(&b.rep(), ul);
}

inline int compare (const Scl<MPF>& b, long sl)
{
  return mpf_cmp_si(&b.rep(), sl);
}
//----------------------------------------------------------------------

__END_NAMESPACE_SYNAPS

