#ifndef SYNAPS_SHAPE_GAIA_H
#define SYNAPS_SHAPE_GAIA_H

#include <synaps/shape/base/fxv.h>
#include <synaps/shape/base/aabb.h>
#include <synaps/shape/gaia/igraph.h>
#include <synaps/shape/gaia/vcode.h>
#include <synaps/base/chrono.h>
__BEGIN_NAMESPACE_SYNAPS

namespace gaia
{
  typedef Interval<double,3>        interval;
  typedef fxv<double,2>             vector2;
  typedef fxv<double,3>             vector3;
  typedef aabb<double,3>            aabb3;
  typedef fxv<double,4>             vector4;
  typedef igraph   graph_t; 
  typedef vector3                   point3;
  typedef vector2                   point2;
  typedef unsigned short            coord_t;
  typedef short            rid_t;
  struct qnode;
  typedef qnode * qtree; 
  
  
  
  
  // dsearch
  
  inline void fill_quad_box( vcode_t c, aabb3& box, 
			     const vector3& p0, const vector3& p1, 
			     const vector3& p2, const vector3& p3  ) { fill(box,p0,p1,p2,p3); };
}

__END_NAMESPACE_SYNAPS

#endif
