#ifndef SYNAPS_SHAPE_IPARAMETRIC_CURVE_H
#define SYNAPS_SHAPE_IPARAMETRIC_CURVE_H

#include "IShape.h"
#include <synaps/shape/gmv/stream.h>

__BEGIN_NAMESPACE_SYNAPS

struct IParametricCurve : IShape
{
  typedef IShape base_t;
  bool planar;
  virtual void range   ( double & tmin, double & tmax ) const = 0;
  virtual void eval    ( double * p, double t ) const = 0;
  virtual void eval    ( double * p, const double * tvals, int n ) const = 0;
  virtual void sample  ( double * p, double * tvals, int n ) const = 0;
  virtual void split   ( IParametricCurve *& a, IParametricCurve *& b, double t ) const = 0;
  virtual double length( double eps ) const = 0;
};

gmv::stream & operator<<( gmv::stream & o, const IParametricCurve & pc );
IGLGood * mesh( const IParametricCurve * );

__END_NAMESPACE_SYNAPS

#endif
