#ifndef PWMERGE_H
#define PWMERGE_H

__BEGIN_NAMESPACE_SYNAPS

namespace trees
{
  template < class node > 
  node * PWMAlloc( unsigned sz )
  {
    unsigned i,acc;
    i = sz; acc = 0;
    do { acc += i, i = i / 2 + i % 2; } while ( i > 1 );
    return new node[acc+1];
  };
  
  template < class node >
  node *  MakePWMTree( node * c, unsigned sz, node * chunk = 0 )
  {
    bool   dlt = false;
    if ( chunk == 0 ) { dlt=true; chunk = PWMAlloc<node>( sz / 2 + sz % 2 ); };
    unsigned bsz = sz;
    bool     right = true;
    node   * built = c;
    node   * curr  = chunk;
    unsigned i,j;
    do
      { 
	if ( right )
	  {
	    for ( i = 0, j = 0; i < bsz-(bsz%2); i += 2, j++ ) 
	      new(curr+j) node( built+i, built+i+1 );
	    if ( bsz % 2 ) *(curr+j++) = *(built+bsz-1);
	    built = curr;
	    curr += j;
	  }
	else
	  {
	    unsigned nextsz = bsz/2 + bsz % 2;
	    built += bsz-1;
	    curr  += nextsz-1;
	    for  ( i = 0, j = 0; i < bsz-(bsz%2); i+= 2, j++ ) 
	      new(curr-j) node( built-i-1, built-i );
	    if ( bsz%2 ) { *(curr-j) = *(built-bsz+1);  };
	    built = curr-nextsz+1;
	    curr++;
	  };
	right = !right;
	bsz = bsz/2+bsz%2;
      }
    while ( bsz > 1);
    if ( dlt ) delete[] chunk;
    return --curr;
  };
};

__END_NAMESPACE_SYNAPS

#endif
