#ifndef SYNAPS_WBSPLINE_SURFACE_H
#define  SYNAPS_WBSPLINE_SURFACE_H


#include <synaps/shape/interfaces/IBSplineSurface.h>

__BEGIN_NAMESPACE_SYNAPS

namespace BSplineSurface
{
  
};

template<class C, class R, class Point>
void setDefinition( wrapper<R,IBSplineSurface> & s, 
		    int nbpu, int nbpv, 
		    int ordu, int ordv, 
		    const C * uknots, 
		    const C * vknots,
		    const Point * controls )
{
  using namespace BSplineSurface;
  setDefinition( s.rep(), nbpu, nbpv, ordu, ordv, 
		 uknots, vknots, controls );
};

#define IBSplineSurfaceWrap \
  void setDefinition( int nbpu, int nbpv, int ordu, int ordv, \
		      const double * uknots, \
		      const double * vknots, \
		      const double * controls )\
  {\
    ::setDefinition(this->rep(),nbpu,nbpv,ordu,ordv,\
		    uknots,vknots,(fxv<double,3>*)controls);\
  }

template<class R> 
struct wrapper<R,IBSplineSurface> :  wrapper<R,IParametricSurface>
{
  template<class C, class Point>
  void setDefinition( int nbpu, int nbpv, 
		      int ordu, int ordv,
		      const C * uknots, 
		      const C * vknots,
		      const Point * controls )
  {
    ::setDefinition(this->rep(),nbpu,nbpv,ordu,ordv,
		    uknots,vknots,controls);
  };

  IBSplineSurfaceWrap;
};

__END_NAMESPACE_SYNAPS

#include <synaps/shape/wrappers/WParametricSurface.h>
#endif
