#ifndef SYNAPS_SHAPE_WRATIONALCURVE_H
#define SYNAPS_SHAPE_WRATIONALCURVE_H

#include <synaps/shape/interfaces/IRationalCurve.h>

__BEGIN_NAMESPACE_SYNAPS


namespace rational_curve {};

template<class R, class C>
void setRange( wrapper<R,IRationalCurve> & r, const C& a, const C &  b )
{
  using namespace rational_curve;
  setRange( r.rep(), a, b );
};


template<class R>
void setEquations( wrapper<R,IRationalCurve>& r, const char * w, const char * x, const char * y, const char * z )
{
  using namespace rational_curve;
  setEquations(r.rep(),w,x,y,z);
};





template<class R>
struct wrapper<R,IRationalCurve> : wrapper<R,IRationalCurve::base_t>
{
  void setEquations( const char * w, const char * x, const char * y, const char * z )\
  {
    ::setEquations( this->rep(), w, x, y, z );
  };
  void setRange( double a, double b ) { ::setRange(this->rep(), a, b ); };

  //IRationalCurveWrap;
};

__END_NAMESPACE_SYNAPS

#include <synaps/shape/wrappers/WParametricCurve.h>
#endif
