#include <synaps/shape/wrappers/WShapeFactory.h>

__BEGIN_NAMESPACE_SYNAPS



void CShapeFactory::insert( IShape * te )
{
  te->addref();
  this->types[te->iname()].push_back( te );
};

IShape * CShapeFactory::interface( const char * interface_name_, const char * representation_name_  )
{
  typedef shape_factory_map::iterator iterator;
  //  for ( iterator it = types.begin(); it != types.end(); it ++ )
  //    std::cout << it->first << std::endl;
  //  std::cout << interface_name_ << std::endl;
  
  iterator it = types.find(interface_name_);

  if ( it != types.end() && representation_name_ == 0 )
    {
      return (it->second.front())->make();
    }
  if ( it != types.end() )
    for (  std::list< IShape * >::const_iterator il = it->second.begin(); 
	   il != it->second.end();  il ++ )
      if ( strcmp((*il)->repname(),representation_name_) == 0 ) return (*il)->make();
  return 0;

};

std::list<IShape*> CShapeFactory::representations( const char * interface_name_ ) 
{
  typedef shape_factory_map::iterator iterator;
  iterator it = types.find(interface_name_);
  if ( it != types.end() )
    return it->second;
  return std::list<IShape*>();
};


__END_NAMESPACE_SYNAPS
