#include <synaps/shape/gmv/stream.h>
#include <algorithm>

__BEGIN_NAMESPACE_SYNAPS

namespace gmv
{
  void stream::quads( const float * src, unsigned nq, float * colors  )
  {
    if ( !m_binary )
      {
	fprintf(m_fd," { = QUAD # gmvstream::quads\n");
	for ( unsigned i = 0; i < nq; i++  )
	  {
	    fprintf(m_fd,"%f %f %f\n",src[0],src[1],src[2]);
	    src += 3;
	    fprintf(m_fd,"%f %f %f\n",src[0],src[1],src[2]);
	    src += 3;
	    fprintf(m_fd,"%f %f %f\n",src[0],src[1],src[2]);
	    src += 3;
	    fprintf(m_fd,"%f %f %f\n",src[0],src[1],src[2]);
	    src += 3;
	  };
	fprintf(m_fd," }\n");
      }
    else
      {
	if ( !colors )
	  {
	    fprintf(m_fd," { = QUAD BINARY # gmvstream::quads\n");
	    float * data = new float[ nq*4*3+1 ];
	    ((int*)data)[0] = nq;
	    std::copy(src,src+nq*4*3,data+1);
	    swab4((unsigned*)data,nq*4*3+1);
	    fwrite(data,4,nq*4*3+1,m_fd);
	    fprintf(m_fd,"}\n");
	    delete[] data;
	  }
	else
	  {
	    fprintf(m_fd," { = CQUAD BINARY # gmvstream::quads\n");
	    float * data = new float[ nq*4*7+1 ];
	    ((int*)data)[0] = nq;
	    data = data +1;
	    for ( unsigned i = 0; i < 4*nq; i ++ )
	      {
		data[7*i] = src[3*i]; data[7*i+1] = src[3*i+1]; data[7*i+2] = src[3*i+2];
		data[7*i+3] = colors[4*i];
		data[7*i+4] = colors[4*i+1]; 
		data[7*i+5] = colors[4*i+2];
		data[7*i+6] = colors[4*i+3];
	      };
	    data = data - 1;
	    swab4((unsigned*)data,nq*4*7+1);
	    fwrite(data,4,nq*4*7+1,m_fd);
	    fprintf(m_fd,"}\n");
	    delete[] data;
	  };
      };
  };
};
__END_NAMESPACE_SYNAPS
