#include <synaps/shape/gmv/stream.h>

__BEGIN_NAMESPACE_SYNAPS
namespace gmv
{
#ifdef WORDS_BIGENDIAN
  void swab4( unsigned * src, unsigned sz ) {};
  void swab4( unsigned * src, unsigned * dst, unsigned sz ){
    std::copy(src,src+sz,dst);
  };
#else
  void swab4( unsigned * src, unsigned sz )
  {
    for ( unsigned i = 0; i < sz; i ++ )
      {
	unsigned a = src[i];
	unsigned b = a & 0xff;
	a >>= 8;
	b <<= 8;
	b |= a & 0xff;
	a >>= 8;
	b <<= 8;
	b |= a & 0xff;
	a >>= 8;
	b <<= 8;
	b |= a & 0xff;
	src[i] = b;
      };
  };

  void swab4( unsigned * src, unsigned * dst, unsigned sz )
  {
    for ( unsigned i = 0; i < sz; i ++ )
      {
	unsigned a = src[i];
	unsigned b = a & 0xff;
	a >>= 8;
	b <<= 8;
	b |= a & 0xff;
	a >>= 8;
	b <<= 8;
	b |= a & 0xff;
	a >>= 8;
	b <<= 8;
	b |= a & 0xff;
	dst[i] = b;
      };
  };
#endif
};
__END_NAMESPACE_SYNAPS
