/* SISL - SINTEF Spline Library version 4.4.                              */
/* Definition and interrogation of NURBS curves and surface.              */
/* Copyright (C) 1978-2005, SINTEF ICT, Applied Mathematics, Norway.      */

/* This program is free software; you can redistribute it and/or          */
/* modify it under the terms of the GNU General Public License            */
/* as published by the Free Software Foundation version 2 of the License. */

/* This program is distributed in the hope that it will be useful,        */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License      */
/* along with this program; if not, write to the Free Software            */
/* Foundation, Inc.,                                                      */
/* 59 Temple Place - Suite 330,                                           */
/* Boston, MA  02111-1307, USA.                                           */

/* Contact information: e-mail: tor.dokken@sintef.no                      */
/* SINTEF ICT, Department of Applied Mathematics,                         */
/* P.O. Box 124 Blindern,                                                 */
/* 0314 Oslo, Norway.                                                     */

/* SISL commercial licenses are available for:                            */
/* - Building commercial software.                                        */
/* - Building software whose source code you wish to keep private.        */


#include "copyright.h"



#define S1531

#include "sislP.h"

#if defined(SISLNEEDPROTOTYPES)
void s1531(double ea[],int idim,int in1,int in2,double **eb,int *jstat)
#else
void s1531(ea,idim,in1,in2,eb,jstat)
     double ea[];
     int idim;
     int in1;
     int in2;
     double **eb;
     int    *jstat;
#endif
{
  int i,j,jbase;       
  int ki,kj,kk;        
  int idiff;           
  int kpos=0;          
  double *mat=SISL_NULL;    


  mat = newarray(idim*in1*in2, DOUBLE);
  if(mat == SISL_NULL) goto err101;

  i = 0;
  jbase = 0;
  idiff = (in1 - 1) * idim;

  for(ki=0; ki<in1; ki++,jbase+=idim)
  {
      for(kj=0,j=jbase; kj<in2; kj++,j+=idiff)
      {
          for(kk=0; kk<idim; kk++,i++,j++)
          {
	      mat[i] = ea[j];
          }
      }
  }

  (*eb) = mat;

  

  *jstat = 0;
  goto out;


  
 err101: *jstat = -101;
  s6err("s1531",*jstat,kpos);
  goto out;


 out:

  return;
}

