/* SISL - SINTEF Spline Library version 4.4.                              */
/* Definition and interrogation of NURBS curves and surface.              */
/* Copyright (C) 1978-2005, SINTEF ICT, Applied Mathematics, Norway.      */

/* This program is free software; you can redistribute it and/or          */
/* modify it under the terms of the GNU General Public License            */
/* as published by the Free Software Foundation version 2 of the License. */

/* This program is distributed in the hope that it will be useful,        */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License      */
/* along with this program; if not, write to the Free Software            */
/* Foundation, Inc.,                                                      */
/* 59 Temple Place - Suite 330,                                           */
/* Boston, MA  02111-1307, USA.                                           */

/* Contact information: e-mail: tor.dokken@sintef.no                      */
/* SINTEF ICT, Department of Applied Mathematics,                         */
/* P.O. Box 124 Blindern,                                                 */
/* 0314 Oslo, Norway.                                                     */

/* SISL commercial licenses are available for:                            */
/* - Building commercial software.                                        */
/* - Building software whose source code you wish to keep private.        */


#include "copyright.h"



#define S2555

#include "sislP.h"

#if defined(SISLNEEDPROTOTYPES)
void
s2555( double     derive[],
       double    *torsion,
       int       *jstat )
#else
void s2555( derive, torsion, jstat )
     double      derive[];
     double     *torsion;
     int        *jstat;
#endif
{
  int kstat = 0;        
  double crpr[3], a;    


  

  s6crss( derive + 3, derive + 6, crpr );

  a = s6length( crpr, 3, &kstat );

  if ( a != 0.0 )
    {
      *torsion = ( s6scpr( derive + 9, crpr, 3 ) ) / ( a*a ) ;
    }
  else
    {
      *torsion = 0.0;

      goto war002;
    }



 

  *jstat = 0;
  goto out;


  
war002:
  *jstat = 2;
  goto out;


 out:

 return;

}

