/* SISL - SINTEF Spline Library version 4.4.                              */
/* Definition and interrogation of NURBS curves and surface.              */
/* Copyright (C) 1978-2005, SINTEF ICT, Applied Mathematics, Norway.      */

/* This program is free software; you can redistribute it and/or          */
/* modify it under the terms of the GNU General Public License            */
/* as published by the Free Software Foundation version 2 of the License. */

/* This program is distributed in the hope that it will be useful,        */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License      */
/* along with this program; if not, write to the Free Software            */
/* Foundation, Inc.,                                                      */
/* 59 Temple Place - Suite 330,                                           */
/* Boston, MA  02111-1307, USA.                                           */

/* Contact information: e-mail: tor.dokken@sintef.no                      */
/* SINTEF ICT, Department of Applied Mathematics,                         */
/* P.O. Box 124 Blindern,                                                 */
/* 0314 Oslo, Norway.                                                     */

/* SISL commercial licenses are available for:                            */
/* - Building commercial software.                                        */
/* - Building software whose source code you wish to keep private.        */


#include "copyright.h"



#define S6CURVATURE

#include "sislP.h"

#if defined(SISLNEEDPROTOTYPES)
void
      s6curvature(double eder[],int idim,double ecurv[],int *jstat)
#else	 
void s6curvature(eder,idim,ecurv,jstat)
     int idim,*jstat;
     double eder[],ecurv[];
#endif     
{
  int kstat = 0;    
  int ki;           
  double tleng;     
  double tleng2;    
  double tdot;      
  
  

  tleng = s6length(eder+idim,idim,&kstat);
  
  if (kstat == 0)
    {
      

      for (ki=0; ki<idim; ki++) ecurv[ki] = (double)0.0;
      goto warn1;
    }
  else
    {
      tleng2 = tleng*tleng;
      tdot = s6scpr(eder+idim,eder+2*idim,idim);
      
      for (ki=0; ki<idim; ki++)
	ecurv[ki] = (eder[2*idim+ki] - eder[idim*ki]*tdot/tleng2)/tleng2;
    }
  
  *jstat = 0;
  goto out;
  
  warn1 :
    *jstat = 1;
  goto out;
  
  out :
    return;
}

  

