/** \example TopSbdCrv3d.cc **/

#include <synaps/arithm/gmp.h>
#include <synaps/topology/TopSbdCurve3d.h>
#include <synaps/base/io/geomview.h>

int main(int argc, char** argv) 
{
  MPol<double> 
    p1("x^4+y^4+z^4-4*x^2-4*y^2*z^2-4*y^2-4*z^2*x^2-4*z^2-4*x^2*y^2+20.7846*x*y*z+1",
       Variables("x y z")),
    p2("4*x^3-8*x-8*x*z^2-8*x*y^2+20.7846*y*z", Variables("x y z"));

  topology::point_graph<double> g;
  topology::assign(g, p1,p2, TopSbdCurve3d<double>(), 
		   -2.1,2.,-2.15,2.1,-2.1,2.2);

  geomview::ostream os("tmp.off");os<<g;os.view();

}
