/*********************************************************************
*      This file is part of the source code of SYNAPS library          *
*   Author(s): G. Gatellier                                          *
*              B. Mourrain, GALAAD, INRIA                            *
**********************************************************************/
#ifndef synaps_topology_triangle_H
#define synaps_topology_triangle_H
/*********************************************************************/
#include <iostream>
#include <synaps/init.h>
#include <synaps/topology/vertex.h>
/*********************************************************************/
__BEGIN_NAMESPACE_SYNAPS
//--------------------------------------------------------------------
namespace topology 
{

/*! 
  Triangle class that defines a triangle by three vertices.
*/ 
template <class Point>
class triangle 
{

public:

  /*! The vertex of the triangle. */
  typedef topology::vertex< Point > Vertex;
  //typedef Point Vertex;
  
  /*! a,b,c are pointer on Vertex. */
  Vertex *a,*b,*c;

  /*! Default constructor. */
  triangle() {}

  /*! Regular constructor. */
  triangle( Vertex *v1, Vertex *v2, Vertex *v3 ) 
    {
      a = v1;
      b = v2;
      c = v3;
    }

};

} //end namespace topology

/*! Output stream. */
template < class Typ >
std::ostream& operator << ( std::ostream& os, const topology::triangle< Typ >& t ) 
{
  os << "Triangle("   
     << (t.a)->point << " ; " 
     << (t.b)->point << " ; " 
     << (t.c)->point << ")\n";
  return os; 
}
//--------------------------------------------------------------------
__END_NAMESPACE_SYNAPS
/*********************************************************************/
#endif // synaps_topology_triangle_H
