#define USING_NAMESPACE_SYNAPS 1

#include "synaps/linalg/rep1d.h"
#include "synaps/bignum.h"
#include "synaps/upol.h"

#ifdef SYNAPS_WITH_GMP

typedef ZZ C;
typedef UPolDse<ZZ> Pol;

int main (int argc, char **argv)
{
  using std::cout;
  using std::cin;
  using std::endl;

  Pol p0("2*x0^2+x0+1;");
  cout<<"p0 ="<<p0<<endl;

  C u1[]={3,0,-1,5,7};
  Pol p1(u1,u1+5);
  cout<<"p1 ="<<p1<<endl;
  cout<<prem(p1,p0)<<endl;

}
#else
#include <iostream>
int main()
{
  std::cout <<"  Gmp is not connected"<<std::endl;
  return(77);
}
#endif //SYNAPS_WITH_GMP
