/** \example SturmSolver.cc **/
#include <synaps/upol.h>
#include <synaps/arithm/QQ.h>
#include <synaps/usolve/sturm/IslSturm.h>
int main()
{
  using std::cout;  using std::endl;

  UPolDse<QQ> P("2*x^7+3*x^6+2*x^5+x^4-x^3-2*x^2-3*x+1");
  cout <<"Testing: "<<P<<endl;
  //| Testing: 2*x^7+3*x^6+2*x^5+1*x^4-1*x^3-2*x^2-3*x+1

  cout <<solve(P,IslSturm<QQ>())<<endl;
  //| [ -5/2,0 ], [ 0,5/8 ], [ 5/8,5/4 ]

  cout <<solve(P,IslSturm<QQ>(),0,1)<<endl;
  //| [ 0,1/2 ], [ 1/2,1 ]

}
