#ifndef _SYNAPS_usolve_SlvInterval_H
#define _SYNAPS_usolve_SlvInterval_H

#include <vector>
#include <synaps/init.h>
#include <synaps/base/Seq.h>
#include <synaps/arithm/Interval.h>

__BEGIN_NAMESPACE_SYNAPS



template < class X >
struct SlvInterval
{
  typedef SlvInterval  self_t;
  X eps; 
  SlvInterval():eps(1.e-6) {}  
  SlvInterval(const X& e):eps(e) {}
  SlvInterval(const self_t& mth): eps(mth.eps) {}
};

template<class T, class U>
bool contains(const Interval<T>& I, const U& x)
{
  return(I.inf()<= x && I.sup() >= x);
}

template<class T>
Interval<T> pop(std::vector<Interval<T> >& LI)
{
  Interval<T> I= LI[LI.size()-1];
  //  LI.resize(LI.size()-1);
  return I;
}


template<class UPOL, class C, class X> inline
Seq< Interval<C> > 
solve( const UPOL & f,
       const Interval<C>& U,
       const SlvInterval<X>& mth)
{
  typedef Interval<C> interval_t;
  std::vector<interval_t> li;
  interval_t I,J;
  Seq<interval_t> res;
  li.push_back(U);
  C m;
  while(li.size())
    {
      I= pop(li);
      J = f(I);
      std::cout <<  J<<std::endl;
      if(contains(J,0))
	if(width(I)< mth.eps)
	  res.push_back(I);
        else
	  {
	    m=median(I);
	    li.push_back(interval_t(I.inf(),m));
	    li.push_back(interval_t(m,I.sup()));
	  }
    }
  return res;
}

__END_NAMESPACE_SYNAPS
#endif // _SYNAPS_SOLVE_STURM_H_

