
#ifndef SYNAPS_AK_FUNCTION_OBJECTS_4_H
#define SYNAPS_AK_FUNCTION_OBJECTS_4_H

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

namespace SYNAPSi 
{
  
  template < class AK >
  struct  Construct_polynomial_2_2 
  {
    typedef typename AK::RT    RT;
    typedef typename AK::FT    FT;
    typedef typename AK::Polynomial_2_2   Poly_2;
  

    Poly_2
    operator() ( const RT& c5, const RT& c4, const RT& c3,
		 const RT& c2, const RT& c1, const RT& c0)
    {
      return Poly_2(c5, c4, c3, c2, c1, c0);  
    }
      
    Poly_2
    operator() ( const FT& c5, const FT& c4, const FT& c3,
		 const FT& c2, const FT& c1, const FT& c0)
    {
      return Poly_2(c5, c4, c3, c2, c1, c0);  
    }

  };
    

  template < class AK >
  struct Solve
  {
    typedef typename AK::Polynomial_2_2   Poly_2;
    typedef typename AK::Solver_type      Solver_type;
  
  

    template < typename OutputIterator >
    OutputIterator
    operator() ( const Poly_2& c1,
		 const Poly_2& c2,
		 OutputIterator res)
    {
      std::cout << "SAK::Solve" << std::endl;
      return solve(c1, c2, res, Solver_type());
    }

  };


  template < class AK >
  struct Sign_at 
  {
    template typename AK::Polynomial_2_2    Poly_2;
    template typename AK::Root_of_4         RO_t;
  

    int
    operator() ( const Poly_2& f, const RO_t& rx, const RO_t& ry)
    {
      return SYNAPS::ALGEBRAIC::sign_at(f, rx, ry);
    }
  
  };
  
 
} // namespace SYNAPSi

__END_NAMESPACE_SYNAPS

#endif // SYNAPS_AK_FUNCTION_OBJECTS_4_H
