// Copyright (c) 2003  INRIA Sophia-Antipolis (France) and
//                     Department of Informatics and Telecommunications
//                     Univeristy of Athens (Greece).
// All rights reserved.
//
// Authors : Elias P. TSIGARIDAS <et@di.uoa.gr>

// Partially supported by INRIA's project "CALAMATA", a
// bilateral collaboration with National Kapodistrian University of
// Athens.
// Partially supported by the IST Programme of the EU as a Shared-cost
// RTD (FET Open) Project under Contract No  IST-2000-26473
// (ECG - Effective Computational Geometry for Curves and Surfaces)


#ifndef SYNAPS_ARITHM_ALGERBAIC_COMPARISON_AUTO_RESULT_LENGTH_6_H
#define SYNAPS_ARITHM_ALGERBAIC_COMPARISON_AUTO_RESULT_LENGTH_6_H


#include <synaps/usolve/algebraic/Algebraic_config.h>

__ALGEBRAIC_BEGIN_NAMESPACE



class Result_length_6 {
	typedef std::map<int, int> MapResult;
	typedef std::map<int, int>::iterator MapResult_iter;
	static bool initialize;
	static void set_default_values();
	static MapResult map_S0_p2q2;
	static MapResult map_S0_p1q1;
	static MapResult map_S1_p2q2;
	static MapResult map_S1_p1q1;
	static MapResult map_S2_p2q2;
	static MapResult map_S2_p1q1;
	static MapResult map_S3_p2q2;
	static MapResult map_S3_p1q1;
	static MapResult map_S4_p2q2;
	static MapResult map_S4_p1q1;
	static MapResult map_S5;

	public:

	inline Result_length_6()
	{
		if (!initialize) {
			initialize = true;
			set_default_values();
		}
	}

Comparison_result
		on_S0_p2q2(int where);

Comparison_result
		on_S0_p1q1(int where);

Comparison_result
		on_S1_p2q2(int where);

Comparison_result
		on_S1_p1q1(int where);

Comparison_result
		on_S2_p2q2(int where);

Comparison_result
		on_S2_p1q1(int where);

Comparison_result
		on_S3_p2q2(int where);

Comparison_result
		on_S3_p1q1(int where);

Comparison_result
		on_S4_p2q2(int where);

Comparison_result
		on_S4_p1q1(int where);

Comparison_result
		on_S5(int where);

}; // end of Class


__ALGEBRAIC_END_NAMESPACE

#endif // SYNAPS_ARITHM_ALGERBAIC_COMPARISON_AUTO_RESULT_LENGTH_6_H

