
#ifndef __SYNAPS_SOLVE_STURM_SOLVE_SMALL_H__
#define __SYNAPS_SOLVE_STURM_SOLVE_SMALL_H__


#include <synaps/init.h>
#include <synaps/usolve/algebraic/Algebraic_config.h>
//#include <synaps/usolve.h>
#include <synaps/usolve/sturm/construct_root_of.h>
#include <synaps/usolve/sturm/common.h>
#include <synaps/usolve/sturm/solve_d2.h>
#include <synaps/usolve/sturm/solve_d3.h>
#include <synaps/usolve/sturm/solve_d4.h>


__ALGEBRAIC_BEGIN_NAMESPACE

template < class K,
	   class OutputIterator >
OutputIterator
solve_small_degree( const typename K::Poly& p, unsigned mult, OutputIterator sol, K)
{
    assert(UPOLDAR::degree(p) <= 4);

    typedef typename K::RT            RT;
    typedef typename K::Poly          Poly;
    typedef typename K::RO_t          RO_t;
    
    Poly f(p);
    
    convert_to_pos_lcoeff(f);
    int dg = UPOLDAR::degree(f);

    if (dg < 1) return sol;

    if (dg == 1) {
	*sol++ = construct_root_of( f, mult, K());
	return sol;
    }

    if (dg == 2) {
	solve_adjust_poly_2(f, sol, mult, K());
	return sol;
    }

    if (dg == 3) {
      solve_adjust_poly_3(f, sol, mult, K());
      return sol;
    }

    //if (dg == 4) 
    solve_adjust_poly_4(f, sol, mult, K());
    return sol;
}

__ALGEBRAIC_END_NAMESPACE
#endif //  __SYNAPS_SOLVE_STURM_SOLVE_SMALL_H__
