// Copyright (c) 2003  INRIA Sophia-Antipolis (France) and
//                     Department of Informatics and Telecommunications
//                     University of Athens (Greece).
// All rights reserved.
//
// Authors : Elias P. TSIGARIDAS <et@di.uoa.gr>

// Partially supported by INRIA's project "CALAMATA", a
// bilateral collaboration with National Kapodistrian University of
// Athens.
// Partially supported by the IST Programme of the EU as a Shared-cost
// RTD (FET Open) Project under Contract No  IST-2000-26473
// (ECG - Effective Computational Geometry for Curves and Surfaces)


#ifndef  SYNAPS_ARITHM_ALGEBRAIC_COMPARISON_AUTO_RESULT_DEG_LENGTH_4_HH
#define  SYNAPS_ARITHM_ALGEBRAIC_COMPARISON_AUTO_RESULT_DEG_LENGTH_4_HH


#include <synaps/usolve/algebraic/comparison/auto/Result_length_4.h>

__ALGEBRAIC_BEGIN_NAMESPACE


class Result_deg_4 {
	static const int  degResult[256];
	public:
	static int on_end(const int& i);
}; // end of Class


const int Result_deg_4::degResult[256] = {
		0, -1, -1,  0,  0, -1,  1,  0,  0,  1, -1,  0,  0,  1,  1,  0,
		0, -1,  1,  0,  0, -1,  1,  0,  0, -1,  1,  0,  0,  1,  1,  0,
		0,  1, -1,  0,  0,  1, -1,  0,  0,  1, -1,  0,  0,  1,  1,  0,
		0, -1, -1,  0,  0,  1, -1,  0,  0, -1,  1,  0,  0,  1,  1,  0,
		0, -1,  0,  0,  0, -1,  1,  0,  0,  0,  0,  0,  0,  0,  1,  0,
		0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,
		0,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,
		0,  0, -1,  0,  0,  1, -1,  0,  0,  0,  0,  0,  0,  1,  0,  0,
		0,  0, -1,  0,  0,  0,  0,  0,  0,  1, -1,  0,  0,  1,  0,  0,
		0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,
		0,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,
		0, -1,  0,  0,  0,  0,  0,  0,  0, -1,  1,  0,  0,  0,  1,  0,
		0, -1, -1,  0,  0, -1,  1,  0,  0,  1, -1,  0,  0,  1,  1,  0,
		0, -1, -1,  0,  0,  1, -1,  0,  0,  1, -1,  0,  0,  1, -1,  0,
		0, -1, -1,  0,  0, -1,  1,  0,  0, -1,  1,  0,  0, -1,  1,  0,
		0, -1, -1,  0,  0,  1, -1,  0,  0, -1,  1,  0,  0,  1,  1,  0
	};
int Result_deg_4::on_end(const int& i)
{
	return degResult[i];
}

__ALGEBRAIC_END_NAMESPACE

#endif //  SYNAPS_ARITHM_ALGEBRAIC_COMPARISON_AUTO_RESULT_DEG_LENGTH_4_HH

