#include <synaps/init.h>
#include <synaps/usolve/Algebraic.h>

#ifdef SYNAPS_WITH_GMP


using std::cout;
using std::cin;
using std::endl;

typedef ZZ NT;
typedef Algebraic<NT> SOLVER;

typedef SOLVER::RT         RT;
typedef SOLVER::FT         FT;

typedef SOLVER::Poly       Poly;

typedef SOLVER::RO_t       RO_t;

#endif //SYNAPS_WITH_GMP

int main()
{
  using namespace ::SYNAPS;
#ifdef SYNAPS_WITH_GMP

  Poly f("x^9-29*x^8+349*x^7-2309*x^6+9307*x^5-23771*x^4+38511*x^3-38151*x^2+20952*x-4860 ");
  cout << "f = " << f << endl;

  Seq<RO_t> sol= solve(f, SOLVER());
  
  for (unsigned i=0; i< sol.size(); ++i) {
    cout << "(" << i << ") " << sol[i] << endl;
  }
  
  return 0;
#else
  
  std::cout <<"  Gmp is not connected"<<std::endl;
  return(77);
  
#endif //SYNAPS_WITH_GMP

}
