#include <iostream>
#include <synaps/upol.h>
#include <synaps/usolve/bezier/SlvBzStd.h>
#include <synaps/usolve/bezier/SlvBzFst.h>

int main()
{
  using std::cout;
  using std::cin;
  using std::endl;

  UPolDse<double> P("2*x0^7+3*x0^6+2*x0^5+1*x0^4-1*x0^3-2*x0^2-3*x0+1");
  cout <<"Testing: "<<P<<endl;
  cout <<solve(P,SlvBzStd<double,double>(1e-6))<<endl;
  //  assert(solve(P,SlvBzStd<double,double>(1e-6)).size()==3);
  //  assert(solve(P,-2.,2.,Exclusion(1e-6)).size()==3);

  assert(RootOf(P,SlvBzFst<double>(1e-6))<0.33);
  //  assert(compare(RootOf(P,2,Algebraic<double>(1e-6)),1.)==1);
  //  cout<<solve(P,Sturm<double>())<<endl;;

  UPolDse<double> Q("x0^4-2*x0^3+x0^2");
  cout <<"Testing: "<<Q<<endl;
  std::cout<<solve(Q,SlvBzStd<double,double>(1e-6))<<std::endl;
  assert(solve(Q,SlvBzStd<double,double>(1e-6)).size()==2);
  assert(RootOf(Q,SlvBzFst<double>(1e-6))==0);

  UPolDse<double> Q0("x0^2-3*x0+2");
  cout <<"Testing: "<<Q0<<endl;
  std::cout<<solve(Q0,SlvBzStd<double,double>(1e-6))<<std::endl;
  assert(solve(Q0,SlvBzStd<double,double>(1e-6)).size()==2);
}

